/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : AD1.C
**     Project   : pp
**     Processor : 56F801FA80
**     Beantype  : ADC
**     Version   : Bean 01.376, Driver 01.16, CPU db: 2.71.091
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 08/04/2008, 07:53 a.m.
**     Abstract  :
**         This device "ADC" implements an A/D converter,
**         its control methods and interrupt/event handling procedure.
**     Settings  :
**         AD control register         : ADCA_ADCR1  [3712]
**         AD control register         : ADCA_ADCR2  [3713]
**         AD control register         : ADCA_ADZCC  [3714]
**         AD control register         : ADCA_ADLST1 [3715]
**         AD control register         : ADCA_ADLST2 [3716]
**         AD control register         : ADCA_ADSDIS [3717]
**         AD control register         : ADCA_ADSTAT [3718]
**         AD control register         : ADCA_ADLSTAT [3719]
**         AD control register         : ADCA_ADZCSTAT [3720]
**         AD control register         : ADCA_ADLLMT0 [3729]
**         AD control register         : ADCA_ADLLMT1 [3730]
**         AD control register         : ADCA_ADLLMT2 [3731]
**         AD control register         : ADCA_ADLLMT3 [3732]
**         AD control register         : ADCA_ADLLMT4 [3733]
**         AD control register         : ADCA_ADLLMT5 [3734]
**         AD control register         : ADCA_ADLLMT6 [3735]
**         AD control register         : ADCA_ADLLMT7 [3736]
**         AD control register         : ADCA_ADHLMT0 [3737]
**         AD control register         : ADCA_ADHLMT1 [3738]
**         AD control register         : ADCA_ADHLMT2 [3739]
**         AD control register         : ADCA_ADHLMT3 [3740]
**         AD control register         : ADCA_ADHLMT4 [3741]
**         AD control register         : ADCA_ADHLMT5 [3742]
**         AD control register         : ADCA_ADHLMT6 [3743]
**         AD control register         : ADCA_ADHLMT7 [3744]
**         AD control register         : ADCA_ADOFS0 [3745]
**         AD control register         : ADCA_ADOFS1 [3746]
**         AD control register         : ADCA_ADOFS2 [3747]
**         AD control register         : ADCA_ADOFS3 [3748]
**         AD control register         : ADCA_ADOFS4 [3749]
**         AD control register         : ADCA_ADOFS5 [3750]
**         AD control register         : ADCA_ADOFS6 [3751]
**         AD control register         : ADCA_ADOFS7 [3752]
**         AD result register          : ADCAres7    [3728]
**         AD result register          : ADCAres7    [3728]
**         AD result register          : ADCAres7    [3728]
**         User handling procedure     : not specified
**         Number of conversions       : 1
**         AD resolution               : 12-bit
**
**         Input pins
**
**
**
**
**         Initialization:
**              Conversion             : Enabled
**              Event                  : Enabled
**         High speed mode
**             Prescaler               : divide-by-8
**     Contents  :
**         Measure        - byte AD1_Measure(bool WaitForResult);
**         GetValue16     - byte AD1_GetValue16(word *Values);
**         GetChanValue16 - byte AD1_GetChanValue16(byte Channel,word *Value);
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE AD1. */

#include "AD1.h"

#define IDLE            0              /* IDLE state           */
#define MEASURE         1              /* MESURE state         */
#define CONTINUOUS      2              /* CONTINUOUS state     */
#define SINGLE          3              /* SINGLE state         */

static bool OutFlg;                    /* Measurement finish flag */
volatile byte AD1_ModeFlg;             /* Current state of device */
static word AD1_OutV[3];               /* Sum of measured values */

/*
** ===================================================================
**     Method      :  MainMeasure (bean ADC)
**
**     Description :
**         The method performs A/D conversion(s). The method is called 
**         automatically as a part of measure methods or the HWEnDi 
**         method.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void MainMeasure(void)
{
  if (getRegBit(ADCA_ADSTAT,EOSI)) {   /* Is a scan cycle completed? */
    setRegBits(ADCA_ADSTAT,2048);      /* Clear EOSI flag */
    AD1_OutV[0] = getReg(ADCA_ADRSLT0); /* Save measured values to the output buffer */
    AD1_OutV[1] = getReg(ADCA_ADRSLT1); /* Save measured values to the output buffer */
    AD1_OutV[2] = getReg(ADCA_ADRSLT2); /* Save measured values to the output buffer */
    OutFlg = TRUE;                     /* Measured values are available */
    AD1_ModeFlg = IDLE;                /* Set the bean to the idle mode */
  }
}

/*
** ===================================================================
**     Method      :  HWEnDi (bean ADC)
**
**     Description :
**         Enables or disables the peripheral(s) associated with the bean.
**         The method is called automatically as a part of Enable, 
**         Disable and Init methods and several internal methods.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void HWEnDi(void)
{
  if (AD1_ModeFlg) {                   /* Launch measurement? */
    OutFlg = FALSE;                    /* Measured values are available */
    setRegBits(ADCA_ADSTAT,2048);      /* Clear flag */
    clrRegBit(ADCA_ADCR1,STOP);        /* Normal operation mode */
    setRegBit(ADCA_ADCR1,START);       /* Launching of conversion */
  }
  else {
    setRegBit(ADCA_ADCR1,STOP);        /* Stop command issued */
  }
}

/*
** ===================================================================
**     Method      :  AD1_Measure (bean ADC)
**
**     Description :
**         This method performs one measurement on all channels that
**         are set in the bean inspector. (Note: If the <number of
**         conversions> is more than one the conversion of A/D
**         channels is performed specified number of times.)
**     Parameters  :
**         NAME            - DESCRIPTION
**         WaitForResult   - Wait for a result
**                           of a conversion. If <interrupt service>
**                           is disabled, A/D peripheral doesn't
**                           support measuring all channels at once
**                           or Autoscan mode property isn't enabled
**                           and at the same time the <number of
**                           channel> is greater than 1, then the
**                           WaitForResult parameter is ignored and
**                           the method waits for each result every
**                           time. If the <interrupt service> is
**                           disabled and a <number of conversions>
**                           is greater than 1, the parameter is
**                           ignored and the method also waits for
**                           each result every time.
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_DISABLED - Device is disabled
**                           ERR_BUSY - A conversion is already
**                           running
** ===================================================================
*/
byte AD1_Measure(bool WaitForResult)
{
  if (AD1_ModeFlg != IDLE)             /* Is the device in running mode? */
    return ERR_BUSY;                   /* If yes then error */
  AD1_ModeFlg = MEASURE;               /* Set state of device to the measure mode */
  HWEnDi();                            /* Enable the device */
  if (WaitForResult)                   /* Is WaitForResult TRUE? */
    while (AD1_ModeFlg == MEASURE)     /* Calling MainMeasure while IDLE state occured */
      MainMeasure();                   /* A/D converter handler */
  return ERR_OK;                       /* OK */
}

/*
** ===================================================================
**     Method      :  AD1_GetValue16 (bean ADC)
**
**     Description :
**         This method returns the last measured values of all
**         channels justified to the left. Compared with <GetValue>
**         method this method returns more accurate result if the
**         <number of conversions> is greater than 1 and <AD
**         resolution> is less than 16 bits. In addition, the user
**         code dependency on <AD resolution> is eliminated.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * Values          - Pointer to the array that
**                           contains the measured data.
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_NOTAVAIL - Requested value not
**                           available
**                           ERR_OVERRUN - External trigger overrun
**                           flag was detected after the last value(s)
**                           was obtained (for example by GetValue).
**                           This error may not be supported on some
**                           CPUs (see generated code).
** ===================================================================
*/
byte AD1_GetValue16(word *Values)
{
  if (AD1_ModeFlg != IDLE)             /* Is the device in any measure mode? */
    MainMeasure();                     /* Call A/D converter handler */
  if (!OutFlg)                         /* Is measured value(s) available? */
    return ERR_NOTAVAIL;               /* If no then error */
  *Values++ = (AD1_OutV[0] + 0) << 1;  /* Store value from output to user buffer */
  *Values++ = (AD1_OutV[1] + 0) << 1;  /* Store value from output to user buffer */
  *Values = (AD1_OutV[2] + 0) << 1;    /* Store value from output to user buffer */
  return ERR_OK;                       /* OK */
}

/*
** ===================================================================
**     Method      :  AD1_GetChanValue16 (bean ADC)
**
**     Description :
**         This method returns the last measured value of the
**         required channel justified to the left. Compared with
**         <GetChanValue> method this method returns more accurate
**         result if the <number of conversions> is greater than 1
**         and <AD resolution> is less than 16 bits. In addition,
**         the user code dependency on <AD resolution> is eliminated.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Channel         - Channel number. If only one
**                           channel in the bean is set then this
**                           parameter is ignored.
**       * Value           - Pointer to the measured value.
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_NOTAVAIL - Requested value not
**                           available
**                           ERR_RANGE - Parameter "Channel" out of
**                           range
**                           ERR_OVERRUN - External trigger overrun
**                           flag was detected after the last value(s)
**                           was obtained (for example by GetValue).
**                           This error may not be supported on some
**                           CPUs (see generated code).
** ===================================================================
*/
byte AD1_GetChanValue16(byte Channel,word *Value)
{
  if (Channel >= 3)                    /* Is channel number out of range? */
    return ERR_RANGE;                  /* If yes then error */
  if (AD1_ModeFlg != IDLE)             /* Is the device in any measure mode? */
    MainMeasure();                     /* Call A/D converter handler */
  if (!OutFlg)                         /* Is measured value(s) available? */
    return ERR_NOTAVAIL;               /* If no then error */
  *Value = (AD1_OutV[Channel] + 0) << 1; /* Store value from output to user buffer */
  return ERR_OK;                       /* OK */
}

/*
** ===================================================================
**     Method      :  AD1_Init (bean ADC)
**
**     Description :
**         Initializes the associated peripheral(s) and the beans 
**         internal variables. The method is called automatically as a 
**         part of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void AD1_Init(void)
{
  OutFlg = FALSE;                      /* No measured value */
  AD1_ModeFlg = IDLE;                  /* Device isn't running */
  /* ADCA_ADCR1: ??=0,STOP=1,START=0,SYNC=0,EOSIE=0,ZCIE=0,LLMTIE=0,HLMTIE=0,CHNCFG=0,??=0,SMODE=0 */
  setReg(ADCA_ADCR1,16384);            /* Set control register 1 */
  /* ADCA_ADOFS0: ??=0,OFFSET=0,??=0,??=0,??=0 */
  setReg(ADCA_ADOFS0,0);               /* Set offset reg. 0 */
  /* ADCA_ADOFS1: ??=0,OFFSET=0,??=0,??=0,??=0 */
  setReg(ADCA_ADOFS1,0);               /* Set offset reg. 1 */
  /* ADCA_ADOFS2: ??=0,OFFSET=0,??=0,??=0,??=0 */
  setReg(ADCA_ADOFS2,0);               /* Set offset reg. 2 */
  /* ADCA_ADHLMT0: ??=0,HLMT=4095,??=0,??=0,??=0 */
  setReg(ADCA_ADHLMT0,32760);          /* Set high limit reg. 0 */
  /* ADCA_ADHLMT1: ??=0,HLMT=4095,??=0,??=0,??=0 */
  setReg(ADCA_ADHLMT1,32760);          /* Set high limit reg. 1 */
  /* ADCA_ADHLMT2: ??=0,HLMT=4095,??=0,??=0,??=0 */
  setReg(ADCA_ADHLMT2,32760);          /* Set high limit reg. 2 */
  /* ADCA_ADLLMT0: ??=0,LLMT=0,??=0,??=0,??=0 */
  setReg(ADCA_ADLLMT0,0);              /* Set low limit reg. 0 */
  /* ADCA_ADLLMT1: ??=0,LLMT=0,??=0,??=0,??=0 */
  setReg(ADCA_ADLLMT1,0);              /* Set low limit reg. 1 */
  /* ADCA_ADLLMT2: ??=0,LLMT=0,??=0,??=0,??=0 */
  setReg(ADCA_ADLLMT2,0);              /* Set low limit reg. 2 */
  /* ADCA_ADZCSTAT: ??=1,??=1,??=1,??=1,??=1,??=1,??=1,??=1,ZCS7=1,ZCS6=1,ZCS5=1,ZCS4=1,ZCS3=1,ZCS2=1,ZCS1=1,ZCS0=1 */
  setReg(ADCA_ADZCSTAT,65535);         /* Clear zero crossing status flags */
  /* ADCA_ADLSTAT: HLS7=1,HLS6=1,HLS5=1,HLS4=1,HLS3=1,HLS2=1,HLS1=1,HLS0=1,LLS7=1,LLS6=1,LLS5=1,LLS4=1,LLS3=1,LLS2=1,LLS1=1,LLS0=1 */
  setReg(ADCA_ADLSTAT,65535);          /* Clear high and low limit status */
  /* ADCA_ADSTAT: CIP=0,??=0,??=0,??=0,EOSI=1,ZCI=0,LLMTI=0,HLMTI=0,RDY7=0,RDY6=0,RDY5=0,RDY4=0,RDY3=0,RDY2=0,RDY1=0,RDY0=0 */
  setReg(ADCA_ADSTAT,2048);            /* Clear EOSI flag */
  /* ADCA_ADSDIS: TEST=0,??=0,??=0,??=0,??=0,??=0,??=0,DS7=1,DS6=1,DS5=1,DS4=1,DS3=1,DS2=0,DS1=0,DS0=0 */
  setReg(ADCA_ADSDIS,248);             /* Enable/disable of samples */
  /* ADCA_ADLST1: ??=0,SAMPLE3=0,??=0,SAMPLE2=2,??=0,SAMPLE1=1,??=0,SAMPLE0=0 */
  setReg(ADCA_ADLST1,528);             /* Set ADC channel list reg. */
  /* ADCA_ADZCC: ZCE7=0,ZCE6=0,ZCE5=0,ZCE4=0,ZCE3=0,ZCE2=0,ZCE1=0,ZCE0=0 */
  setReg(ADCA_ADZCC,0);                /* Set zero crossing control reg. */
  /* ADCA_ADCR2: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,DIV=3 */
  setReg(ADCA_ADCR2,3);                /* Set prescaler */
}

/* END AD1. */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98.03 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
