/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : AD1.H
**     Project   : pp
**     Processor : 56F801FA80
**     Beantype  : ADC
**     Version   : Bean 01.376, Driver 01.16, CPU db: 2.71.091
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 08/04/2008, 07:53 a.m.
**     Abstract  :
**         This device "ADC" implements an A/D converter,
**         its control methods and interrupt/event handling procedure.
**     Settings  :
**         AD control register         : ADCA_ADCR1  [3712]
**         AD control register         : ADCA_ADCR2  [3713]
**         AD control register         : ADCA_ADZCC  [3714]
**         AD control register         : ADCA_ADLST1 [3715]
**         AD control register         : ADCA_ADLST2 [3716]
**         AD control register         : ADCA_ADSDIS [3717]
**         AD control register         : ADCA_ADSTAT [3718]
**         AD control register         : ADCA_ADLSTAT [3719]
**         AD control register         : ADCA_ADZCSTAT [3720]
**         AD control register         : ADCA_ADLLMT0 [3729]
**         AD control register         : ADCA_ADLLMT1 [3730]
**         AD control register         : ADCA_ADLLMT2 [3731]
**         AD control register         : ADCA_ADLLMT3 [3732]
**         AD control register         : ADCA_ADLLMT4 [3733]
**         AD control register         : ADCA_ADLLMT5 [3734]
**         AD control register         : ADCA_ADLLMT6 [3735]
**         AD control register         : ADCA_ADLLMT7 [3736]
**         AD control register         : ADCA_ADHLMT0 [3737]
**         AD control register         : ADCA_ADHLMT1 [3738]
**         AD control register         : ADCA_ADHLMT2 [3739]
**         AD control register         : ADCA_ADHLMT3 [3740]
**         AD control register         : ADCA_ADHLMT4 [3741]
**         AD control register         : ADCA_ADHLMT5 [3742]
**         AD control register         : ADCA_ADHLMT6 [3743]
**         AD control register         : ADCA_ADHLMT7 [3744]
**         AD control register         : ADCA_ADOFS0 [3745]
**         AD control register         : ADCA_ADOFS1 [3746]
**         AD control register         : ADCA_ADOFS2 [3747]
**         AD control register         : ADCA_ADOFS3 [3748]
**         AD control register         : ADCA_ADOFS4 [3749]
**         AD control register         : ADCA_ADOFS5 [3750]
**         AD control register         : ADCA_ADOFS6 [3751]
**         AD control register         : ADCA_ADOFS7 [3752]
**         AD result register          : ADCAres7    [3728]
**         AD result register          : ADCAres7    [3728]
**         AD result register          : ADCAres7    [3728]
**         User handling procedure     : not specified
**         Number of conversions       : 1
**         AD resolution               : 12-bit
**
**         Input pins
**
**
**
**
**         Initialization:
**              Conversion             : Enabled
**              Event                  : Enabled
**         High speed mode
**             Prescaler               : divide-by-8
**     Contents  :
**         Measure        - byte AD1_Measure(bool WaitForResult);
**         GetValue16     - byte AD1_GetValue16(word *Values);
**         GetChanValue16 - byte AD1_GetChanValue16(byte Channel,word *Value);
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE AD1. */

#ifndef __AD1
#define __AD1

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "PE_Timer.h"

/* MODULE AD1. */



byte AD1_Measure(bool WaitForResult);
/*
** ===================================================================
**     Method      :  AD1_Measure (bean ADC)
**
**     Description :
**         This method performs one measurement on all channels that
**         are set in the bean inspector. (Note: If the <number of
**         conversions> is more than one the conversion of A/D
**         channels is performed specified number of times.)
**     Parameters  :
**         NAME            - DESCRIPTION
**         WaitForResult   - Wait for a result
**                           of a conversion. If <interrupt service>
**                           is disabled, A/D peripheral doesn't
**                           support measuring all channels at once
**                           or Autoscan mode property isn't enabled
**                           and at the same time the <number of
**                           channel> is greater than 1, then the
**                           WaitForResult parameter is ignored and
**                           the method waits for each result every
**                           time. If the <interrupt service> is
**                           disabled and a <number of conversions>
**                           is greater than 1, the parameter is
**                           ignored and the method also waits for
**                           each result every time.
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_DISABLED - Device is disabled
**                           ERR_BUSY - A conversion is already
**                           running
** ===================================================================
*/

byte AD1_GetValue16(word *Values);
/*
** ===================================================================
**     Method      :  AD1_GetValue16 (bean ADC)
**
**     Description :
**         This method returns the last measured values of all
**         channels justified to the left. Compared with <GetValue>
**         method this method returns more accurate result if the
**         <number of conversions> is greater than 1 and <AD
**         resolution> is less than 16 bits. In addition, the user
**         code dependency on <AD resolution> is eliminated.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * Values          - Pointer to the array that
**                           contains the measured data.
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_NOTAVAIL - Requested value not
**                           available
**                           ERR_OVERRUN - External trigger overrun
**                           flag was detected after the last value(s)
**                           was obtained (for example by GetValue).
**                           This error may not be supported on some
**                           CPUs (see generated code).
** ===================================================================
*/

byte AD1_GetChanValue16(byte Channel,word *Value);
/*
** ===================================================================
**     Method      :  AD1_GetChanValue16 (bean ADC)
**
**     Description :
**         This method returns the last measured value of the
**         required channel justified to the left. Compared with
**         <GetChanValue> method this method returns more accurate
**         result if the <number of conversions> is greater than 1
**         and <AD resolution> is less than 16 bits. In addition,
**         the user code dependency on <AD resolution> is eliminated.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Channel         - Channel number. If only one
**                           channel in the bean is set then this
**                           parameter is ignored.
**       * Value           - Pointer to the measured value.
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_NOTAVAIL - Requested value not
**                           available
**                           ERR_RANGE - Parameter "Channel" out of
**                           range
**                           ERR_OVERRUN - External trigger overrun
**                           flag was detected after the last value(s)
**                           was obtained (for example by GetValue).
**                           This error may not be supported on some
**                           CPUs (see generated code).
** ===================================================================
*/

void AD1_Init(void);
/*
** ===================================================================
**     Method      :  AD1_Init (bean ADC)
**
**     Description :
**         Initializes the associated peripheral(s) and the beans 
**         internal variables. The method is called automatically as a 
**         part of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

/* END AD1. */

#endif /* ifndef __AD1 */
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98.03 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
