/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : Cpu.C
**     Project   : pp
**     Processor : 56F801FA80
**     Beantype  : 56F801
**     Version   : Bean 01.021, Driver 01.32, CPU db: 2.71.091
**     Datasheet : DSP56F801/D Rev. 11.0, DSP56F801-7UM/D - Rev. 4.0
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 08/04/2008, 07:53 a.m.
**     Abstract  :
**
**     Settings  :
**
**     Contents  :
**         EnableInt   - void Cpu_EnableInt(void);
**         DisableInt  - void Cpu_DisableInt(void);
**         SetWaitMode - void Cpu_SetWaitMode(void);
**         SetStopMode - void Cpu_SetStopMode(void);
**         SetDataMode - void Cpu_SetDataMode(byte Mode);
**
**     (c) Freescale Semiconductor
**     2004 All Rights Reserved
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE Cpu. */
#include "SM1.h"
#include "SS.h"
#include "ADEInt.h"
#include "LCD_RS.h"
#include "LCD_E.h"
#include "LCD_D4.h"
#include "LCD_D5.h"
#include "LCD_D6.h"
#include "LCD_D7.h"
#include "SDA.h"
#include "SCL.h"
#include "AS1.h"
#include "AD1.h"
#include "TI1.h"
#include "TI2.h"
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "PE_Timer.h"
#include "Events.h"
#include "Cpu.h"


/* Global variables */
volatile word SR_lock=0;               /* Lock */
volatile word SR_reg;                  /* Current value of the SR register */

/*Definition of global shadow variables*/
word Shadow_GPIO_A_DR;

/*
** ===================================================================
**     Method      :  Cpu_Interrupt (bean 56F801)
**
**     Description :
**         The method services unhandled interrupt vectors.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
#pragma interrupt
void Cpu_Interrupt(void)
{
  asm(DEBUG);                          /* Halt the core and placing it in the debug processing state */
}

/*
** ===================================================================
**     Method      :  Cpu_DisableInt (bean 56F801)
**
**     Description :
**         Disables all maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_DisableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_EnableInt (bean 56F801)
**
**     Description :
**         Enables all maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_EnableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_SetStopMode (bean 56F801)
**
**     Description :
**         Sets low power mode - Stop mode.
**         For more information about the stop mode see this CPU
**         documentation.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_SetStopMode(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_SetWaitMode (bean 56F801)
**
**     Description :
**         Sets low power mode - Wait mode.
**         For more information about the wait mode see this CPU
**         documentation.
**         Release from wait mode: Reset or interrupt
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_SetWaitMode(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_SetDataMode (bean 56F801)
**
**     Description :
**         Sets the Data memory map to use either internal &
**         external resources or external resources only.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Mode            - Data memory access mode.
**                           Possible modes:
**                           INT_EXT_MODE - use internal & external
**                           resources
**                           EXT_MODE - use external resources only
**     Returns     : Nothing
** ===================================================================
*/
void Cpu_SetDataMode(byte Mode)
{
  if (Mode == INT_EXT_MODE) {
    asm { bfclr  #0x0008,OMR }         /* Set internal and external data memory mode */
  } else {
    asm { bfset  #0x0008,OMR }         /* Set external data memory mode */
  }
}

/*
** ===================================================================
**     Method      :  _EntryPoint (bean 56F801)
**
**     Description :
**         Initializes the whole system like timing and so on. At the end 
**         of this function, the C startup is invoked to initialize stack,
**         memory areas and so on.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
extern void init_56800_(void);         /* Forward declaration of external startup function declared in startup file */

/*** !!! Here you can place your own code using property "User data declarations" on the build options tab. !!! ***/

void _EntryPoint(void)
{

  /*** !!! Here you can place your own code before PE initialization using property "User code before PE initialization" on the build options tab. !!! ***/

  /*** ### 56F801FA80 "Cpu" init code ... ***/
  /*** PE initialization code after reset ***/
  /* System clock initialization */
  setRegBit(DFIU_CNTL, IFREN);         /* Set IFREN bit of DFIU to read info flash */
  setReg(IOSCTL, *(word *)0x103F);     /* Set the trim osc freq with factory programmed value */
  clrRegBit(DFIU_CNTL, IFREN);         /* Clear IFREN bit for normal data flash */
  clrRegBit(PLLCR, PRECS);             /* Select an internal clock source for the CPU core */
  while(getRegBit(PLLSR, PRECS)){}     /* Wait for clock stabilization */
  setReg(PLLCR, (PLLCR_LCKON_MASK | PLLCR_ZSRC0_MASK)); /* Enable PLL, LCKON and select clock source from prescaler */
  /* CLKOSR: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,CLKOSEL=0 */
  setReg16(CLKOSR, 0);                 /* CLKO = ZCLOCK */ 
  /* PLLDB: LORTP=2,PLLCOD=0,PLLCID=1,??=0,PLLDB=39 */
  setReg16(PLLDB, 8487);               /* Set the clock prescalers */ 
  while(!getRegBit(PLLSR, LCK0)){}     /* Wait for PLL lock */
  setReg(PLLCR, (PLLCR_LCKON_MASK | PLLCR_ZSRC1_MASK)); /* Select clock source from postscaler */
  /*** End of PE initialization code after reset ***/

  /*** !!! Here you can place your own code after PE initialization using property "User code after PE initialization" on the build options tab. !!! ***/

  asm(JMP init_56800_);                /* Jump to C startup code */
}

/*
** ===================================================================
**     Method      :  PE_low_level_init (bean 56F801)
**
**     Description :
**         Initializes beans and provides common register initialization. 
**         The method is called automatically as a part of the 
**         application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void PE_low_level_init(void)
{
  /* Common initialization of the CPU registers */
  /* GPIO_B_PER: PE&=~128,PE|=115 */
  clrSetReg16Bits(GPIO_B_PER, 128, 115); 
  /* GPIO_B_IENR: IEN&=~128 */
  clrReg16Bits(GPIO_B_IENR, 128);       
  /* GPIO_B_IAR: IA&=~128 */
  clrReg16Bits(GPIO_B_IAR, 128);        
  /* GPIO_B_IESR: IES&=~128 */
  clrReg16Bits(GPIO_B_IESR, 128);       
  /* GPIO_B_DR: D|=128 */
  setReg16Bits(GPIO_B_DR, 128);         
  /* GPIO_B_DDR: DD|=128 */
  setReg16Bits(GPIO_B_DDR, 128);        
  /* IPR: CH3=1,CH4=1,IAL1=1,IAINV=0 */
  clrSetReg16Bits(IPR, 1, 6148);        
  /* GPIO_A_IENR: IEN&=~3 */
  clrReg16Bits(GPIO_A_IENR, 3);         
  /* GPIO_A_IAR: IA&=~3 */
  clrReg16Bits(GPIO_A_IAR, 3);          
  /* GPIO_A_IESR: IES&=~3 */
  clrReg16Bits(GPIO_A_IESR, 3);         
  /* GPIO_A_PUR: PU|=2 */
  setReg16Bits(GPIO_A_PUR, 2);          
  /* GPIO_A_DR: D&=~1,D|=2 */
  clrSetReg16Bits(GPIO_A_DR, 1, 2);     
  /* GPIO_A_DDR: DD&=~2,DD|=1 */
  clrSetReg16Bits(GPIO_A_DDR, 2, 1);    
  /* GPIO_A_PER: PE&=~3 */
  clrReg16Bits(GPIO_A_PER, 3);          
  /* GPR13: PLR53=4,PLR52=4 */
  clrSetReg16Bits(GPR13, 51, 68);       
  /* GPR12: PLR51=4,PLR50=4 */
  clrSetReg16Bits(GPR12, 13056, 17408); 
  /* GPR8: PLR35=4,PLR34=5 */
  clrSetReg16Bits(GPR8, 12800, 17664);  
  /* ### SynchroMaster "SM1" init code ... */
  SM1_Init();
  /* ### External interrupt "ADEInt" init code ... */
  setRegBit(IPR,IAL0);                 /* Enable interrupt "INT_IRQA" */
  /* ### Programable pulse generation "LCD_RS" init code ... */
  LCD_RS_Init();
  /* ### Programable pulse generation "LCD_E" init code ... */
  LCD_E_Init();
  /* ### Programable pulse generation "LCD_D4" init code ... */
  LCD_D4_Init();
  /* ### Programable pulse generation "LCD_D5" init code ... */
  LCD_D5_Init();
  /* ### Programable pulse generation "LCD_D6" init code ... */
  LCD_D6_Init();
  /* ### Programable pulse generation "LCD_D7" init code ... */
  LCD_D7_Init();
  /* ### BitIO "SDA" init code ... */
  Shadow_GPIO_A_DR |= (word)2;         /* Initialize shadow variable */
  /* ### Asynchro serial "AS1" init code ... */
  AS1_Init();
  /* ### ADC "AD1" init code ... */
  AD1_Init();
  /* ### TimerInt "TI1" init code ... */
  TI1_Init();
  /* ### TimerInt "TI2" init code ... */
  TI2_Init();
 /* Common peripheral initialization - ENABLE */
  /* PWMA_PMOUT: OUTCTL=0 */
  clrReg16Bits(PWMA_PMOUT, 16128);      
  /* PWMA_PMCCR: MSK=0 */
  clrReg16Bits(PWMA_PMCCR, 16128);      
  setRegBit(PWMA_PMOUT,PAD_EN);        /* Enable output */
  setRegBits(PWMA_PMCTL,3);            /* Run counter */
  __EI();                              /* Enable interrupts */
}

/* END Cpu. */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98.03 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
