/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : LCD_D5.H
**     Project   : pp
**     Processor : 56F801FA80
**     Beantype  : PWM
**     Version   : Bean 02.112, Driver 01.15, CPU db: 2.71.091
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 08/04/2008, 07:53 a.m.
**     Abstract  :
**         This bean implements a pulse-width modulation generator
**         that generates signal with variable duty and fixed cycle. 
**     Settings  :
**         Used output pin             : 
**             ----------------------------------------------------
**                Number (on package)  |    Name
**             ----------------------------------------------------
**                       44            |  PWMA1
**             ----------------------------------------------------
**
**         Timer name                  : PWM_A [15-bit] 
**         Counter                     : PWMA_PMCNT [3588]
**         Mode register               : PWMA_PMCTL [3584]
**         Run register                : PWMA_PMCTL [3584]
**         Prescaler                   : PWMA_PMCTL [3584]
**         Compare register            : PWMA_PWMVAL1 [3591]
**         Flip-flop register          : PWMA_PMCFG [3599]
**
**         User handling procedure     : not specified
**
**
**         Initialization:
**              Output level           : high
**              Timer                  : Enabled
**              Event                  : Enabled
**         High speed mode
**             Prescaler               : divide-by-1
**             Clock                   : 10000000 Hz
**           Initial value of            period     pulse width
**             Xtal ticks              : 16000      8000
**             microseconds            : 2000       1000
**             milliseconds            : 2          1
**             seconds (real)          : 0.0020000  0.0010000
**
**     Contents  :
**         SetRatio16 - byte LCD_D5_SetRatio16(word Ratio);
**         SetDutyUS  - byte LCD_D5_SetDutyUS(word Time);
**         SetDutyMS  - byte LCD_D5_SetDutyMS(word Time);
**         SetValue   - byte LCD_D5_SetValue(void);
**         ClrValue   - byte LCD_D5_ClrValue(void);
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

#ifndef __LCD_D5
#define __LCD_D5

/* MODULE LCD_D5. */

#include "Cpu.h"



byte LCD_D5_SetRatio16(word Ratio);
/*
** ===================================================================
**     Method      :  LCD_D5_SetRatio16 (bean PWM)
**
**     Description :
**         This method sets a new duty-cycle ratio.
**     Parameters  :
**         NAME       - DESCRIPTION
**         Ratio      - Ratio is expressed as an 16-bit unsigned integer
**                      number. 0 - 65535 value is proportional
**                      to ratio 0 - 100%
**         Note: Calculated duty depends on the timer possibilities
**               and on the selected period.
**     Returns     :
**         ---        - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
** ===================================================================
*/

byte LCD_D5_SetDutyUS(word Time);
/*
** ===================================================================
**     Method      :  LCD_D5_SetDutyUS (bean PWM)
**
**     Description :
**         This method sets the new duty value of the output signal.
**         The duty is expressed in microseconds as a 16-bit
**         unsigned integer number.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Time            - Duty to set [in microseconds]
**                      (0 to 2000 us in high speed mode)
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_MATH - Overflow during evaluation
**                           ERR_RANGE - Parameter out of range
** ===================================================================
*/

byte LCD_D5_SetDutyMS(word Time);
/*
** ===================================================================
**     Method      :  LCD_D5_SetDutyMS (bean PWM)
**
**     Description :
**         This method sets the new duty value of the output signal.
**         The duty is expressed in milliseconds as a 16-bit
**         unsigned integer number.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Time            - Duty to set [in milliseconds]
**                      (0 to 2 ms in high speed mode)
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_MATH - Overflow during evaluation
**                           ERR_RANGE - Parameter out of range
** ===================================================================
*/

byte LCD_D5_SetValue(void);
/*
** ===================================================================
**     Method      :  LCD_D5_SetValue (bean PWM)
**
**     Description :
**         This method sets (sets to "1" = "High") timer flip-flop
**         output signal level. It allow user to directly set the
**         output pin value (=flip-flop state), and can set the
**         signal polarity. This method only works when the timer is
**         disabled (Disable) otherwise it returns the error code.
**         "ClrValue" and "SetValue" methods are used for setting
**         the initial state.
**     Parameters  : None
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_ENABLED - Bean is enabled. Bean must
**                           be disabled (see "Disable method")
** ===================================================================
*/

byte LCD_D5_ClrValue(void);
/*
** ===================================================================
**     Method      :  LCD_D5_ClrValue (bean PWM)
**
**     Description :
**         This method clears (sets to "0" = "Low") timer flip-flop
**         output signal level. It allow user to directly set the
**         output pin value (=flip-flop state), and can set the
**         signal polarity. This method only works when the timer is
**         disabled (Disable) otherwise it returns the error code.
**         "ClrValue" and "SetValue" methods are used for setting
**         the initial state.
**     Parameters  : None
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_ENABLED - Bean is enabled. Bean must
**                           be disabled (see "Disable method")
** ===================================================================
*/

void LCD_D5_Init(void);
/*
** ===================================================================
**     Method      :  LCD_D5_Init (bean PWM)
**
**     Description :
**         Initializes the associated peripheral(s) and the beans 
**         internal variables. The method is called automatically as a 
**         part of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/


/* END LCD_D5. */

#endif /* ifndef __LCD_D5 */
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98.03 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
