/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : PE_Timer.C
**     Project   : pp
**     Processor : 56F801FA80
**     Beantype  : PE_Timer
**     Version   : Driver 01.02
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 08/04/2008, 07:53 a.m.
**     Abstract  :
**         This module "PE_Timer" implements internal methods and definitions
**         used by beans working with timers.
**     Settings  :
**     Contents  :
**         No public methods
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE PE_Timer. */

#include "PE_Timer.h"

typedef dword UINT32;

typedef union {
  UINT32 val;
  struct {
    word lo16,hi16;
  } s;
} OP_UINT32;

typedef struct {
  word dummy;
  word midlo16,midhi16;
} M_UINT32;

typedef struct {
  UINT32 lo32, hi32;
} UINT64;

typedef union {
  UINT64 val;
  M_UINT32 m; 
} OP_UINT64;

/*
** ===================================================================
**     Method      :  PE_Timer_LngMul (bean PE_Timer)
**
**     Description :
**         32bits number x 32bits number -> 64bits number. The method is 
**         called automatically as a part of several internal methods.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void PE_Timer_LngMul(dword va1, dword va2, dlong *var)
{
  OP_UINT32 *va = (OP_UINT32*)&va1;
  OP_UINT32 *vb = (OP_UINT32*)&va2;
  OP_UINT64 *vr = (OP_UINT64*)var;
  
  vr->val.hi32 = 0UL;
  vr->val.lo32 = ((UINT32)va->s.lo16)*((UINT32)vb->s.lo16);
  {
    OP_UINT32 tmp;
    OP_UINT32 register tmpx;
    
    tmp.val = ((UINT32)va->s.lo16)*((UINT32)vb->s.hi16);

    tmpx.s.lo16 = vr->m.midlo16;
    tmpx.s.hi16 = vr->m.midhi16;
    tmpx.val += (UINT32)tmp.s.lo16;
    vr->m.midlo16 = tmpx.s.lo16;
    vr->m.midhi16 = tmpx.s.hi16;

    vr->val.hi32 += (UINT32)tmp.s.hi16;
  }
  {
    OP_UINT32 tmp;
    OP_UINT32 register tmpx;
    
    tmp.val = ((UINT32)va->s.hi16)*((UINT32)vb->s.lo16);

    tmpx.s.lo16 = vr->m.midlo16;
    tmpx.s.hi16 = vr->m.midhi16;
    tmpx.val += (UINT32)tmp.s.lo16;
    vr->m.midlo16 = tmpx.s.lo16;
    vr->m.midhi16 = tmpx.s.hi16;

    vr->val.hi32 += (UINT32)tmp.s.hi16;
  }
  vr->val.hi32 += ((UINT32)va->s.hi16)*((UINT32)vb->s.hi16);
}

/*
** ===================================================================
**     Method      :  PE_Timer_LngHi2 (bean PE_Timer)
**
**     Description :
**         64bits number / 2^24 -> 16bits number. The method is called 
**         automatically as a part of several internal methods.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
bool PE_Timer_LngHi2(dword Low, dword High, word *Out) 
{
  if (High == 0) {
    if ((Low & 0x8000) != 0) {
      if ((Low >> 16) < 0xFFFF) {
        *Out = ((word)(Low >> 16))+1;
        return FALSE;
      }  
    }
    else {
      *Out = (word)(Low >> 16);
      return FALSE;
    }
  }
  *Out = (word)(Low >> 16);
  return TRUE;
}

/*
** ===================================================================
**     Method      :  PE_Timer_LngHi3 (bean PE_Timer)
**
**     Description :
**         64bits number / 2^32 -> 16bits number. The method is called 
**         automatically as a part of several internal methods.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
bool PE_Timer_LngHi3(dword Low, dword High, word *Out) 
{
  if ((High >> 8) == 0) {
    if ((Low & 0x800000UL) != 0) {
      if (((Low >> 24) | (High << 8)) < 0xFFFF) {
        *Out = ((word)((Low >> 24) | (High << 8)))+1;
        return FALSE;
      } 
    }   
    else { 
      *Out = (word)((Low >> 24) | (High << 8));
      return FALSE;
    }
  }
  *Out = (word)((Low >> 24) | (High << 8));
  return TRUE;
}

/* END PE_Timer. */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98.03 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
