/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : SCL.H
**     Project   : pp
**     Processor : 56F801FA80
**     Beantype  : BitIO
**     Version   : Bean 02.068, Driver 01.16, CPU db: 2.71.091
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 08/04/2008, 07:53 a.m.
**     Abstract  :
**         This bean "BitIO" implements an one-bit input/output.
**         It uses one bit/pin of a port.
**         Note: This bean is set to work in Output direction only.
**         Methods of this bean are mostly implemented as a macros
**         (if supported by target language and compiler).
**     Settings  :
**         Used pin                    :
**             ----------------------------------------------------
**                Number (on package)  |    Name
**             ----------------------------------------------------
**                       1             |  GPIOA0_TD0
**             ----------------------------------------------------
**
**         Port name                   : GPIOA
**
**         Bit number (in port)        : 0
**         Bit mask of the port        : 1
**
**         Initial direction           : Output (direction cannot be changed)
**         Initial output value        : 0
**         Initial pull option         : up
**
**         Port data register          : GPIO_A_DR [4017]
**         Port control register       : GPIO_A_DDR [4018]
**         Port function register      : GPIO_A_PER [4019]
**
**         Optimization for            : speed
**     Contents  :
**         GetVal - bool SCL_GetVal(void);
**         PutVal - void SCL_PutVal(bool Val);
**         ClrVal - void SCL_ClrVal(void);
**         SetVal - void SCL_SetVal(void);
**         NegVal - void SCL_NegVal(void);
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

#ifndef __SCL_H
#define __SCL_H

/* MODULE SCL. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "PE_Timer.h"

#include "Cpu.h"


#define SCL_PIN_MASK            ((byte)1) /* Pin mask */


/*
** ===================================================================
**     Method      :  SCL_GetVal (bean BitIO)
**
**     Description :
**         This method returns an input value.
**           a) direction = Input  : reads the input value from the
**                                   pin and returns it
**           b) direction = Output : returns the last written value
**         Note: This bean is set to work in Output direction only.
**     Parameters  : None
**     Returns     :
**         ---             - Input value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)

** ===================================================================
*/
#define SCL_GetVal() ((bool)(getRegBits(GPIO_A_DR,SCL_PIN_MASK)))

/*
** ===================================================================
**     Method      :  SCL_PutVal (bean BitIO)
**
**     Description :
**         This method writes the new output value.
**     Parameters  :
**         NAME       - DESCRIPTION
**         Val             - Output value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)
**     Returns     : Nothing
** ===================================================================
*/
void SCL_PutVal(bool Val);

/*
** ===================================================================
**     Method      :  SCL_ClrVal (bean BitIO)
**
**     Description :
**         This method clears (sets to zero) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define SCL_ClrVal() (clrRegBits(GPIO_A_DR,SCL_PIN_MASK))

/*
** ===================================================================
**     Method      :  SCL_SetVal (bean BitIO)
**
**     Description :
**         This method sets (sets to one) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define SCL_SetVal() (setRegBits(GPIO_A_DR,SCL_PIN_MASK))

/*
** ===================================================================
**     Method      :  SCL_NegVal (bean BitIO)
**
**     Description :
**         This method negates (inverts) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define SCL_NegVal() (changeRegBits(GPIO_A_DR,SCL_PIN_MASK))


/* END SCL. */

#endif /* __SCL_H*/
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98.03 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
