/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : SDA.C
**     Project   : pp
**     Processor : 56F801FA80
**     Beantype  : BitIO
**     Version   : Bean 02.068, Driver 01.16, CPU db: 2.71.091
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 08/04/2008, 07:53 a.m.
**     Abstract  :
**         This bean "BitIO" implements an one-bit input/output.
**         It uses one bit/pin of a port.
**         Note: This bean is set to work in Input direction only.
**         Methods of this bean are mostly implemented as a macros
**         (if supported by target language and compiler).
**     Settings  :
**         Used pin                    :
**             ----------------------------------------------------
**                Number (on package)  |    Name
**             ----------------------------------------------------
**                       2             |  GPIOA1_TD1
**             ----------------------------------------------------
**
**         Port name                   : GPIOA
**
**         Bit number (in port)        : 1
**         Bit mask of the port        : 2
**
**         Initial direction           : Input (direction cannot be changed)
**         Initial output value        : 1
**         Initial pull option         : up
**
**         Port data register          : GPIO_A_DR [4017]
**         Port control register       : GPIO_A_DDR [4018]
**         Port function register      : GPIO_A_PER [4019]
**
**         Optimization for            : speed
**     Contents  :
**         SetInput  - void SDA_SetInput(void);
**         SetOutput - void SDA_SetOutput(void);
**         GetVal    - bool SDA_GetVal(void);
**         PutVal    - void SDA_PutVal(bool Val);
**         ClrVal    - void SDA_ClrVal(void);
**         SetVal    - void SDA_SetVal(void);
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE SDA. */

#include "SDA.h"
/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "PE_Timer.h"

#include "Cpu.h"


/*
** ===================================================================
**     Method      :  SDA_GetVal (bean BitIO)
**
**     Description :
**         This method returns an input value.
**           a) direction = Input  : reads the input value from the
**                                   pin and returns it
**           b) direction = Output : returns the last written value
**         Note: This bean is set to work in Input direction only.
**     Parameters  : None
**     Returns     :
**         ---             - Input value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)

** ===================================================================
*/
/*
bool SDA_GetVal(void)

**  This method is implemented as a macro. See SDA.h file.  **

*/

/*
** ===================================================================
**     Method      :  SDA_PutVal (bean BitIO)
**
**     Description :
**         This method writes the new output value.
**     Parameters  :
**         NAME       - DESCRIPTION
**         Val             - Output value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)
**     Returns     : Nothing
** ===================================================================
*/
void SDA_PutVal(bool Val)
{
  if (Val) {                           /* Is it one to be written? */
    Shadow_GPIO_A_DR |= SDA_PIN_MASK;  /* Set bit in shadow variable */
    setRegBits(GPIO_A_DR,SDA_PIN_MASK); /* Set bit on port */
  }
  else {                               /* Is it zero to be written? */
    Shadow_GPIO_A_DR &= ~SDA_PIN_MASK; /* Clear bit in shadow variable */
    clrRegBits(GPIO_A_DR,SDA_PIN_MASK); /* Clear bit on port */
  }
}

/*
** ===================================================================
**     Method      :  SDA_SetVal (bean BitIO)
**
**     Description :
**         This method sets (sets to one) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void SDA_SetVal(void)

**  This method is implemented as a macro. See SDA.h file.  **
*/

/*
** ===================================================================
**     Method      :  SDA_ClrVal (bean BitIO)
**
**     Description :
**         This method clears (sets to zero) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void SDA_ClrVal(void)

**  This method is implemented as a macro. See SDA.h file.  **
*/

/*
** ===================================================================
**     Method      :  SDA_SetInput (bean BitIO)
**
**     Description :
**         This method sets direction of the bean to input.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void SDA_SetInput(void)

**  This method is implemented as a macro. See SDA.h file.  **
*/

/*
** ===================================================================
**     Method      :  SDA_SetOutput (bean BitIO)
**
**     Description :
**         This method sets direction of the bean to output.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void SDA_SetOutput(void)
{
  setReg(GPIO_A_DR,((getReg(GPIO_A_DR)) & ~SDA_PIN_MASK) | (Shadow_GPIO_A_DR & SDA_PIN_MASK)); /* Restore correct value of output from shadow variable */
  setRegBits(GPIO_A_DDR,SDA_PIN_MASK); /* Set direction to output */
}

/* END SDA. */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98.03 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
