/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : SS.H
**     Project   : pp
**     Processor : 56F801FA80
**     Beantype  : BitIO
**     Version   : Bean 02.068, Driver 01.16, CPU db: 2.71.091
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 08/04/2008, 07:53 a.m.
**     Abstract  :
**         This bean "BitIO" implements an one-bit input/output.
**         It uses one bit/pin of a port.
**         Note: This bean is set to work in Output direction only.
**         Methods of this bean are mostly implemented as a macros
**         (if supported by target language and compiler).
**     Settings  :
**         Used pin                    :
**             ----------------------------------------------------
**                Number (on package)  |    Name
**             ----------------------------------------------------
**                       4             |  GPIOB7_SS
**             ----------------------------------------------------
**
**         Port name                   : GPIOB
**
**         Bit number (in port)        : 7
**         Bit mask of the port        : 128
**
**         Initial direction           : Output (direction cannot be changed)
**         Initial output value        : 1
**         Initial pull option         : off
**
**         Port data register          : GPIO_B_DR [4033]
**         Port control register       : GPIO_B_DDR [4034]
**         Port function register      : GPIO_B_PER [4035]
**
**         Optimization for            : speed
**     Contents  :
**         GetVal - bool SS_GetVal(void);
**         PutVal - void SS_PutVal(bool Val);
**         ClrVal - void SS_ClrVal(void);
**         SetVal - void SS_SetVal(void);
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

#ifndef __SS_H
#define __SS_H

/* MODULE SS. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

#include "Cpu.h"


#define SS_PIN_MASK             ((byte)128) /* Pin mask */


/*
** ===================================================================
**     Method      :  SS_GetVal (bean BitIO)
**
**     Description :
**         This method returns an input value.
**           a) direction = Input  : reads the input value from the
**                                   pin and returns it
**           b) direction = Output : returns the last written value
**         Note: This bean is set to work in Output direction only.
**     Parameters  : None
**     Returns     :
**         ---             - Input value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)

** ===================================================================
*/
#define SS_GetVal() ((bool)(getRegBits(GPIO_B_DR,SS_PIN_MASK)))

/*
** ===================================================================
**     Method      :  SS_PutVal (bean BitIO)
**
**     Description :
**         This method writes the new output value.
**     Parameters  :
**         NAME       - DESCRIPTION
**         Val             - Output value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)
**     Returns     : Nothing
** ===================================================================
*/
void SS_PutVal(bool Val);

/*
** ===================================================================
**     Method      :  SS_ClrVal (bean BitIO)
**
**     Description :
**         This method clears (sets to zero) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define SS_ClrVal() (clrRegBits(GPIO_B_DR,SS_PIN_MASK))

/*
** ===================================================================
**     Method      :  SS_SetVal (bean BitIO)
**
**     Description :
**         This method sets (sets to one) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define SS_SetVal() (setRegBits(GPIO_B_DR,SS_PIN_MASK))


/* END SS. */

#endif /* __SS_H*/
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98.03 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
