/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : TI1.C
**     Project   : pp
**     Processor : 56F801FA80
**     Beantype  : TimerInt
**     Version   : Bean 02.119, Driver 01.24, CPU db: 2.71.091
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 08/04/2008, 07:53 a.m.
**     Abstract  :
**         This bean "TimerInt" implements a periodic interrupt.
**         When the bean and its events are enabled, the "OnInterrupt"
**         event is called periodically with the period that you specify.
**         TimerInt supports also changing the period in runtime.
**         The source of periodic interrupt can be timer compare or reload
**         register or timer-overflow interrupt (of free running counter).
**     Settings  :
**         Timer name                  : TMRC0 (16-bit)
**         Compare name                : TMRC0_Compare
**         Counter shared              : No
**
**         High speed mode
**             Prescaler               : divide-by-16
**             Clock                   : 2500000 Hz
**           Initial period/frequency
**             Xtal ticks              : 160000
**             microseconds            : 20000
**             milliseconds            : 20
**             seconds (real)          : 0.0200000
**             Hz                      : 50
**
**         Runtime setting             : none
**
**         Initialization:
**              Timer                  : Enabled
**              Events                 : Enabled
**
**         Timer registers
**              Counter                : TMRC0_CNTR [3397]
**              Mode                   : TMRC0_CTRL [3398]
**              Run                    : TMRC0_CTRL [3398]
**              Prescaler              : TMRC0_CTRL [3398]
**
**         Compare registers
**              Compare                : TMRC0_CMP1 [3392]
**
**         Flip-flop registers
**              Mode                   : TMRC0_SCR [3399]
**     Contents  :
**         No public methods
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE TI1. */

#include "Events.h"
#include "TI1.h"



/* Internal method prototypes */
static void SetCV(word Val);
static void SetPV(byte Val);

/*
** ===================================================================
**     Method      :  SetCV (bean TimerInt)
**
**     Description :
**         Sets compare or preload register value. The method is called 
**         automatically as a part of several internal methods.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void SetCV(word Val)
{
  setReg(TMRC0_CMP1,Val);              /* Store given value to the compare register */
}

/*
** ===================================================================
**     Method      :  SetPV (bean TimerInt)
**
**     Description :
**         Sets prescaler value. The method is called automatically as a 
**         part of several internal methods.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void SetPV(byte Val)
{
  setRegBitGroup(TMRC0_CTRL,PCS,Val);  /* Store given value to the prescaler */
  setReg(TMRC0_CNTR,0);                /* Reset counter */
}

/*
** ===================================================================
**     Method      :  TI1_Init (bean TimerInt)
**
**     Description :
**         Initializes the associated peripheral(s) and the beans 
**         internal variables. The method is called automatically as a 
**         part of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void TI1_Init(void)
{
  /* TMRC0_CTRL: CM=0,PCS=0,SCS=0,ONCE=0,LENGTH=1,DIR=0,Co_INIT=0,OM=0 */
  setReg(TMRC0_CTRL,32);               /* Stop all functions of the timer */
  /* TMRC0_SCR: TCF=0,TCFIE=1,TOF=0,TOFIE=0,IEF=0,IEFIE=0,IPS=0,INPUT=0,Capture_Mode=0,MSTR=0,EEOF=0,VAL=0,FORCE=0,OPS=0,OEN=0 */
  setReg(TMRC0_SCR,16384);
  setReg(TMRC0_CNTR,0);                /* Reset counter register */
  setReg(TMRC0_LOAD,0);                /* Reset load register */
  SetCV((word)49999);                  /* Store appropriate value to the compare register according to the selected high speed CPU mode */
  SetPV((byte)12);                     /* Set prescaler register according to the selected high speed CPU mode */
  setRegBitGroup(TMRC0_CTRL,CM,1);     /* Run counter */
}

/*
** ===================================================================
**     Method      :  TI1_Interrupt (bean TimerInt)
**
**     Description :
**         The method services the interrupt of the selected peripheral(s)
**         and eventually invokes the beans event(s).
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
#pragma interrupt saveall
void TI1_Interrupt(void)
{
  clrRegBit(TMRC0_SCR,TCF);            /* Reset interrupt request flag */
  TI1_OnInterrupt();                   /* Invoke user event */
}

/* END TI1. */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98.03 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
