/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : TI2.H
**     Project   : pp
**     Processor : 56F801FA80
**     Beantype  : TimerInt
**     Version   : Bean 02.119, Driver 01.24, CPU db: 2.71.091
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 08/04/2008, 07:53 a.m.
**     Abstract  :
**         This bean "TimerInt" implements a periodic interrupt.
**         When the bean and its events are enabled, the "OnInterrupt"
**         event is called periodically with the period that you specify.
**         TimerInt supports also changing the period in runtime.
**         The source of periodic interrupt can be timer compare or reload
**         register or timer-overflow interrupt (of free running counter).
**     Settings  :
**         Timer name                  : TMRC1 (16-bit)
**         Compare name                : TMRC1_Compare
**         Counter shared              : No
**
**         High speed mode
**             Prescaler               : divide-by-1
**             Clock                   : 40000000 Hz
**           Initial period/frequency
**             Xtal ticks              : 2000
**             microseconds            : 250
**             seconds (real)          : 0.0002500
**             Hz                      : 4000
**             kHz                     : 4
**
**         Runtime setting             : none
**
**         Initialization:
**              Timer                  : Enabled
**              Events                 : Enabled
**
**         Timer registers
**              Counter                : TMRC1_CNTR [3405]
**              Mode                   : TMRC1_CTRL [3406]
**              Run                    : TMRC1_CTRL [3406]
**              Prescaler              : TMRC1_CTRL [3406]
**
**         Compare registers
**              Compare                : TMRC1_CMP1 [3400]
**
**         Flip-flop registers
**              Mode                   : TMRC1_SCR [3407]
**     Contents  :
**         Enable  - byte TI2_Enable(void);
**         Disable - byte TI2_Disable(void);
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

#ifndef __TI2
#define __TI2

/* MODULE TI2. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "PE_Timer.h"
#include "Cpu.h"


byte TI2_Enable(void);
/*
** ===================================================================
**     Method      :  TI2_Enable (bean TimerInt)
**
**     Description :
**         Enables the bean - it starts the timer. Events may be
**         generated ("DisableEvent"/"EnableEvent").
**     Parameters  : None
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
** ===================================================================
*/

byte TI2_Disable(void);
/*
** ===================================================================
**     Method      :  TI2_Disable (bean TimerInt)
**
**     Description :
**         Disables the bean - it stops the timer. No events will be
**         generated.
**     Parameters  : None
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
** ===================================================================
*/

void TI2_Init(void);
/*
** ===================================================================
**     Method      :  TI2_Init (bean TimerInt)
**
**     Description :
**         Initializes the associated peripheral(s) and the beans 
**         internal variables. The method is called automatically as a 
**         part of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void TI2_Interrupt(void);
/*
** ===================================================================
**     Method      :  TI2_Interrupt (bean TimerInt)
**
**     Description :
**         The method services the interrupt of the selected peripheral(s)
**         and eventually invokes the beans event(s).
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

/* END TI2. */

#endif /* ifndef __TI2 */
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98.03 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
