/** ###################################################################
**     Filename  : pp.C
**     Project   : pp
**     Processor : 56F801FA80
**     Version   : Driver 01.11
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 16/01/2008, 7:34
**     Abstract  :
**         Main module.
**         Here is to be placed user's code.
**     Settings  :
**     Contents  :
**         No public methods
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/
/* MODULE pp */

/* Including used modules for compiling procedure */


//***************************LIBRERIAS*****************************

#include "Cpu.h"
#include "Events.h"
#include "LCD_RS.h"
#include "LCD_E.h"
#include "LCD_D4.h"
#include "LCD_D5.h"
#include "LCD_D6.h"
#include "LCD_D7.h"
#include "SDA.h"
#include "SCL.h"
#include "TI1.h"
#include "SM1.h"
#include "AD1.h"
#include "AS1.h"
#include "TI2.h"
#include "ADEInt.h"
#include "SS.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

#include	"lcd_801pex.h"
#include	"i2c_801pex.h"

#include	"ade.h"
#include	"chipset.h"
#include	"display.h"



//****************************CONSTANTES *****************************

//Ctes comunicacion con Matlab

#define	PCREGS		'S'
#define	PCREGSNW	'R'
#define	PCTIME		'T'
#define	PCEEPROM	'E'
#define	PCWZERO		'Z'
#define	PCTXRX		'X'
#define	PCINTCONFIG	'I'
#define	PCWAVE		'W'
#define	PCHIST		'H'




#define	DIRHISTORIAL	20
#define	ONDASIZE	64

//***********************VARIABLES GLOBALES**********************************

volatile unsigned int tic, tic1, tic2, ticTiempo;
volatile unsigned int flag;

int mostrarFase;
int mostrarValor;

unsigned int timeout;
unsigned char serialBuffer[20];
unsigned int serialIndex;

unsigned int refresh;

long adeFaseA[18];	//	4*6*3 = 72bytes
long potenciaVA[3];
long potenciaWATT[3];
long potenciaVAR[3];
long vrms[3], irms[3], freq[3];

int status;
unsigned int statusI;


long accWatt[3], accVar[3], accVa[3];

unsigned long tiempo;

unsigned char numPeaks, numSagsA, numSagsB, numSagsC;
unsigned int refrescarHistorial;

int factores[8];
int configInterrupt;

unsigned int historial;

unsigned int waveIndex;


//**************************ENCABEZADOS************************

long wave[ONDASIZE];

void medirPotencia(void);
void medirValores(void);
void enviarDatos(void);

void escribirHistorial(void);

void eepromEscribir16(int *val, int size, int addr);
void eepromLeer16(int *val, int size, int addr);



/////////////////////////////////////////////////////////////////



void main(void)
{
  /* Write your local variable definition here */
  //int res[64];
  

  unsigned int f;
  unsigned int i,j;
  
  int test[6];
  
  int estadoBoton;
  
  long regLeido;
  unsigned char res[4];
  
  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  /* Write your code here */
  
  
  
  //******************************INICIO PROGRAMA*******************************
  
	tiempo = 0;

	timeout = 5*10;
  	
	SS_SetVal();						//Inicializa protocolo SPI
	lcdInit();							//Inicializa LCD
	
	mostrarFase = 0;
	mostrarValor = 2;
	mostrarLCD(mostrarFase);

  	estadoBoton = 0;	
	refresh = 1;
	AS1_SendChar('*');
	
	eepromLeer16(test, 1, 0);			//	init
	
	
//ESCRIBE EN LA EEPROM POR UNICA VEZ PARA MANTENER CALIBRADA LA TARJETA SIN NECESIDAD DE CONECTARLA A MATLAB	
	//eepromLeer16(test, 6, 0);
	/*
	factores[0] = 4720;
	factores[1] = 524;
	factores[2] = 16;
	factores[3] = 71;
	factores[4] = 3403;
	factores[5] = 81;
	
	eepromEscribir16(factores, 6, 0);
	*/
	

	lcdSend(LCD_2L, LCD_CMD);
	lcdSendStr("<LOAD> ");
	eepromLeer16(factores, 6, 0);


	eepromLeer16(test, 1, DIRHISTORIAL + 4);
	numSagsA = test[0] & 0x00FF;
	numPeaks = (test[0] >> 8) & 0x00FF;
	
	eepromLeer16(test, 1, DIRHISTORIAL + 6);
	numSagsB = test[0] & 0x00FF;
	numSagsC = (test[0] >> 8) & 0x00FF;
	
	
	
	//*************************	REINICIO ADE ***********************
	
		
	//	escribir 0x44 a OPMODE		softReset !!!	
	res[0] = 0x44;
	escribirADE(OPMODE, 1, res);

	
	//	escribir 0x1C a COMPMODE
	res[0] = 0x1C;
	escribirADE(COMPMODE, 1, res);
	
	
	//	escribir 0x4038 a MASK
	res[0] = 0x00;
	res[1] = 0x40;
	res[2] = 0x38;
	escribirADE(MASK, 3, res);

	
	//	escribir 0x06 a SAGCYC
	res[0] = 0x06;
	escribirADE(SAGCYC, 1, res);
	
	
	//	escribir 0x7F a LCYCMODE
	res[0] = 0x78;
	escribirADE(LCYCMODE, 1, res);

		
	//	leer status
	leerADE(RSTATUS, 3, res);
	
	
	
///////////////////////////////////////////////////////////////////////////////
	
	configInterrupt = 0;
	
	f = 0;
	tic = 0;
	tic1 = 0;
	tic2 = 0;
	ticTiempo = 0;
	flag = 0;
	waveIndex = 0;
	
	historial = 0;
	
	statusI = 0;
	
	accWatt[0] = 0; 
	accVar[0] = 0;
	accVa[0] = 0;
	accWatt[1] = 0; 
	accVar[1] = 0;
	accVa[1] = 0;
	accWatt[2] = 0; 
	accVar[2] = 0;
	accVa[2] = 0;

	
	refrescarHistorial = 0;
	
//************************************COMIENZA CICLO INFINITO******************
//********************************COMANDOS PARA LA COMUNICACION CON MATLAB******************
//************************************  RECEPCION DE DATOS	************************	
	
	while(1)
	{
		if(ticTiempo > 10-1)
		{
			ticTiempo = 0;
			
			tiempo++;
		}
		
		if(serialIndex > 2*7-1)
		{
			if(serialBuffer[0] == PCTXRX)
			{
				if(serialBuffer[1] == PCREGSNW)
				{
					factores[0] = serialBuffer[2] + 256*serialBuffer[3];
					factores[1] = serialBuffer[4] + 256*serialBuffer[5];
					factores[2] = serialBuffer[6] + 256*serialBuffer[7];
					factores[3] = serialBuffer[8] + 256*serialBuffer[9];
					factores[4] = serialBuffer[10] + 256*serialBuffer[11];
					factores[5] = serialBuffer[12] + 256*serialBuffer[13];

					lcdSend(LCD_2L, LCD_CMD);
					lcdSendStr("<REGS> ");
				}

				if(serialBuffer[1] == PCREGS)
				{
					factores[0] = serialBuffer[2] + 256*serialBuffer[3];
					factores[1] = serialBuffer[4] + 256*serialBuffer[5];
					factores[2] = serialBuffer[6] + 256*serialBuffer[7];
					factores[3] = serialBuffer[8] + 256*serialBuffer[9];
					factores[4] = serialBuffer[10] + 256*serialBuffer[11];
					factores[5] = serialBuffer[12] + 256*serialBuffer[13];
					
					eepromLeer16(factores, 6, 0);

					lcdSend(LCD_2L, LCD_CMD);
					lcdSendStr("<SAVE> ");
				}
				
				if(serialBuffer[1] == PCHIST)
				{
					unsigned char temp;
					
					while(AS1_SendChar('H') != ERR_OK);
					while(AS1_SendChar('h') != ERR_OK);
					for(i=0;i<10;i++)
					{
						temp = (unsigned char)i2cReceive8(I2CEEPROM, DIRHISTORIAL + i);
						while(AS1_SendChar(temp) != ERR_OK);
					}
				}
				
				if(serialBuffer[1] == PCINTCONFIG)
				{
					factores[6] = serialBuffer[2] + 256*serialBuffer[3];
					factores[7] = serialBuffer[4] + 256*serialBuffer[5];
					configInterrupt = serialBuffer[6] + 256*serialBuffer[7];

					lcdSend(LCD_2L, LCD_CMD);
				
					
					if(configInterrupt & 0x0001)
					{
						unsigned long temp;
					
					
						res[0] = (unsigned char)(factores[6] & 0xFF);
						escribirADE(SAGLVL, 1, res);

					
						res[0] = (unsigned char)(factores[7] & 0xFF);
						escribirADE(VPINTLVL, 1, res);
					
						
						temp = res[0];
						
						lcdSendStr("<I");
						lcdSendDec32Short(temp, 3);
						lcdSendStr("> ");
					}
					else
					{
						lcdSendStr("<IOff> ");
					}
				}
				
			
				
//////RESETEA DESDE MATLAB				
				
				if(serialBuffer[1] == PCWZERO)
				{
					accWatt[0] = 0; 
					accVar[0] = 0;
					accVa[0] = 0;
					accWatt[1] = 0; 
					accVar[1] = 0;
					accVa[1] = 0;
					accWatt[2] = 0; 
					accVar[2] = 0;
					accVa[2] = 0;
					numPeaks = 0;
					numSagsA = 0;
					numSagsB = 0;
					numSagsC = 0;
					
					refrescarHistorial++;
				
	
					lcdSend(LCD_2L, LCD_CMD);
					lcdSendStr("<ZERO> ");
				}
				
			}

			serialIndex = 0;
		}
	
		if(flag > 10)
		{
			flag = 0;
			
			
//*******CONFIGURACION PULSADORES******			
			
			estadoBoton = leerBotones(estadoBoton);
			if(estadoBoton)
			{
				if(estadoBoton == 1)
					mostrarValor--;
				if(estadoBoton == 2)
					mostrarValor++;
				if(estadoBoton == 3)
					mostrarFase++;
				
				if(mostrarFase>2)
					mostrarFase = 0;
				if(mostrarFase<0)
					mostrarFase = 2;
				if(mostrarValor>5)
					mostrarValor = 0;
				if(mostrarValor<0)
					mostrarValor = 5;
				
				lcdSend(LCD_CLS, LCD_CMD);
				mostrarLCD(mostrarFase);
			}
		}

		//	power
		if(tic1>20)
		{
			tic1 = 0;
			
	//******MIDE POTENCIA*********/////		
			medirPotencia();      

		
		
//**************CONTEO DE SAGS Y SWELLS**********		
		
			if(1)
			{
				leerADE(STATUS, 3, res);
				status = res[2] + 256*res[1] + 65536*res[0];

				if(status & 0x004000)
				{
					numPeaks++;
					refrescarHistorial++;
					leerADE(RSTATUS, 3, res);
				}

				if(status & 0x000008)	// 0x38 para cualquier SAC
				{
					numSagsA++;
					refrescarHistorial++;
					leerADE(RSTATUS, 3, res);
				}

				if(status & 0x000010)	// 0x38 para cualquier SAC
				{
					numSagsB++;
					refrescarHistorial++;
					leerADE(RSTATUS, 3, res);
				}

				if(status & 0x000020)	// 0x38 para cualquier SAC
				{
					numSagsC++;
					refrescarHistorial++;
					leerADE(RSTATUS, 3, res);
				}
			}
		}
	
		if(statusI)
		{
			statusI = 0;
			
			leerADE(STATUS, 3, res);
			status = res[2] + 256*res[1] + 65536*res[0];
			
			if(status & 0x004000)
			{
				numPeaks++;
			}
			if(status & 0x000008)	
			{
				numSagsA++;
			}
			if(status & 0x000010)	
			{
				numSagsB++;
			}
			if(status & 0x000020)	
			{
				numSagsC++;
			}
			
			refrescarHistorial++;
			leerADE(RSTATUS, 3, res);
		}

		//	vrms, irms, freq
		//	refresco cada 960ms
		if(tic>48)
		{
			tic = 0;
			refresh = 1;

		//*******MIDE VRMS IRMS Y FREQ*****///
			medirValores();
		}
		
		if(refresh)
		{
			refresh = 0;



/////***************************DESPLIEGUE DATOS LCD***************/////////

			//	****	FREQ	****
			if(mostrarValor == 5)
			{
				lcdSend(LCD_2L, LCD_CMD);
				lcdSendStr("Freq: ");
				lcdSendDec32Short((unsigned long)freq[mostrarFase], 2);
				lcdSendStr("Hz");
			}

			//	****	VRMS	****
			if(mostrarValor == 0)
			{
				
				lcdSend(LCD_2L, LCD_CMD);
				lcdSendStr("Vrms: ");
				lcdSendDec32Short((unsigned long)vrms[mostrarFase], 3);
				lcdSendStr("V");
			}

			//	****	IRMS	****
			if(mostrarValor == 1)
			{
				
				lcdSend(LCD_2L, LCD_CMD);
				lcdSendStr("Irms: ");
				lcdSendDec32Short((unsigned long)irms[mostrarFase], 4);
				lcdSendStr("mA");
			}

			//	****	WATT	****
			if(mostrarValor == 2)
			{
				
				lcdSend(LCD_2L, LCD_CMD);
				lcdSendStr("WATT-HR: ");
				lcdSendDec32Short((unsigned long)accWatt[mostrarFase]/1000, 6);
			
			}

			//	****     VAR	****
			if(mostrarValor == 3)
			{
				
				lcdSend(LCD_2L, LCD_CMD);
				lcdSendStr("VAR-HR: ");
				lcdSendDec32Short((unsigned long)accVar[mostrarFase]/1000, 6);
			
			}

			//	*******	 VA	*******
			if(mostrarValor == 4)
			{
			
				lcdSend(LCD_2L, LCD_CMD);
				lcdSendStr("VA-HR: ");
				lcdSendDec32Short((unsigned long)accVa[mostrarFase]/1000, 6);
			
			}
			
			if(refrescarHistorial)
			{
				refrescarHistorial = 0;
				
				escribirHistorial();
			}

			enviarDatos();   //*********ENVIA DATOS A MATLAB*******
		}
		
	}
	
	
	
  	
  for(;;) {}
}

/* END */
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/


///////////////////////////////////////////////////////////////
//*************FUNCION PARA ENVIAR VALORES A MATLAB******
void enviarDatos(void)
{
	unsigned char datos[72];
	unsigned int i;
	
	long2charCompleta(adeFaseA[0], &datos[0]);
	long2charCompleta(adeFaseA[1], &datos[4]);
	long2charCompleta(adeFaseA[2], &datos[8]);
	long2charCompleta(adeFaseA[3], &datos[12]);
	long2charCompleta(adeFaseA[4], &datos[16]);
	long2charCompleta(adeFaseA[5], &datos[20]);
	
	long2charCompleta(adeFaseA[6], &datos[24]);
	long2charCompleta(adeFaseA[7], &datos[28]);
	long2charCompleta(adeFaseA[8], &datos[32]);
	long2charCompleta(adeFaseA[9], &datos[36]);
	long2charCompleta(adeFaseA[10], &datos[40]);
	long2charCompleta(adeFaseA[11], &datos[44]);
	
	long2charCompleta(adeFaseA[12], &datos[48]);
	long2charCompleta(adeFaseA[13], &datos[52]);
	long2charCompleta(adeFaseA[14], &datos[56]);
	long2charCompleta(adeFaseA[15], &datos[60]);
	long2charCompleta(adeFaseA[16], &datos[64]);
	long2charCompleta(adeFaseA[17], &datos[68]);
	
	while(AS1_SendChar('u') != ERR_OK);
	while(AS1_SendChar('p') != ERR_OK);
	while(AS1_SendChar('b') != ERR_OK);
	for(i=0;i<72;i++)
	{
		while(AS1_SendChar(datos[i]) != ERR_OK);
	}
	while(AS1_SendChar(numPeaks) != ERR_OK);
	while(AS1_SendChar(numSagsA) != ERR_OK);
	
	while(AS1_SendChar(numSagsB) != ERR_OK);
	while(AS1_SendChar(numSagsC) != ERR_OK);

}



//////////////////////////////////////////////////////////////
//********************FUNCION PRA MEDIR LAS POTENCIAS*********

void medirPotencia(void)
{
	unsigned int iFase;
	long regLeido;
	unsigned char res[4];
	
	for(iFase=0;iFase<3;iFase++)
	{
		//	****	WATT	****
		
		//	selecciono potencia activa y fase
		res[0] = 0x08 + iFase;
		escribirADE(WAVMODE, 1, res);
		
		//	leo el valor de Vrms de la respectiva fase
		leerADE(AWATTHR + iFase, 2, res);
		regLeido = res[1] + 256*res[0];

		regLeido /= factores[3];
		accWatt[iFase] += regLeido;

		potenciaWATT[iFase] = regLeido;

		
		adeFaseA[3 + 6*iFase] = accWatt[iFase];
		
		
		//	****	PVAR	****

		//	selecciono potencia reactiva y fase
		res[0] = 0x0C + iFase;
		escribirADE(WAVMODE, 1, res);
		
		//	leo el valor de Vrms de la respectiva fase
		leerADE(AVARHR + iFase, 2, res);
		regLeido = res[1] + 256*res[0];


		regLeido /= factores[4];
		accVar[iFase] += regLeido;
		
		potenciaVAR[iFase] = regLeido;

		adeFaseA[4 + 6*iFase] = accVar[iFase];
		
		
		
		//	****	PVA 	****

		//	selecciono potencia aparente y fase
		res[0] = 0x10 + iFase;
		escribirADE(WAVMODE, 1, res);

		//	leo el valor de Vrms de la respectiva fase
		leerADE(AVAHR + iFase, 2, res);
		regLeido = res[1] + 256*res[0];


	
		regLeido /= factores[5];
		accVa[iFase] += regLeido;
		
		potenciaVA[iFase] = regLeido;

	
		adeFaseA[5 + 6*iFase] = accVa[iFase];
	}
}


////////////////////////////////////////////////////////////////////////
//************************FUNCION PARA MEDICION DE VRMS Y IRMS********

void medirValores(void)
{
	unsigned int iFase;
	long regLeido;
	unsigned char res[4];
	unsigned char iii;
	
	for(iFase=0;iFase<3;iFase++)
	{
		//	****	VRMS	****
		
		//	selecciono voltaje y fase
		res[0] = 0x04 + iFase;
		escribirADE(WAVMODE, 1, res);

		//	leo el valor de Vrms de la respectiva fase
		leerADE(AVRMS + iFase, 3, res);
		
		iii = (res[2]>>6);
		iii += ((res[1]<<2) & 0xFC); 
		
		regLeido = res[2] + 256*res[1] + 65536*res[0];
		
	
		adeFaseA[0 + 6*iFase] = regLeido;
		
	
		regLeido /= factores[0];

		vrms[iFase] = regLeido;




		//	****	IRMS	****

		//	selecciono corriente y fase
		res[0] = 0x00 + iFase;
		escribirADE(WAVMODE, 1, res);

		//	leo el valor de Irms de la respectiva fase
		leerADE(AIRMS + iFase, 3, res);
		regLeido = res[2] + 256*res[1] + 65536*res[0];

		
		adeFaseA[1 + 6*iFase] = regLeido;

		
		regLeido /= factores[1];
		
		irms[iFase] = regLeido;
		
		
		
		
		//	****	FREQ	****

		res[0] = 0xFC + iFase;
		escribirADE(MMODE, 1, res);

		leerADE(FREQ, 2, res);
		regLeido = res[1] + 256*res[0];
		
	
		adeFaseA[2 + 6*iFase] = regLeido;

	
		regLeido /= factores[2];
			
		freq[iFase] = regLeido;
	}
}


/////////////////////////////////////////////////////////////////////
//***************FUNCION PARA ESCRIBIR EEPROM********************

void eepromEscribir16(int *val, int size, int addr)
{
	unsigned int i;
	
	for(i=0;i<size;i++)
	{
		unsigned int temp;
		
		temp = *val;
		val++;
		i2cSendByte((unsigned char)(temp & 0x00FF), I2CEEPROM, addr + 2*i);
		recDelay();
		i2cSendByte((unsigned char)((temp >> 8) & 0x00FF), I2CEEPROM, addr + 2*i + 1);
		recDelay();
	}
}

///////////////////////////////////////////////////////////////////////
//*****************FUNCION PARA LEER EEPROM***********************

void eepromLeer16(int *val, int size, int addr)
{
	unsigned int i;
	
	for(i=0;i<size;i++)
	{
		unsigned int temp;
		
		temp = i2cReceive8(I2CEEPROM, addr + 2*i);
		recDelay();
		temp |= i2cReceive8(I2CEEPROM, addr + 2*i + 1) << 8;
		recDelay();
		*val = temp;
		val++;
	}
}


///////////////////////////////////////////////////////////////////////
//*******************FUNCION PARA ESCRIBIR HISTORIAL EN EEPROM POR UNICA VEZ***********
void escribirHistorial(void)
{
	int temp[4];

	temp[0] = (unsigned int)(tiempo & 0xFFFF);
	temp[1] = (unsigned int)((tiempo >> 16) & 0xFFFF);
	temp[2] = numSagsA + (numPeaks << 8);
	temp[3] = numSagsB + (numSagsC << 8);
		
	if(DIRHISTORIAL + historial >= DIRHISTORIAL)
	{
		eepromEscribir16(temp, 4, DIRHISTORIAL + historial);
	
	}
}
