/*

			SAMESYS
			
			LCD MODULE ROUTINES
			
			Version:	0.91
			File:		LCD.H
		
			Target:		DSP56800E
			
					
*/

//	LCD Definitions

#define			lcdESet()	PWMA_PMOUT |= 0x0020
#define			lcdEClr()	PWMA_PMOUT &= ~(0x0020)
#define			lcdRSSet()	PWMA_PMOUT |= 0x0010
#define			lcdRSClr()	PWMA_PMOUT &= ~(0x0010)
void portInit(void);
void lcdPutInPort(unsigned int val);
void portInit(void)
{
	PWMA_PMOUT = 0xBF00;	//	pads enabled software control enabled
}
void lcdPutInPort(unsigned int val)
{
	PWMA_PMOUT &= 0xFFF0;
	PWMA_PMOUT |= (val & 0x000F);
}

//	External defines: 	PIN_LCD_RS, PIN_LCD_E, PIN_LCD_CON_ALL, PIN_LCD_DATA_ALL, 
//						PORT_LCD_DATA_PER, PORT_LCD_DATA_DDR, PORT_LCD_DATA_DR,
//						PORT_LCD_CON_PER, PORT_LCD_CON_DDR, PORT_LCD_CON_DR,

//#define			RS		1	//$0010
//#define			E		2	//$0020
#define			LCD_CMD		0
#define			LCD_CHR		1
#define			LCD_CLS		0x0001
#define			LCD_1L		0x0080
#define			LCD_2L		0x00C0
#define			LCD_3L		0x0094
#define			LCD_4L		0x00D4
/*
#define			lcdESet()	asm(bfset	#PIN_LCD_E,x:PORT_LCD_CON_DR)
#define			lcdEClr()	asm(bfclr	#PIN_LCD_E,x:PORT_LCD_CON_DR)
#define			lcdRSSet()	asm(bfset	#PIN_LCD_RS,x:PORT_LCD_CON_DR)
#define			lcdRSClr()	asm(bfclr	#PIN_LCD_RS,x:PORT_LCD_CON_DR)
*/

#define			lcdClearScreen()	lcdSend(LCD_CLS, LCD_CMD)
#define			lcdFirstLine()		lcdSend(LCD_1L, LCD_CMD)
#define			lcdSecondLine()		lcdSend(LCD_2L, LCD_CMD)

void lcdInit(void);
void lcdDelay(unsigned int);
void lcdSend(unsigned int, unsigned int);
void lcdSendChr(unsigned int);
void lcdSendStr(char *);

asm void lcdPutInPort(unsigned int);
void lcdNibbleDelay(void);

//	LCD Routines

void lcdInit(void)
{
	//	lcd's pin configuration
	portInit();
/*	asm
	{
		bfclr	#PIN_LCD_DATA_ALL,x:PORT_LCD_DATA_PER
		bfclr	#PIN_LCD_DATA_ALL,x:PORT_LCD_DATA_DR
		bfset	#PIN_LCD_DATA_ALL,x:PORT_LCD_DATA_DDR	//	data as outputs

		bfclr	#PIN_LCD_CON_ALL,x:PORT_LCD_CON_PER
		bfclr	#PIN_LCD_CON_ALL,x:PORT_LCD_CON_DR
		bfset	#PIN_LCD_CON_ALL,x:PORT_LCD_CON_DDR		//	rs & e as outputs
	}
*/
	lcdDelay(600);										//	nibble mode config
	lcdSend(0x0033, LCD_CMD);
	lcdDelay(600);
	lcdSend(0x0032, LCD_CMD);
	lcdDelay(600);	
	lcdSend(0x000F, LCD_CMD);
	lcdDelay(600);	
	lcdSend(0x0001, LCD_CMD);
	lcdDelay(1000);	
	lcdSend(0x0006, LCD_CMD);
	lcdDelay(600);	
}

void lcdDelay(unsigned int value)
{
	unsigned int i,j;
	
	for(j=0;j<=value;j++)
	{
		for(i=0;i<=1000;i++)
		{
			//asm(nop);
		}
	}
}
/*
//	data is alligned with lsb
asm void lcdPutInPort(unsigned int)
{
	bfclr	#$000F,x:PORT_LCD_DATA_DR
	add.w	y0,x:PORT_LCD_DATA_DR
	rts
}
*/
void lcdNibbleDelay(void)
{
	unsigned int i;
	
	for(i=0;i<50000;i++)
	{
		
	}
}

void lcdSend(unsigned int value, unsigned int flag)
{
	if(flag)
		lcdRSSet();				//	chr
	else
		lcdRSClr();				//	cmd

	lcdPutInPort((value & 0x00F0)>>4);
	lcdESet();
	lcdNibbleDelay();
	lcdEClr();
	lcdNibbleDelay();
	lcdPutInPort((value & 0x000F));
	lcdESet();
	lcdNibbleDelay();
	lcdEClr();
	lcdNibbleDelay();
}

void lcdSendChr(unsigned int value)
{
	lcdRSSet();				//	chr
	lcdPutInPort((value & 0x00F0)>>4);
	lcdESet();
	lcdNibbleDelay();
	lcdEClr();
	lcdNibbleDelay();
	lcdPutInPort((value & 0x000F));
	lcdESet();
	lcdNibbleDelay();
	lcdEClr();
	lcdDelay(50);
}

void lcdSendStr(char *mes)
{
	unsigned int i;
	
	i = 0;
	while(mes[i] != '\0')
	{
		lcdSendChr((unsigned int)mes[i]);
		if(i++>16)	break;
	}
}

/*			eof			*/
