/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : IO_Map.H
**     Project   : pp
**     Processor : 56F801FA80
**     Beantype  : IO_Map
**     Version   : Driver 01.00
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 08/04/2008, 07:53 a.m.
**     Abstract  :
**         IO_Map.h - implements an IO device's mapping. 
**         This module contains symbol definitions of all peripheral 
**         registers and bits. 
**     Settings  :
**
**     Contents  :
**         No public methods
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

#ifndef __IO_Map_H
#define __IO_Map_H

/* Based on CPU DB 56F801, version 2.71.088 (RegistersPrg V2.01) */
/* DataSheet : DSP56F801/D Rev. 11.0, DSP56F801-7UM/D - Rev. 4.0 */

#include "PE_Types.h"

/******************************************
*** Peripheral SIM
*******************************************/
typedef volatile struct {
  /*** SYS_CNTL - System Control Register; 0x00000C00 ***/
  union {
    word Word;
  } SYS_CNTL_STR;
  
  #define SYS_CNTL_RPD_MASK             1U
  #define SYS_CNTL_PD_MASK              2U
  #define SYS_CNTL_LVIE22_MASK          4U
  #define SYS_CNTL_LVIE27_MASK          8U
  #define SYS_CNTL_BOOTMAP_B_MASK       16U
  #define SYS_CNTL_DATA_PD_MASK         256U
  #define SYS_CNTL_ADR_PD_MASK          512U
  #define SYS_CNTL_CTRL_PD_MASK         1024U
  #define SYS_CNTL_TMR_PD_MASK          2048U
  #define SYS_CNTL                      *((volatile word *)0x00000C00)


  /*** SYS_STS - System Status Register; 0x00000C01 ***/
  union {
    word Word;
  } SYS_STS_STR;
  
  #define SYS_STS_LVIS_22_MASK          1U
  #define SYS_STS_LVIS27_MASK           2U
  #define SYS_STS_POR_MASK              4U
  #define SYS_STS_EXTR_MASK             8U
  #define SYS_STS_COPR_MASK             16U
  #define SYS_STS                       *((volatile word *)0x00000C01)


  word Reserved0[4];                   /* Reserved (unused) registers */
  
  /*** MSH_ID - Most Significant Half of JTAG ID; 0x00000C06 ***/
  union {
    word Word;
  } MSH_ID_STR;
  
  #define MSH_ID_MSH_ID0_MASK           1U
  #define MSH_ID_MSH_ID1_MASK           2U
  #define MSH_ID_MSH_ID2_MASK           4U
  #define MSH_ID_MSH_ID3_MASK           8U
  #define MSH_ID_MSH_ID4_MASK           16U
  #define MSH_ID_MSH_ID5_MASK           32U
  #define MSH_ID_MSH_ID6_MASK           64U
  #define MSH_ID_MSH_ID7_MASK           128U
  #define MSH_ID_MSH_ID8_MASK           256U
  #define MSH_ID_MSH_ID9_MASK           512U
  #define MSH_ID_MSH_ID10_MASK          1024U
  #define MSH_ID_MSH_ID11_MASK          2048U
  #define MSH_ID_MSH_ID12_MASK          4096U
  #define MSH_ID_MSH_ID13_MASK          8192U
  #define MSH_ID_MSH_ID14_MASK          16384U
  #define MSH_ID_MSH_ID15_MASK          32768U
  #define MSH_ID                        *((volatile word *)0x00000C06)


  /*** LSH_ID - Least Significant Half of JTAG ID; 0x00000C07 ***/
  union {
    word Word;
  } LSH_ID_STR;
  
  #define LSH_ID_LSH_ID0_MASK           1U
  #define LSH_ID_LSH_ID1_MASK           2U
  #define LSH_ID_LSH_ID2_MASK           4U
  #define LSH_ID_LSH_ID3_MASK           8U
  #define LSH_ID_LSH_ID4_MASK           16U
  #define LSH_ID_LSH_ID5_MASK           32U
  #define LSH_ID_LSH_ID6_MASK           64U
  #define LSH_ID_LSH_ID7_MASK           128U
  #define LSH_ID_LSH_ID8_MASK           256U
  #define LSH_ID_LSH_ID9_MASK           512U
  #define LSH_ID_LSH_ID10_MASK          1024U
  #define LSH_ID_LSH_ID11_MASK          2048U
  #define LSH_ID_LSH_ID12_MASK          4096U
  #define LSH_ID_LSH_ID13_MASK          8192U
  #define LSH_ID_LSH_ID14_MASK          16384U
  #define LSH_ID_LSH_ID15_MASK          32768U
  #define LSH_ID                        *((volatile word *)0x00000C07)


  word Reserved1[312];                 /* Reserved (unused) registers */

} SIM_PRPH;

/******************************************
*** Peripheral TMRC0
*******************************************/
typedef volatile struct {
  /*** TMRC0_CMP1 - Timer C Channel 0 Compare Register #1; 0x00000D40 ***/
  union {
    word Word;
  } TMRC0_CMP1_STR;
  
  #define TMRC0_CMP1                    *((volatile word *)0x00000D40)


  /*** TMRC0_CMP2 - Timer C Channel 0 Compare Register #2; 0x00000D41 ***/
  union {
    word Word;
  } TMRC0_CMP2_STR;
  
  #define TMRC0_CMP2                    *((volatile word *)0x00000D41)


  /*** TMRC0_CAP - Timer C Channel 0 Capture Register; 0x00000D42 ***/
  union {
    word Word;
  } TMRC0_CAP_STR;
  
  #define TMRC0_CAP                     *((volatile word *)0x00000D42)


  /*** TMRC0_LOAD - Timer C Channel 0 Load Register; 0x00000D43 ***/
  union {
    word Word;
  } TMRC0_LOAD_STR;
  
  #define TMRC0_LOAD_LOAD0_MASK         1U
  #define TMRC0_LOAD_LOAD1_MASK         2U
  #define TMRC0_LOAD_LOAD2_MASK         4U
  #define TMRC0_LOAD_LOAD3_MASK         8U
  #define TMRC0_LOAD_LOAD4_MASK         16U
  #define TMRC0_LOAD_LOAD5_MASK         32U
  #define TMRC0_LOAD_LOAD6_MASK         64U
  #define TMRC0_LOAD_LOAD7_MASK         128U
  #define TMRC0_LOAD_LOAD8_MASK         256U
  #define TMRC0_LOAD_LOAD9_MASK         512U
  #define TMRC0_LOAD_LOAD10_MASK        1024U
  #define TMRC0_LOAD_LOAD11_MASK        2048U
  #define TMRC0_LOAD_LOAD12_MASK        4096U
  #define TMRC0_LOAD_LOAD13_MASK        8192U
  #define TMRC0_LOAD_LOAD14_MASK        16384U
  #define TMRC0_LOAD_LOAD15_MASK        32768U
  #define TMRC0_LOAD                    *((volatile word *)0x00000D43)


  /*** TMRC0_HOLD - Timer C Channel 0 Hold Register; 0x00000D44 ***/
  union {
    word Word;
  } TMRC0_HOLD_STR;
  
  #define TMRC0_HOLD_HOLD0_MASK         1U
  #define TMRC0_HOLD_HOLD1_MASK         2U
  #define TMRC0_HOLD_HOLD2_MASK         4U
  #define TMRC0_HOLD_HOLD3_MASK         8U
  #define TMRC0_HOLD_HOLD4_MASK         16U
  #define TMRC0_HOLD_HOLD5_MASK         32U
  #define TMRC0_HOLD_HOLD6_MASK         64U
  #define TMRC0_HOLD_HOLD7_MASK         128U
  #define TMRC0_HOLD_HOLD8_MASK         256U
  #define TMRC0_HOLD_HOLD9_MASK         512U
  #define TMRC0_HOLD_HOLD10_MASK        1024U
  #define TMRC0_HOLD_HOLD11_MASK        2048U
  #define TMRC0_HOLD_HOLD12_MASK        4096U
  #define TMRC0_HOLD_HOLD13_MASK        8192U
  #define TMRC0_HOLD_HOLD14_MASK        16384U
  #define TMRC0_HOLD_HOLD15_MASK        32768U
  #define TMRC0_HOLD                    *((volatile word *)0x00000D44)


  /*** TMRC0_CNTR - Timer C Channel 0 Counter Register; 0x00000D45 ***/
  union {
    word Word;
  } TMRC0_CNTR_STR;
  
  #define TMRC0_CNTR                    *((volatile word *)0x00000D45)


  /*** TMRC0_CTRL - Timer C Channel 0 Control Register; 0x00000D46 ***/
  union {
    word Word;
  } TMRC0_CTRL_STR;
  
  #define TMRC0_CTRL_OM0_MASK           1U
  #define TMRC0_CTRL_OM1_MASK           2U
  #define TMRC0_CTRL_OM2_MASK           4U
  #define TMRC0_CTRL_Co_INIT_MASK       8U
  #define TMRC0_CTRL_DIR_MASK           16U
  #define TMRC0_CTRL_LENGTH_MASK        32U
  #define TMRC0_CTRL_ONCE_MASK          64U
  #define TMRC0_CTRL_SCS0_MASK          128U
  #define TMRC0_CTRL_SCS1_MASK          256U
  #define TMRC0_CTRL_PCS0_MASK          512U
  #define TMRC0_CTRL_PCS1_MASK          1024U
  #define TMRC0_CTRL_PCS2_MASK          2048U
  #define TMRC0_CTRL_PCS3_MASK          4096U
  #define TMRC0_CTRL_CM0_MASK           8192U
  #define TMRC0_CTRL_CM1_MASK           16384U
  #define TMRC0_CTRL_CM2_MASK           32768U
  #define TMRC0_CTRL_OM_MASK            7U
  #define TMRC0_CTRL_OM_BITNUM          0U
  #define TMRC0_CTRL_SCS_MASK           384U
  #define TMRC0_CTRL_SCS_BITNUM         7U
  #define TMRC0_CTRL_PCS_MASK           7680U
  #define TMRC0_CTRL_PCS_BITNUM         9U
  #define TMRC0_CTRL_CM_MASK            57344U
  #define TMRC0_CTRL_CM_BITNUM          13U
  #define TMRC0_CTRL                    *((volatile word *)0x00000D46)


  /*** TMRC0_SCR - Timer C Channel 0 Status and Control Register; 0x00000D47 ***/
  union {
    word Word;
  } TMRC0_SCR_STR;
  
  #define TMRC0_SCR_OEN_MASK            1U
  #define TMRC0_SCR_OPS_MASK            2U
  #define TMRC0_SCR_FORCE_MASK          4U
  #define TMRC0_SCR_VAL_MASK            8U
  #define TMRC0_SCR_EEOF_MASK           16U
  #define TMRC0_SCR_MSTR_MASK           32U
  #define TMRC0_SCR_Capture_Mode0_MASK  64U
  #define TMRC0_SCR_Capture_Mode1_MASK  128U
  #define TMRC0_SCR_INPUT_MASK          256U
  #define TMRC0_SCR_IPS_MASK            512U
  #define TMRC0_SCR_IEFIE_MASK          1024U
  #define TMRC0_SCR_IEF_MASK            2048U
  #define TMRC0_SCR_TOFIE_MASK          4096U
  #define TMRC0_SCR_TOF_MASK            8192U
  #define TMRC0_SCR_TCFIE_MASK          16384U
  #define TMRC0_SCR_TCF_MASK            32768U
  #define TMRC0_SCR_Capture_Mode_MASK   192U
  #define TMRC0_SCR_Capture_Mode_BITNUM 6U
  #define TMRC0_SCR                     *((volatile word *)0x00000D47)


} TMRC0_PRPH;

/******************************************
*** Peripheral TMRC1
*******************************************/
typedef volatile struct {
  /*** TMRC1_CMP1 - Timer C Channel 1 Compare Register #1; 0x00000D48 ***/
  union {
    word Word;
  } TMRC1_CMP1_STR;
  
  #define TMRC1_CMP1                    *((volatile word *)0x00000D48)


  /*** TMRC1_CMP2 - Timer C Channel 1 Compare Register #2; 0x00000D49 ***/
  union {
    word Word;
  } TMRC1_CMP2_STR;
  
  #define TMRC1_CMP2                    *((volatile word *)0x00000D49)


  /*** TMRC1_CAP - Timer C Channel 1 Capture Register; 0x00000D4A ***/
  union {
    word Word;
  } TMRC1_CAP_STR;
  
  #define TMRC1_CAP                     *((volatile word *)0x00000D4A)


  /*** TMRC1_LOAD - Timer C Channel 1 Load Register; 0x00000D4B ***/
  union {
    word Word;
  } TMRC1_LOAD_STR;
  
  #define TMRC1_LOAD_LOAD0_MASK         1U
  #define TMRC1_LOAD_LOAD1_MASK         2U
  #define TMRC1_LOAD_LOAD2_MASK         4U
  #define TMRC1_LOAD_LOAD3_MASK         8U
  #define TMRC1_LOAD_LOAD4_MASK         16U
  #define TMRC1_LOAD_LOAD5_MASK         32U
  #define TMRC1_LOAD_LOAD6_MASK         64U
  #define TMRC1_LOAD_LOAD7_MASK         128U
  #define TMRC1_LOAD_LOAD8_MASK         256U
  #define TMRC1_LOAD_LOAD9_MASK         512U
  #define TMRC1_LOAD_LOAD10_MASK        1024U
  #define TMRC1_LOAD_LOAD11_MASK        2048U
  #define TMRC1_LOAD_LOAD12_MASK        4096U
  #define TMRC1_LOAD_LOAD13_MASK        8192U
  #define TMRC1_LOAD_LOAD14_MASK        16384U
  #define TMRC1_LOAD_LOAD15_MASK        32768U
  #define TMRC1_LOAD                    *((volatile word *)0x00000D4B)


  /*** TMRC1_HOLD - Timer C Channel 1 Hold Register; 0x00000D4C ***/
  union {
    word Word;
  } TMRC1_HOLD_STR;
  
  #define TMRC1_HOLD_HOLD0_MASK         1U
  #define TMRC1_HOLD_HOLD1_MASK         2U
  #define TMRC1_HOLD_HOLD2_MASK         4U
  #define TMRC1_HOLD_HOLD3_MASK         8U
  #define TMRC1_HOLD_HOLD4_MASK         16U
  #define TMRC1_HOLD_HOLD5_MASK         32U
  #define TMRC1_HOLD_HOLD6_MASK         64U
  #define TMRC1_HOLD_HOLD7_MASK         128U
  #define TMRC1_HOLD_HOLD8_MASK         256U
  #define TMRC1_HOLD_HOLD9_MASK         512U
  #define TMRC1_HOLD_HOLD10_MASK        1024U
  #define TMRC1_HOLD_HOLD11_MASK        2048U
  #define TMRC1_HOLD_HOLD12_MASK        4096U
  #define TMRC1_HOLD_HOLD13_MASK        8192U
  #define TMRC1_HOLD_HOLD14_MASK        16384U
  #define TMRC1_HOLD_HOLD15_MASK        32768U
  #define TMRC1_HOLD                    *((volatile word *)0x00000D4C)


  /*** TMRC1_CNTR - Timer C Channel 1 Counter Register; 0x00000D4D ***/
  union {
    word Word;
  } TMRC1_CNTR_STR;
  
  #define TMRC1_CNTR                    *((volatile word *)0x00000D4D)


  /*** TMRC1_CTRL - Timer C Channel 1 Control Register; 0x00000D4E ***/
  union {
    word Word;
  } TMRC1_CTRL_STR;
  
  #define TMRC1_CTRL_OM0_MASK           1U
  #define TMRC1_CTRL_OM1_MASK           2U
  #define TMRC1_CTRL_OM2_MASK           4U
  #define TMRC1_CTRL_Co_INIT_MASK       8U
  #define TMRC1_CTRL_DIR_MASK           16U
  #define TMRC1_CTRL_LENGTH_MASK        32U
  #define TMRC1_CTRL_ONCE_MASK          64U
  #define TMRC1_CTRL_SCS0_MASK          128U
  #define TMRC1_CTRL_SCS1_MASK          256U
  #define TMRC1_CTRL_PCS0_MASK          512U
  #define TMRC1_CTRL_PCS1_MASK          1024U
  #define TMRC1_CTRL_PCS2_MASK          2048U
  #define TMRC1_CTRL_PCS3_MASK          4096U
  #define TMRC1_CTRL_CM0_MASK           8192U
  #define TMRC1_CTRL_CM1_MASK           16384U
  #define TMRC1_CTRL_CM2_MASK           32768U
  #define TMRC1_CTRL_OM_MASK            7U
  #define TMRC1_CTRL_OM_BITNUM          0U
  #define TMRC1_CTRL_SCS_MASK           384U
  #define TMRC1_CTRL_SCS_BITNUM         7U
  #define TMRC1_CTRL_PCS_MASK           7680U
  #define TMRC1_CTRL_PCS_BITNUM         9U
  #define TMRC1_CTRL_CM_MASK            57344U
  #define TMRC1_CTRL_CM_BITNUM          13U
  #define TMRC1_CTRL                    *((volatile word *)0x00000D4E)


  /*** TMRC1_SCR - Timer C Channel 1 Status and Control Register; 0x00000D4F ***/
  union {
    word Word;
  } TMRC1_SCR_STR;
  
  #define TMRC1_SCR_OEN_MASK            1U
  #define TMRC1_SCR_OPS_MASK            2U
  #define TMRC1_SCR_FORCE_MASK          4U
  #define TMRC1_SCR_VAL_MASK            8U
  #define TMRC1_SCR_EEOF_MASK           16U
  #define TMRC1_SCR_MSTR_MASK           32U
  #define TMRC1_SCR_Capture_Mode0_MASK  64U
  #define TMRC1_SCR_Capture_Mode1_MASK  128U
  #define TMRC1_SCR_INPUT_MASK          256U
  #define TMRC1_SCR_IPS_MASK            512U
  #define TMRC1_SCR_IEFIE_MASK          1024U
  #define TMRC1_SCR_IEF_MASK            2048U
  #define TMRC1_SCR_TOFIE_MASK          4096U
  #define TMRC1_SCR_TOF_MASK            8192U
  #define TMRC1_SCR_TCFIE_MASK          16384U
  #define TMRC1_SCR_TCF_MASK            32768U
  #define TMRC1_SCR_Capture_Mode_MASK   192U
  #define TMRC1_SCR_Capture_Mode_BITNUM 6U
  #define TMRC1_SCR                     *((volatile word *)0x00000D4F)


} TMRC1_PRPH;

/******************************************
*** Peripheral TMRC2
*******************************************/
typedef volatile struct {
  /*** TMRC2_CMP1 - Timer C Channel 2 Compare Register #1; 0x00000D50 ***/
  union {
    word Word;
  } TMRC2_CMP1_STR;
  
  #define TMRC2_CMP1                    *((volatile word *)0x00000D50)


  /*** TMRC2_CMP2 - Timer C Channel 2 Compare Register #2; 0x00000D51 ***/
  union {
    word Word;
  } TMRC2_CMP2_STR;
  
  #define TMRC2_CMP2                    *((volatile word *)0x00000D51)


  /*** TMRC2_CAP - Timer C Channel 2 Capture Register; 0x00000D52 ***/
  union {
    word Word;
  } TMRC2_CAP_STR;
  
  #define TMRC2_CAP                     *((volatile word *)0x00000D52)


  /*** TMRC2_LOAD - Timer C Channel 2 Load Register; 0x00000D53 ***/
  union {
    word Word;
  } TMRC2_LOAD_STR;
  
  #define TMRC2_LOAD_LOAD0_MASK         1U
  #define TMRC2_LOAD_LOAD1_MASK         2U
  #define TMRC2_LOAD_LOAD2_MASK         4U
  #define TMRC2_LOAD_LOAD3_MASK         8U
  #define TMRC2_LOAD_LOAD4_MASK         16U
  #define TMRC2_LOAD_LOAD5_MASK         32U
  #define TMRC2_LOAD_LOAD6_MASK         64U
  #define TMRC2_LOAD_LOAD7_MASK         128U
  #define TMRC2_LOAD_LOAD8_MASK         256U
  #define TMRC2_LOAD_LOAD9_MASK         512U
  #define TMRC2_LOAD_LOAD10_MASK        1024U
  #define TMRC2_LOAD_LOAD11_MASK        2048U
  #define TMRC2_LOAD_LOAD12_MASK        4096U
  #define TMRC2_LOAD_LOAD13_MASK        8192U
  #define TMRC2_LOAD_LOAD14_MASK        16384U
  #define TMRC2_LOAD_LOAD15_MASK        32768U
  #define TMRC2_LOAD                    *((volatile word *)0x00000D53)


  /*** TMRC2_HOLD - Timer C Channel 2 Hold Register; 0x00000D54 ***/
  union {
    word Word;
  } TMRC2_HOLD_STR;
  
  #define TMRC2_HOLD_HOLD0_MASK         1U
  #define TMRC2_HOLD_HOLD1_MASK         2U
  #define TMRC2_HOLD_HOLD2_MASK         4U
  #define TMRC2_HOLD_HOLD3_MASK         8U
  #define TMRC2_HOLD_HOLD4_MASK         16U
  #define TMRC2_HOLD_HOLD5_MASK         32U
  #define TMRC2_HOLD_HOLD6_MASK         64U
  #define TMRC2_HOLD_HOLD7_MASK         128U
  #define TMRC2_HOLD_HOLD8_MASK         256U
  #define TMRC2_HOLD_HOLD9_MASK         512U
  #define TMRC2_HOLD_HOLD10_MASK        1024U
  #define TMRC2_HOLD_HOLD11_MASK        2048U
  #define TMRC2_HOLD_HOLD12_MASK        4096U
  #define TMRC2_HOLD_HOLD13_MASK        8192U
  #define TMRC2_HOLD_HOLD14_MASK        16384U
  #define TMRC2_HOLD_HOLD15_MASK        32768U
  #define TMRC2_HOLD                    *((volatile word *)0x00000D54)


  /*** TMRC2_CNTR - Timer C Channel 2 Counter Register; 0x00000D55 ***/
  union {
    word Word;
  } TMRC2_CNTR_STR;
  
  #define TMRC2_CNTR                    *((volatile word *)0x00000D55)


  /*** TMRC2_CTRL - Timer C Channel 2 Control Register; 0x00000D56 ***/
  union {
    word Word;
  } TMRC2_CTRL_STR;
  
  #define TMRC2_CTRL_OM0_MASK           1U
  #define TMRC2_CTRL_OM1_MASK           2U
  #define TMRC2_CTRL_OM2_MASK           4U
  #define TMRC2_CTRL_Co_INIT_MASK       8U
  #define TMRC2_CTRL_DIR_MASK           16U
  #define TMRC2_CTRL_LENGTH_MASK        32U
  #define TMRC2_CTRL_ONCE_MASK          64U
  #define TMRC2_CTRL_SCS0_MASK          128U
  #define TMRC2_CTRL_SCS1_MASK          256U
  #define TMRC2_CTRL_PCS0_MASK          512U
  #define TMRC2_CTRL_PCS1_MASK          1024U
  #define TMRC2_CTRL_PCS2_MASK          2048U
  #define TMRC2_CTRL_PCS3_MASK          4096U
  #define TMRC2_CTRL_CM0_MASK           8192U
  #define TMRC2_CTRL_CM1_MASK           16384U
  #define TMRC2_CTRL_CM2_MASK           32768U
  #define TMRC2_CTRL_OM_MASK            7U
  #define TMRC2_CTRL_OM_BITNUM          0U
  #define TMRC2_CTRL_SCS_MASK           384U
  #define TMRC2_CTRL_SCS_BITNUM         7U
  #define TMRC2_CTRL_PCS_MASK           7680U
  #define TMRC2_CTRL_PCS_BITNUM         9U
  #define TMRC2_CTRL_CM_MASK            57344U
  #define TMRC2_CTRL_CM_BITNUM          13U
  #define TMRC2_CTRL                    *((volatile word *)0x00000D56)


  /*** TMRC2_SCR - Timer C Channel 2 Status and Control Register; 0x00000D57 ***/
  union {
    word Word;
  } TMRC2_SCR_STR;
  
  #define TMRC2_SCR_OEN_MASK            1U
  #define TMRC2_SCR_OPS_MASK            2U
  #define TMRC2_SCR_FORCE_MASK          4U
  #define TMRC2_SCR_VAL_MASK            8U
  #define TMRC2_SCR_EEOF_MASK           16U
  #define TMRC2_SCR_MSTR_MASK           32U
  #define TMRC2_SCR_Capture_Mode0_MASK  64U
  #define TMRC2_SCR_Capture_Mode1_MASK  128U
  #define TMRC2_SCR_INPUT_MASK          256U
  #define TMRC2_SCR_IPS_MASK            512U
  #define TMRC2_SCR_IEFIE_MASK          1024U
  #define TMRC2_SCR_IEF_MASK            2048U
  #define TMRC2_SCR_TOFIE_MASK          4096U
  #define TMRC2_SCR_TOF_MASK            8192U
  #define TMRC2_SCR_TCFIE_MASK          16384U
  #define TMRC2_SCR_TCF_MASK            32768U
  #define TMRC2_SCR_Capture_Mode_MASK   192U
  #define TMRC2_SCR_Capture_Mode_BITNUM 6U
  #define TMRC2_SCR                     *((volatile word *)0x00000D57)


} TMRC2_PRPH;

/******************************************
*** Peripheral TMRC3
*******************************************/
typedef volatile struct {
  /*** TMRC3_CMP1 - Timer C Channel 3 Compare Register #1; 0x00000D58 ***/
  union {
    word Word;
  } TMRC3_CMP1_STR;
  
  #define TMRC3_CMP1                    *((volatile word *)0x00000D58)


  /*** TMRC3_CMP2 - Timer C Channel 3 Compare Register #2; 0x00000D59 ***/
  union {
    word Word;
  } TMRC3_CMP2_STR;
  
  #define TMRC3_CMP2                    *((volatile word *)0x00000D59)


  /*** TMRC3_CAP - Timer C Channel 3 Capture Register; 0x00000D5A ***/
  union {
    word Word;
  } TMRC3_CAP_STR;
  
  #define TMRC3_CAP                     *((volatile word *)0x00000D5A)


  /*** TMRC3_LOAD - Timer C Channel 3 Load Register; 0x00000D5B ***/
  union {
    word Word;
  } TMRC3_LOAD_STR;
  
  #define TMRC3_LOAD_LOAD0_MASK         1U
  #define TMRC3_LOAD_LOAD1_MASK         2U
  #define TMRC3_LOAD_LOAD2_MASK         4U
  #define TMRC3_LOAD_LOAD3_MASK         8U
  #define TMRC3_LOAD_LOAD4_MASK         16U
  #define TMRC3_LOAD_LOAD5_MASK         32U
  #define TMRC3_LOAD_LOAD6_MASK         64U
  #define TMRC3_LOAD_LOAD7_MASK         128U
  #define TMRC3_LOAD_LOAD8_MASK         256U
  #define TMRC3_LOAD_LOAD9_MASK         512U
  #define TMRC3_LOAD_LOAD10_MASK        1024U
  #define TMRC3_LOAD_LOAD11_MASK        2048U
  #define TMRC3_LOAD_LOAD12_MASK        4096U
  #define TMRC3_LOAD_LOAD13_MASK        8192U
  #define TMRC3_LOAD_LOAD14_MASK        16384U
  #define TMRC3_LOAD_LOAD15_MASK        32768U
  #define TMRC3_LOAD                    *((volatile word *)0x00000D5B)


  /*** TMRC3_HOLD - Timer C Channel 3 Hold Register; 0x00000D5C ***/
  union {
    word Word;
  } TMRC3_HOLD_STR;
  
  #define TMRC3_HOLD_HOLD0_MASK         1U
  #define TMRC3_HOLD_HOLD1_MASK         2U
  #define TMRC3_HOLD_HOLD2_MASK         4U
  #define TMRC3_HOLD_HOLD3_MASK         8U
  #define TMRC3_HOLD_HOLD4_MASK         16U
  #define TMRC3_HOLD_HOLD5_MASK         32U
  #define TMRC3_HOLD_HOLD6_MASK         64U
  #define TMRC3_HOLD_HOLD7_MASK         128U
  #define TMRC3_HOLD_HOLD8_MASK         256U
  #define TMRC3_HOLD_HOLD9_MASK         512U
  #define TMRC3_HOLD_HOLD10_MASK        1024U
  #define TMRC3_HOLD_HOLD11_MASK        2048U
  #define TMRC3_HOLD_HOLD12_MASK        4096U
  #define TMRC3_HOLD_HOLD13_MASK        8192U
  #define TMRC3_HOLD_HOLD14_MASK        16384U
  #define TMRC3_HOLD_HOLD15_MASK        32768U
  #define TMRC3_HOLD                    *((volatile word *)0x00000D5C)


  /*** TMRC3_CNTR - Timer C Channel 3 Counter Register; 0x00000D5D ***/
  union {
    word Word;
  } TMRC3_CNTR_STR;
  
  #define TMRC3_CNTR                    *((volatile word *)0x00000D5D)


  /*** TMRC3_CTRL - Timer C Channel 3 Control Register; 0x00000D5E ***/
  union {
    word Word;
  } TMRC3_CTRL_STR;
  
  #define TMRC3_CTRL_OM0_MASK           1U
  #define TMRC3_CTRL_OM1_MASK           2U
  #define TMRC3_CTRL_OM2_MASK           4U
  #define TMRC3_CTRL_Co_INIT_MASK       8U
  #define TMRC3_CTRL_DIR_MASK           16U
  #define TMRC3_CTRL_LENGTH_MASK        32U
  #define TMRC3_CTRL_ONCE_MASK          64U
  #define TMRC3_CTRL_SCS0_MASK          128U
  #define TMRC3_CTRL_SCS1_MASK          256U
  #define TMRC3_CTRL_PCS0_MASK          512U
  #define TMRC3_CTRL_PCS1_MASK          1024U
  #define TMRC3_CTRL_PCS2_MASK          2048U
  #define TMRC3_CTRL_PCS3_MASK          4096U
  #define TMRC3_CTRL_CM0_MASK           8192U
  #define TMRC3_CTRL_CM1_MASK           16384U
  #define TMRC3_CTRL_CM2_MASK           32768U
  #define TMRC3_CTRL_OM_MASK            7U
  #define TMRC3_CTRL_OM_BITNUM          0U
  #define TMRC3_CTRL_SCS_MASK           384U
  #define TMRC3_CTRL_SCS_BITNUM         7U
  #define TMRC3_CTRL_PCS_MASK           7680U
  #define TMRC3_CTRL_PCS_BITNUM         9U
  #define TMRC3_CTRL_CM_MASK            57344U
  #define TMRC3_CTRL_CM_BITNUM          13U
  #define TMRC3_CTRL                    *((volatile word *)0x00000D5E)


  /*** TMRC3_SCR - Timer C Channel 3 Status and Control Register; 0x00000D5F ***/
  union {
    word Word;
  } TMRC3_SCR_STR;
  
  #define TMRC3_SCR_OEN_MASK            1U
  #define TMRC3_SCR_OPS_MASK            2U
  #define TMRC3_SCR_FORCE_MASK          4U
  #define TMRC3_SCR_VAL_MASK            8U
  #define TMRC3_SCR_EEOF_MASK           16U
  #define TMRC3_SCR_MSTR_MASK           32U
  #define TMRC3_SCR_Capture_Mode0_MASK  64U
  #define TMRC3_SCR_Capture_Mode1_MASK  128U
  #define TMRC3_SCR_INPUT_MASK          256U
  #define TMRC3_SCR_IPS_MASK            512U
  #define TMRC3_SCR_IEFIE_MASK          1024U
  #define TMRC3_SCR_IEF_MASK            2048U
  #define TMRC3_SCR_TOFIE_MASK          4096U
  #define TMRC3_SCR_TOF_MASK            8192U
  #define TMRC3_SCR_TCFIE_MASK          16384U
  #define TMRC3_SCR_TCF_MASK            32768U
  #define TMRC3_SCR_Capture_Mode_MASK   192U
  #define TMRC3_SCR_Capture_Mode_BITNUM 6U
  #define TMRC3_SCR                     *((volatile word *)0x00000D5F)


} TMRC3_PRPH;

/******************************************
*** Peripheral TMRD0
*******************************************/
typedef volatile struct {
  /*** TMRD0_CMP1 - Timer D Channel 0 Compare Register #1; 0x00000D60 ***/
  union {
    word Word;
  } TMRD0_CMP1_STR;
  
  #define TMRD0_CMP1                    *((volatile word *)0x00000D60)


  /*** TMRD0_CMP2 - Timer D Channel 0 Compare Register #2; 0x00000D61 ***/
  union {
    word Word;
  } TMRD0_CMP2_STR;
  
  #define TMRD0_CMP2                    *((volatile word *)0x00000D61)


  /*** TMRD0_CAP - Timer D Channel 0 Capture Register; 0x00000D62 ***/
  union {
    word Word;
  } TMRD0_CAP_STR;
  
  #define TMRD0_CAP                     *((volatile word *)0x00000D62)


  /*** TMRD0_LOAD - Timer D Channel 0 Load Register; 0x00000D63 ***/
  union {
    word Word;
  } TMRD0_LOAD_STR;
  
  #define TMRD0_LOAD_LOAD0_MASK         1U
  #define TMRD0_LOAD_LOAD1_MASK         2U
  #define TMRD0_LOAD_LOAD2_MASK         4U
  #define TMRD0_LOAD_LOAD3_MASK         8U
  #define TMRD0_LOAD_LOAD4_MASK         16U
  #define TMRD0_LOAD_LOAD5_MASK         32U
  #define TMRD0_LOAD_LOAD6_MASK         64U
  #define TMRD0_LOAD_LOAD7_MASK         128U
  #define TMRD0_LOAD_LOAD8_MASK         256U
  #define TMRD0_LOAD_LOAD9_MASK         512U
  #define TMRD0_LOAD_LOAD10_MASK        1024U
  #define TMRD0_LOAD_LOAD11_MASK        2048U
  #define TMRD0_LOAD_LOAD12_MASK        4096U
  #define TMRD0_LOAD_LOAD13_MASK        8192U
  #define TMRD0_LOAD_LOAD14_MASK        16384U
  #define TMRD0_LOAD_LOAD15_MASK        32768U
  #define TMRD0_LOAD                    *((volatile word *)0x00000D63)


  /*** TMRD0_HOLD - Timer D Channel 0 Hold Register; 0x00000D64 ***/
  union {
    word Word;
  } TMRD0_HOLD_STR;
  
  #define TMRD0_HOLD_HOLD0_MASK         1U
  #define TMRD0_HOLD_HOLD1_MASK         2U
  #define TMRD0_HOLD_HOLD2_MASK         4U
  #define TMRD0_HOLD_HOLD3_MASK         8U
  #define TMRD0_HOLD_HOLD4_MASK         16U
  #define TMRD0_HOLD_HOLD5_MASK         32U
  #define TMRD0_HOLD_HOLD6_MASK         64U
  #define TMRD0_HOLD_HOLD7_MASK         128U
  #define TMRD0_HOLD_HOLD8_MASK         256U
  #define TMRD0_HOLD_HOLD9_MASK         512U
  #define TMRD0_HOLD_HOLD10_MASK        1024U
  #define TMRD0_HOLD_HOLD11_MASK        2048U
  #define TMRD0_HOLD_HOLD12_MASK        4096U
  #define TMRD0_HOLD_HOLD13_MASK        8192U
  #define TMRD0_HOLD_HOLD14_MASK        16384U
  #define TMRD0_HOLD_HOLD15_MASK        32768U
  #define TMRD0_HOLD                    *((volatile word *)0x00000D64)


  /*** TMRD0_CNTR - Timer D Channel 0 Counter Register; 0x00000D65 ***/
  union {
    word Word;
  } TMRD0_CNTR_STR;
  
  #define TMRD0_CNTR                    *((volatile word *)0x00000D65)


  /*** TMRD0_CTRL - Timer D Channel 0 Control Register; 0x00000D66 ***/
  union {
    word Word;
  } TMRD0_CTRL_STR;
  
  #define TMRD0_CTRL_OM0_MASK           1U
  #define TMRD0_CTRL_OM1_MASK           2U
  #define TMRD0_CTRL_OM2_MASK           4U
  #define TMRD0_CTRL_Co_INIT_MASK       8U
  #define TMRD0_CTRL_DIR_MASK           16U
  #define TMRD0_CTRL_LENGTH_MASK        32U
  #define TMRD0_CTRL_ONCE_MASK          64U
  #define TMRD0_CTRL_SCS0_MASK          128U
  #define TMRD0_CTRL_SCS1_MASK          256U
  #define TMRD0_CTRL_PCS0_MASK          512U
  #define TMRD0_CTRL_PCS1_MASK          1024U
  #define TMRD0_CTRL_PCS2_MASK          2048U
  #define TMRD0_CTRL_PCS3_MASK          4096U
  #define TMRD0_CTRL_CM0_MASK           8192U
  #define TMRD0_CTRL_CM1_MASK           16384U
  #define TMRD0_CTRL_CM2_MASK           32768U
  #define TMRD0_CTRL_OM_MASK            7U
  #define TMRD0_CTRL_OM_BITNUM          0U
  #define TMRD0_CTRL_SCS_MASK           384U
  #define TMRD0_CTRL_SCS_BITNUM         7U
  #define TMRD0_CTRL_PCS_MASK           7680U
  #define TMRD0_CTRL_PCS_BITNUM         9U
  #define TMRD0_CTRL_CM_MASK            57344U
  #define TMRD0_CTRL_CM_BITNUM          13U
  #define TMRD0_CTRL                    *((volatile word *)0x00000D66)


  /*** TMRD0_SCR - Timer D Channel 0 Status and Control Register; 0x00000D67 ***/
  union {
    word Word;
  } TMRD0_SCR_STR;
  
  #define TMRD0_SCR_OEN_MASK            1U
  #define TMRD0_SCR_OPS_MASK            2U
  #define TMRD0_SCR_FORCE_MASK          4U
  #define TMRD0_SCR_VAL_MASK            8U
  #define TMRD0_SCR_EEOF_MASK           16U
  #define TMRD0_SCR_MSTR_MASK           32U
  #define TMRD0_SCR_Capture_Mode0_MASK  64U
  #define TMRD0_SCR_Capture_Mode1_MASK  128U
  #define TMRD0_SCR_INPUT_MASK          256U
  #define TMRD0_SCR_IPS_MASK            512U
  #define TMRD0_SCR_IEFIE_MASK          1024U
  #define TMRD0_SCR_IEF_MASK            2048U
  #define TMRD0_SCR_TOFIE_MASK          4096U
  #define TMRD0_SCR_TOF_MASK            8192U
  #define TMRD0_SCR_TCFIE_MASK          16384U
  #define TMRD0_SCR_TCF_MASK            32768U
  #define TMRD0_SCR_Capture_Mode_MASK   192U
  #define TMRD0_SCR_Capture_Mode_BITNUM 6U
  #define TMRD0_SCR                     *((volatile word *)0x00000D67)


} TMRD0_PRPH;

/******************************************
*** Peripheral TMRD1
*******************************************/
typedef volatile struct {
  /*** TMRD1_CMP1 - Timer D Channel 1 Compare Register #1; 0x00000D68 ***/
  union {
    word Word;
  } TMRD1_CMP1_STR;
  
  #define TMRD1_CMP1                    *((volatile word *)0x00000D68)


  /*** TMRD1_CMP2 - Timer D Channel 1 Compare Register #2; 0x00000D69 ***/
  union {
    word Word;
  } TMRD1_CMP2_STR;
  
  #define TMRD1_CMP2                    *((volatile word *)0x00000D69)


  /*** TMRD1_CAP - Timer D Channel 1 Capture Register; 0x00000D6A ***/
  union {
    word Word;
  } TMRD1_CAP_STR;
  
  #define TMRD1_CAP                     *((volatile word *)0x00000D6A)


  /*** TMRD1_LOAD - Timer D Channel 1 Load Register; 0x00000D6B ***/
  union {
    word Word;
  } TMRD1_LOAD_STR;
  
  #define TMRD1_LOAD_LOAD0_MASK         1U
  #define TMRD1_LOAD_LOAD1_MASK         2U
  #define TMRD1_LOAD_LOAD2_MASK         4U
  #define TMRD1_LOAD_LOAD3_MASK         8U
  #define TMRD1_LOAD_LOAD4_MASK         16U
  #define TMRD1_LOAD_LOAD5_MASK         32U
  #define TMRD1_LOAD_LOAD6_MASK         64U
  #define TMRD1_LOAD_LOAD7_MASK         128U
  #define TMRD1_LOAD_LOAD8_MASK         256U
  #define TMRD1_LOAD_LOAD9_MASK         512U
  #define TMRD1_LOAD_LOAD10_MASK        1024U
  #define TMRD1_LOAD_LOAD11_MASK        2048U
  #define TMRD1_LOAD_LOAD12_MASK        4096U
  #define TMRD1_LOAD_LOAD13_MASK        8192U
  #define TMRD1_LOAD_LOAD14_MASK        16384U
  #define TMRD1_LOAD_LOAD15_MASK        32768U
  #define TMRD1_LOAD                    *((volatile word *)0x00000D6B)


  /*** TMRD1_HOLD - Timer D Channel 1 Hold Register; 0x00000D6C ***/
  union {
    word Word;
  } TMRD1_HOLD_STR;
  
  #define TMRD1_HOLD_HOLD0_MASK         1U
  #define TMRD1_HOLD_HOLD1_MASK         2U
  #define TMRD1_HOLD_HOLD2_MASK         4U
  #define TMRD1_HOLD_HOLD3_MASK         8U
  #define TMRD1_HOLD_HOLD4_MASK         16U
  #define TMRD1_HOLD_HOLD5_MASK         32U
  #define TMRD1_HOLD_HOLD6_MASK         64U
  #define TMRD1_HOLD_HOLD7_MASK         128U
  #define TMRD1_HOLD_HOLD8_MASK         256U
  #define TMRD1_HOLD_HOLD9_MASK         512U
  #define TMRD1_HOLD_HOLD10_MASK        1024U
  #define TMRD1_HOLD_HOLD11_MASK        2048U
  #define TMRD1_HOLD_HOLD12_MASK        4096U
  #define TMRD1_HOLD_HOLD13_MASK        8192U
  #define TMRD1_HOLD_HOLD14_MASK        16384U
  #define TMRD1_HOLD_HOLD15_MASK        32768U
  #define TMRD1_HOLD                    *((volatile word *)0x00000D6C)


  /*** TMRD1_CNTR - Timer D Channel 1 Counter Register; 0x00000D6D ***/
  union {
    word Word;
  } TMRD1_CNTR_STR;
  
  #define TMRD1_CNTR                    *((volatile word *)0x00000D6D)


  /*** TMRD1_CTRL - Timer D Channel 1 Control Register; 0x00000D6E ***/
  union {
    word Word;
  } TMRD1_CTRL_STR;
  
  #define TMRD1_CTRL_OM0_MASK           1U
  #define TMRD1_CTRL_OM1_MASK           2U
  #define TMRD1_CTRL_OM2_MASK           4U
  #define TMRD1_CTRL_Co_INIT_MASK       8U
  #define TMRD1_CTRL_DIR_MASK           16U
  #define TMRD1_CTRL_LENGTH_MASK        32U
  #define TMRD1_CTRL_ONCE_MASK          64U
  #define TMRD1_CTRL_SCS0_MASK          128U
  #define TMRD1_CTRL_SCS1_MASK          256U
  #define TMRD1_CTRL_PCS0_MASK          512U
  #define TMRD1_CTRL_PCS1_MASK          1024U
  #define TMRD1_CTRL_PCS2_MASK          2048U
  #define TMRD1_CTRL_PCS3_MASK          4096U
  #define TMRD1_CTRL_CM0_MASK           8192U
  #define TMRD1_CTRL_CM1_MASK           16384U
  #define TMRD1_CTRL_CM2_MASK           32768U
  #define TMRD1_CTRL_OM_MASK            7U
  #define TMRD1_CTRL_OM_BITNUM          0U
  #define TMRD1_CTRL_SCS_MASK           384U
  #define TMRD1_CTRL_SCS_BITNUM         7U
  #define TMRD1_CTRL_PCS_MASK           7680U
  #define TMRD1_CTRL_PCS_BITNUM         9U
  #define TMRD1_CTRL_CM_MASK            57344U
  #define TMRD1_CTRL_CM_BITNUM          13U
  #define TMRD1_CTRL                    *((volatile word *)0x00000D6E)


  /*** TMRD1_SCR - Timer D Channel 1 Status and Control Register; 0x00000D6F ***/
  union {
    word Word;
  } TMRD1_SCR_STR;
  
  #define TMRD1_SCR_OEN_MASK            1U
  #define TMRD1_SCR_OPS_MASK            2U
  #define TMRD1_SCR_FORCE_MASK          4U
  #define TMRD1_SCR_VAL_MASK            8U
  #define TMRD1_SCR_EEOF_MASK           16U
  #define TMRD1_SCR_MSTR_MASK           32U
  #define TMRD1_SCR_Capture_Mode0_MASK  64U
  #define TMRD1_SCR_Capture_Mode1_MASK  128U
  #define TMRD1_SCR_INPUT_MASK          256U
  #define TMRD1_SCR_IPS_MASK            512U
  #define TMRD1_SCR_IEFIE_MASK          1024U
  #define TMRD1_SCR_IEF_MASK            2048U
  #define TMRD1_SCR_TOFIE_MASK          4096U
  #define TMRD1_SCR_TOF_MASK            8192U
  #define TMRD1_SCR_TCFIE_MASK          16384U
  #define TMRD1_SCR_TCF_MASK            32768U
  #define TMRD1_SCR_Capture_Mode_MASK   192U
  #define TMRD1_SCR_Capture_Mode_BITNUM 6U
  #define TMRD1_SCR                     *((volatile word *)0x00000D6F)


} TMRD1_PRPH;

/******************************************
*** Peripheral TMRD2
*******************************************/
typedef volatile struct {
  /*** TMRD2_CMP1 - Timer D Channel 2 Compare Register #1; 0x00000D70 ***/
  union {
    word Word;
  } TMRD2_CMP1_STR;
  
  #define TMRD2_CMP1                    *((volatile word *)0x00000D70)


  /*** TMRD2_CMP2 - Timer D Channel 2 Compare Register #2; 0x00000D71 ***/
  union {
    word Word;
  } TMRD2_CMP2_STR;
  
  #define TMRD2_CMP2                    *((volatile word *)0x00000D71)


  /*** TMRD2_CAP - Timer D Channel 2 Capture Register; 0x00000D72 ***/
  union {
    word Word;
  } TMRD2_CAP_STR;
  
  #define TMRD2_CAP                     *((volatile word *)0x00000D72)


  /*** TMRD2_LOAD - Timer D Channel 2 Load Register; 0x00000D73 ***/
  union {
    word Word;
  } TMRD2_LOAD_STR;
  
  #define TMRD2_LOAD_LOAD0_MASK         1U
  #define TMRD2_LOAD_LOAD1_MASK         2U
  #define TMRD2_LOAD_LOAD2_MASK         4U
  #define TMRD2_LOAD_LOAD3_MASK         8U
  #define TMRD2_LOAD_LOAD4_MASK         16U
  #define TMRD2_LOAD_LOAD5_MASK         32U
  #define TMRD2_LOAD_LOAD6_MASK         64U
  #define TMRD2_LOAD_LOAD7_MASK         128U
  #define TMRD2_LOAD_LOAD8_MASK         256U
  #define TMRD2_LOAD_LOAD9_MASK         512U
  #define TMRD2_LOAD_LOAD10_MASK        1024U
  #define TMRD2_LOAD_LOAD11_MASK        2048U
  #define TMRD2_LOAD_LOAD12_MASK        4096U
  #define TMRD2_LOAD_LOAD13_MASK        8192U
  #define TMRD2_LOAD_LOAD14_MASK        16384U
  #define TMRD2_LOAD_LOAD15_MASK        32768U
  #define TMRD2_LOAD                    *((volatile word *)0x00000D73)


  /*** TMRD2_HOLD - Timer D Channel 2 Hold Register; 0x00000D74 ***/
  union {
    word Word;
  } TMRD2_HOLD_STR;
  
  #define TMRD2_HOLD_HOLD0_MASK         1U
  #define TMRD2_HOLD_HOLD1_MASK         2U
  #define TMRD2_HOLD_HOLD2_MASK         4U
  #define TMRD2_HOLD_HOLD3_MASK         8U
  #define TMRD2_HOLD_HOLD4_MASK         16U
  #define TMRD2_HOLD_HOLD5_MASK         32U
  #define TMRD2_HOLD_HOLD6_MASK         64U
  #define TMRD2_HOLD_HOLD7_MASK         128U
  #define TMRD2_HOLD_HOLD8_MASK         256U
  #define TMRD2_HOLD_HOLD9_MASK         512U
  #define TMRD2_HOLD_HOLD10_MASK        1024U
  #define TMRD2_HOLD_HOLD11_MASK        2048U
  #define TMRD2_HOLD_HOLD12_MASK        4096U
  #define TMRD2_HOLD_HOLD13_MASK        8192U
  #define TMRD2_HOLD_HOLD14_MASK        16384U
  #define TMRD2_HOLD_HOLD15_MASK        32768U
  #define TMRD2_HOLD                    *((volatile word *)0x00000D74)


  /*** TMRD2_CNTR - Timer D Channel 2 Counter Register; 0x00000D75 ***/
  union {
    word Word;
  } TMRD2_CNTR_STR;
  
  #define TMRD2_CNTR                    *((volatile word *)0x00000D75)


  /*** TMRD2_CTRL - Timer D Channel 2 Control Register; 0x00000D76 ***/
  union {
    word Word;
  } TMRD2_CTRL_STR;
  
  #define TMRD2_CTRL_OM0_MASK           1U
  #define TMRD2_CTRL_OM1_MASK           2U
  #define TMRD2_CTRL_OM2_MASK           4U
  #define TMRD2_CTRL_Co_INIT_MASK       8U
  #define TMRD2_CTRL_DIR_MASK           16U
  #define TMRD2_CTRL_LENGTH_MASK        32U
  #define TMRD2_CTRL_ONCE_MASK          64U
  #define TMRD2_CTRL_SCS0_MASK          128U
  #define TMRD2_CTRL_SCS1_MASK          256U
  #define TMRD2_CTRL_PCS0_MASK          512U
  #define TMRD2_CTRL_PCS1_MASK          1024U
  #define TMRD2_CTRL_PCS2_MASK          2048U
  #define TMRD2_CTRL_PCS3_MASK          4096U
  #define TMRD2_CTRL_CM0_MASK           8192U
  #define TMRD2_CTRL_CM1_MASK           16384U
  #define TMRD2_CTRL_CM2_MASK           32768U
  #define TMRD2_CTRL_OM_MASK            7U
  #define TMRD2_CTRL_OM_BITNUM          0U
  #define TMRD2_CTRL_SCS_MASK           384U
  #define TMRD2_CTRL_SCS_BITNUM         7U
  #define TMRD2_CTRL_PCS_MASK           7680U
  #define TMRD2_CTRL_PCS_BITNUM         9U
  #define TMRD2_CTRL_CM_MASK            57344U
  #define TMRD2_CTRL_CM_BITNUM          13U
  #define TMRD2_CTRL                    *((volatile word *)0x00000D76)


  /*** TMRD2_SCR - Timer D Channel 2 Status and Control Register; 0x00000D77 ***/
  union {
    word Word;
  } TMRD2_SCR_STR;
  
  #define TMRD2_SCR_OEN_MASK            1U
  #define TMRD2_SCR_OPS_MASK            2U
  #define TMRD2_SCR_FORCE_MASK          4U
  #define TMRD2_SCR_VAL_MASK            8U
  #define TMRD2_SCR_EEOF_MASK           16U
  #define TMRD2_SCR_MSTR_MASK           32U
  #define TMRD2_SCR_Capture_Mode0_MASK  64U
  #define TMRD2_SCR_Capture_Mode1_MASK  128U
  #define TMRD2_SCR_INPUT_MASK          256U
  #define TMRD2_SCR_IPS_MASK            512U
  #define TMRD2_SCR_IEFIE_MASK          1024U
  #define TMRD2_SCR_IEF_MASK            2048U
  #define TMRD2_SCR_TOFIE_MASK          4096U
  #define TMRD2_SCR_TOF_MASK            8192U
  #define TMRD2_SCR_TCFIE_MASK          16384U
  #define TMRD2_SCR_TCF_MASK            32768U
  #define TMRD2_SCR_Capture_Mode_MASK   192U
  #define TMRD2_SCR_Capture_Mode_BITNUM 6U
  #define TMRD2_SCR                     *((volatile word *)0x00000D77)


} TMRD2_PRPH;

/******************************************
*** Peripheral TMRD3
*******************************************/
typedef volatile struct {
  /*** TMRD3_CMP1 - Timer D Channel 3 Compare Register #1; 0x00000D78 ***/
  union {
    word Word;
  } TMRD3_CMP1_STR;
  
  #define TMRD3_CMP1                    *((volatile word *)0x00000D78)


  /*** TMRD3_CMP2 - Timer D Channel 3 Compare Register #2; 0x00000D79 ***/
  union {
    word Word;
  } TMRD3_CMP2_STR;
  
  #define TMRD3_CMP2                    *((volatile word *)0x00000D79)


  /*** TMRD3_CAP - Timer D Channel 3 Capture Register; 0x00000D7A ***/
  union {
    word Word;
  } TMRD3_CAP_STR;
  
  #define TMRD3_CAP                     *((volatile word *)0x00000D7A)


  /*** TMRD3_LOAD - Timer D Channel 3 Load Register; 0x00000D7B ***/
  union {
    word Word;
  } TMRD3_LOAD_STR;
  
  #define TMRD3_LOAD_LOAD0_MASK         1U
  #define TMRD3_LOAD_LOAD1_MASK         2U
  #define TMRD3_LOAD_LOAD2_MASK         4U
  #define TMRD3_LOAD_LOAD3_MASK         8U
  #define TMRD3_LOAD_LOAD4_MASK         16U
  #define TMRD3_LOAD_LOAD5_MASK         32U
  #define TMRD3_LOAD_LOAD6_MASK         64U
  #define TMRD3_LOAD_LOAD7_MASK         128U
  #define TMRD3_LOAD_LOAD8_MASK         256U
  #define TMRD3_LOAD_LOAD9_MASK         512U
  #define TMRD3_LOAD_LOAD10_MASK        1024U
  #define TMRD3_LOAD_LOAD11_MASK        2048U
  #define TMRD3_LOAD_LOAD12_MASK        4096U
  #define TMRD3_LOAD_LOAD13_MASK        8192U
  #define TMRD3_LOAD_LOAD14_MASK        16384U
  #define TMRD3_LOAD_LOAD15_MASK        32768U
  #define TMRD3_LOAD                    *((volatile word *)0x00000D7B)


  /*** TMRD3_HOLD - Timer D Channel 3 Hold Register; 0x00000D7C ***/
  union {
    word Word;
  } TMRD3_HOLD_STR;
  
  #define TMRD3_HOLD_HOLD0_MASK         1U
  #define TMRD3_HOLD_HOLD1_MASK         2U
  #define TMRD3_HOLD_HOLD2_MASK         4U
  #define TMRD3_HOLD_HOLD3_MASK         8U
  #define TMRD3_HOLD_HOLD4_MASK         16U
  #define TMRD3_HOLD_HOLD5_MASK         32U
  #define TMRD3_HOLD_HOLD6_MASK         64U
  #define TMRD3_HOLD_HOLD7_MASK         128U
  #define TMRD3_HOLD_HOLD8_MASK         256U
  #define TMRD3_HOLD_HOLD9_MASK         512U
  #define TMRD3_HOLD_HOLD10_MASK        1024U
  #define TMRD3_HOLD_HOLD11_MASK        2048U
  #define TMRD3_HOLD_HOLD12_MASK        4096U
  #define TMRD3_HOLD_HOLD13_MASK        8192U
  #define TMRD3_HOLD_HOLD14_MASK        16384U
  #define TMRD3_HOLD_HOLD15_MASK        32768U
  #define TMRD3_HOLD                    *((volatile word *)0x00000D7C)


  /*** TMRD3_CNTR - Timer D Channel 3 Counter Register; 0x00000D7D ***/
  union {
    word Word;
  } TMRD3_CNTR_STR;
  
  #define TMRD3_CNTR                    *((volatile word *)0x00000D7D)


  /*** TMRD3_CTRL - Timer D Channel 3 Control Register; 0x00000D7E ***/
  union {
    word Word;
  } TMRD3_CTRL_STR;
  
  #define TMRD3_CTRL_OM0_MASK           1U
  #define TMRD3_CTRL_OM1_MASK           2U
  #define TMRD3_CTRL_OM2_MASK           4U
  #define TMRD3_CTRL_Co_INIT_MASK       8U
  #define TMRD3_CTRL_DIR_MASK           16U
  #define TMRD3_CTRL_LENGTH_MASK        32U
  #define TMRD3_CTRL_ONCE_MASK          64U
  #define TMRD3_CTRL_SCS0_MASK          128U
  #define TMRD3_CTRL_SCS1_MASK          256U
  #define TMRD3_CTRL_PCS0_MASK          512U
  #define TMRD3_CTRL_PCS1_MASK          1024U
  #define TMRD3_CTRL_PCS2_MASK          2048U
  #define TMRD3_CTRL_PCS3_MASK          4096U
  #define TMRD3_CTRL_CM0_MASK           8192U
  #define TMRD3_CTRL_CM1_MASK           16384U
  #define TMRD3_CTRL_CM2_MASK           32768U
  #define TMRD3_CTRL_OM_MASK            7U
  #define TMRD3_CTRL_OM_BITNUM          0U
  #define TMRD3_CTRL_SCS_MASK           384U
  #define TMRD3_CTRL_SCS_BITNUM         7U
  #define TMRD3_CTRL_PCS_MASK           7680U
  #define TMRD3_CTRL_PCS_BITNUM         9U
  #define TMRD3_CTRL_CM_MASK            57344U
  #define TMRD3_CTRL_CM_BITNUM          13U
  #define TMRD3_CTRL                    *((volatile word *)0x00000D7E)


  /*** TMRD3_SCR - Timer D Channel 3 Status and Control Register; 0x00000D7F ***/
  union {
    word Word;
  } TMRD3_SCR_STR;
  
  #define TMRD3_SCR_OEN_MASK            1U
  #define TMRD3_SCR_OPS_MASK            2U
  #define TMRD3_SCR_FORCE_MASK          4U
  #define TMRD3_SCR_VAL_MASK            8U
  #define TMRD3_SCR_EEOF_MASK           16U
  #define TMRD3_SCR_MSTR_MASK           32U
  #define TMRD3_SCR_Capture_Mode0_MASK  64U
  #define TMRD3_SCR_Capture_Mode1_MASK  128U
  #define TMRD3_SCR_INPUT_MASK          256U
  #define TMRD3_SCR_IPS_MASK            512U
  #define TMRD3_SCR_IEFIE_MASK          1024U
  #define TMRD3_SCR_IEF_MASK            2048U
  #define TMRD3_SCR_TOFIE_MASK          4096U
  #define TMRD3_SCR_TOF_MASK            8192U
  #define TMRD3_SCR_TCFIE_MASK          16384U
  #define TMRD3_SCR_TCF_MASK            32768U
  #define TMRD3_SCR_Capture_Mode_MASK   192U
  #define TMRD3_SCR_Capture_Mode_BITNUM 6U
  #define TMRD3_SCR                     *((volatile word *)0x00000D7F)


  word Reserved0[128];                 /* Reserved (unused) registers */

} TMRD3_PRPH;

/******************************************
*** Peripheral PWMA
*******************************************/
typedef volatile struct {
  /*** PWMA_PMCTL - PWMA control register; 0x00000E00 ***/
  union {
    word Word;
  } PWMA_PMCTL_STR;
  
  #define PWMA_PMCTL_PWMEN_MASK         1U
  #define PWMA_PMCTL_LDOK_MASK          2U
  #define PWMA_PMCTL_ISENS0_MASK        4U
  #define PWMA_PMCTL_ISENS1_MASK        8U
  #define PWMA_PMCTL_PWMF_MASK          16U
  #define PWMA_PMCTL_PWMRIE_MASK        32U
  #define PWMA_PMCTL_PRSC0_MASK         64U
  #define PWMA_PMCTL_PRSC1_MASK         128U
  #define PWMA_PMCTL_IPOL0_MASK         256U
  #define PWMA_PMCTL_IPOL1_MASK         512U
  #define PWMA_PMCTL_IPOL2_MASK         1024U
  #define PWMA_PMCTL_HALF_MASK          2048U
  #define PWMA_PMCTL_LDFQ0_MASK         4096U
  #define PWMA_PMCTL_LDFQ1_MASK         8192U
  #define PWMA_PMCTL_LDFQ2_MASK         16384U
  #define PWMA_PMCTL_LDFQ3_MASK         32768U
  #define PWMA_PMCTL_ISENS_MASK         12U
  #define PWMA_PMCTL_ISENS_BITNUM       2U
  #define PWMA_PMCTL_PRSC_MASK          192U
  #define PWMA_PMCTL_PRSC_BITNUM        6U
  #define PWMA_PMCTL_IPOL_MASK          1792U
  #define PWMA_PMCTL_IPOL_BITNUM        8U
  #define PWMA_PMCTL_LDFQ_MASK          61440U
  #define PWMA_PMCTL_LDFQ_BITNUM        12U
  #define PWMA_PMCTL                    *((volatile word *)0x00000E00)


  /*** PWMA_PMFCTL - PWMA fault control register; 0x00000E01 ***/
  union {
    word Word;
  } PWMA_PMFCTL_STR;
  
  #define PWMA_PMFCTL_FMODE0_MASK       1U
  #define PWMA_PMFCTL_FIE0_MASK         2U
  #define PWMA_PMFCTL_FMODE1_MASK       4U
  #define PWMA_PMFCTL_FIE1_MASK         8U
  #define PWMA_PMFCTL_FMODE2_MASK       16U
  #define PWMA_PMFCTL_FIE2_MASK         32U
  #define PWMA_PMFCTL_FMODE3_MASK       64U
  #define PWMA_PMFCTL_FIE3_MASK         128U
  #define PWMA_PMFCTL                   *((volatile word *)0x00000E01)


  /*** PWMA_PMFSA - PWMA fault status acknowledge; 0x00000E02 ***/
  union {
    word Word;
  } PWMA_PMFSA_STR;
  
  #define PWMA_PMFSA_DT0_FTACK0_MASK    1U
  #define PWMA_PMFSA_DT1_MASK           2U
  #define PWMA_PMFSA_DT2_FTACK1_MASK    4U
  #define PWMA_PMFSA_DT3_MASK           8U
  #define PWMA_PMFSA_DT4_FTACK2_MASK    16U
  #define PWMA_PMFSA_DT5_MASK           32U
  #define PWMA_PMFSA_FTACK3_MASK        64U
  #define PWMA_PMFSA_FFLAG0_MASK        256U
  #define PWMA_PMFSA_FPIN0_MASK         512U
  #define PWMA_PMFSA_FFLAG1_MASK        1024U
  #define PWMA_PMFSA_FPIN1_MASK         2048U
  #define PWMA_PMFSA_FFLAG2_MASK        4096U
  #define PWMA_PMFSA_FPIN2_MASK         8192U
  #define PWMA_PMFSA_FFLAG3_MASK        16384U
  #define PWMA_PMFSA_FPIN3_MASK         32768U
  #define PWMA_PMFSA                    *((volatile word *)0x00000E02)


  /*** PWMA_PMOUT - PWMA output control register; 0x00000E03 ***/
  union {
    word Word;
  } PWMA_PMOUT_STR;
  
  #define PWMA_PMOUT_OUT0_MASK          1U
  #define PWMA_PMOUT_OUT1_MASK          2U
  #define PWMA_PMOUT_OUT2_MASK          4U
  #define PWMA_PMOUT_OUT3_MASK          8U
  #define PWMA_PMOUT_OUT4_MASK          16U
  #define PWMA_PMOUT_OUT5_MASK          32U
  #define PWMA_PMOUT_OUTCTL0_MASK       256U
  #define PWMA_PMOUT_OUTCTL1_MASK       512U
  #define PWMA_PMOUT_OUTCTL2_MASK       1024U
  #define PWMA_PMOUT_OUTCTL3_MASK       2048U
  #define PWMA_PMOUT_OUTCTL4_MASK       4096U
  #define PWMA_PMOUT_OUTCTL5_MASK       8192U
  #define PWMA_PMOUT_PAD_EN_MASK        32768U
  #define PWMA_PMOUT_OUT_MASK           63U
  #define PWMA_PMOUT_OUT_BITNUM         0U
  #define PWMA_PMOUT_OUTCTL_MASK        16128U
  #define PWMA_PMOUT_OUTCTL_BITNUM      8U
  #define PWMA_PMOUT                    *((volatile word *)0x00000E03)


  /*** PWMA_PMCNT - PWMA counter register; 0x00000E04 ***/
  union {
    word Word;
  } PWMA_PMCNT_STR;
  
  #define PWMA_PMCNT_CR0_MASK           1U
  #define PWMA_PMCNT_CR1_MASK           2U
  #define PWMA_PMCNT_CR2_MASK           4U
  #define PWMA_PMCNT_CR3_MASK           8U
  #define PWMA_PMCNT_CR4_MASK           16U
  #define PWMA_PMCNT_CR5_MASK           32U
  #define PWMA_PMCNT_CR6_MASK           64U
  #define PWMA_PMCNT_CR7_MASK           128U
  #define PWMA_PMCNT_CR8_MASK           256U
  #define PWMA_PMCNT_CR9_MASK           512U
  #define PWMA_PMCNT_CR10_MASK          1024U
  #define PWMA_PMCNT_CR11_MASK          2048U
  #define PWMA_PMCNT_CR12_MASK          4096U
  #define PWMA_PMCNT_CR13_MASK          8192U
  #define PWMA_PMCNT_CR14_MASK          16384U
  #define PWMA_PMCNT_CR_MASK            32767U
  #define PWMA_PMCNT_CR_BITNUM          0U
  #define PWMA_PMCNT                    *((volatile word *)0x00000E04)


  /*** PWMA_PWMCM - PWMA counter modulo register; 0x00000E05 ***/
  union {
    word Word;
  } PWMA_PWMCM_STR;
  
  #define PWMA_PWMCM_PWMCM0_MASK        1U
  #define PWMA_PWMCM_PWMCM1_MASK        2U
  #define PWMA_PWMCM_PWMCM2_MASK        4U
  #define PWMA_PWMCM_PWMCM3_MASK        8U
  #define PWMA_PWMCM_PWMCM4_MASK        16U
  #define PWMA_PWMCM_PWMCM5_MASK        32U
  #define PWMA_PWMCM_PWMCM6_MASK        64U
  #define PWMA_PWMCM_PWMCM7_MASK        128U
  #define PWMA_PWMCM_PWMCM8_MASK        256U
  #define PWMA_PWMCM_PWMCM9_MASK        512U
  #define PWMA_PWMCM_PWMCM10_MASK       1024U
  #define PWMA_PWMCM_PWMCM11_MASK       2048U
  #define PWMA_PWMCM_PWMCM12_MASK       4096U
  #define PWMA_PWMCM_PWMCM13_MASK       8192U
  #define PWMA_PWMCM_PWMCM14_MASK       16384U
  #define PWMA_PWMCM_PWMCM_MASK         32767U
  #define PWMA_PWMCM_PWMCM_BITNUM       0U
  #define PWMA_PWMCM                    *((volatile word *)0x00000E05)


  /*** PWMA_PWMVAL0 - PWMA value register 0; 0x00000E06 ***/
  union {
    word Word;
  } PWMA_PWMVAL0_STR;
  
  #define PWMA_PWMVAL0_PWMVAL0_MASK     1U
  #define PWMA_PWMVAL0_PWMVAL1_MASK     2U
  #define PWMA_PWMVAL0_PWMVAL2_MASK     4U
  #define PWMA_PWMVAL0_PWMVAL3_MASK     8U
  #define PWMA_PWMVAL0_PWMVAL4_MASK     16U
  #define PWMA_PWMVAL0_PWMVAL5_MASK     32U
  #define PWMA_PWMVAL0_PWMVAL6_MASK     64U
  #define PWMA_PWMVAL0_PWMVAL7_MASK     128U
  #define PWMA_PWMVAL0_PWMVAL8_MASK     256U
  #define PWMA_PWMVAL0_PWMVAL9_MASK     512U
  #define PWMA_PWMVAL0_PWMVAL10_MASK    1024U
  #define PWMA_PWMVAL0_PWMVAL11_MASK    2048U
  #define PWMA_PWMVAL0_PWMVAL12_MASK    4096U
  #define PWMA_PWMVAL0_PWMVAL13_MASK    8192U
  #define PWMA_PWMVAL0_PWMVAL14_MASK    16384U
  #define PWMA_PWMVAL0_PWMVAL15_MASK    32768U
  #define PWMA_PWMVAL0                  *((volatile word *)0x00000E06)


  /*** PWMA_PWMVAL1 - PWMA value register 1; 0x00000E07 ***/
  union {
    word Word;
  } PWMA_PWMVAL1_STR;
  
  #define PWMA_PWMVAL1_PWMVAL0_MASK     1U
  #define PWMA_PWMVAL1_PWMVAL1_MASK     2U
  #define PWMA_PWMVAL1_PWMVAL2_MASK     4U
  #define PWMA_PWMVAL1_PWMVAL3_MASK     8U
  #define PWMA_PWMVAL1_PWMVAL4_MASK     16U
  #define PWMA_PWMVAL1_PWMVAL5_MASK     32U
  #define PWMA_PWMVAL1_PWMVAL6_MASK     64U
  #define PWMA_PWMVAL1_PWMVAL7_MASK     128U
  #define PWMA_PWMVAL1_PWMVAL8_MASK     256U
  #define PWMA_PWMVAL1_PWMVAL9_MASK     512U
  #define PWMA_PWMVAL1_PWMVAL10_MASK    1024U
  #define PWMA_PWMVAL1_PWMVAL11_MASK    2048U
  #define PWMA_PWMVAL1_PWMVAL12_MASK    4096U
  #define PWMA_PWMVAL1_PWMVAL13_MASK    8192U
  #define PWMA_PWMVAL1_PWMVAL14_MASK    16384U
  #define PWMA_PWMVAL1_PWMVAL15_MASK    32768U
  #define PWMA_PWMVAL1                  *((volatile word *)0x00000E07)


  /*** PWMA_PWMVAL2 - PWMA value register 2; 0x00000E08 ***/
  union {
    word Word;
  } PWMA_PWMVAL2_STR;
  
  #define PWMA_PWMVAL2_PWMVAL0_MASK     1U
  #define PWMA_PWMVAL2_PWMVAL1_MASK     2U
  #define PWMA_PWMVAL2_PWMVAL2_MASK     4U
  #define PWMA_PWMVAL2_PWMVAL3_MASK     8U
  #define PWMA_PWMVAL2_PWMVAL4_MASK     16U
  #define PWMA_PWMVAL2_PWMVAL5_MASK     32U
  #define PWMA_PWMVAL2_PWMVAL6_MASK     64U
  #define PWMA_PWMVAL2_PWMVAL7_MASK     128U
  #define PWMA_PWMVAL2_PWMVAL8_MASK     256U
  #define PWMA_PWMVAL2_PWMVAL9_MASK     512U
  #define PWMA_PWMVAL2_PWMVAL10_MASK    1024U
  #define PWMA_PWMVAL2_PWMVAL11_MASK    2048U
  #define PWMA_PWMVAL2_PWMVAL12_MASK    4096U
  #define PWMA_PWMVAL2_PWMVAL13_MASK    8192U
  #define PWMA_PWMVAL2_PWMVAL14_MASK    16384U
  #define PWMA_PWMVAL2_PWMVAL15_MASK    32768U
  #define PWMA_PWMVAL2                  *((volatile word *)0x00000E08)


  /*** PWMA_PWMVAL3 - PWMA value register 3; 0x00000E09 ***/
  union {
    word Word;
  } PWMA_PWMVAL3_STR;
  
  #define PWMA_PWMVAL3_PWMVAL0_MASK     1U
  #define PWMA_PWMVAL3_PWMVAL1_MASK     2U
  #define PWMA_PWMVAL3_PWMVAL2_MASK     4U
  #define PWMA_PWMVAL3_PWMVAL3_MASK     8U
  #define PWMA_PWMVAL3_PWMVAL4_MASK     16U
  #define PWMA_PWMVAL3_PWMVAL5_MASK     32U
  #define PWMA_PWMVAL3_PWMVAL6_MASK     64U
  #define PWMA_PWMVAL3_PWMVAL7_MASK     128U
  #define PWMA_PWMVAL3_PWMVAL8_MASK     256U
  #define PWMA_PWMVAL3_PWMVAL9_MASK     512U
  #define PWMA_PWMVAL3_PWMVAL10_MASK    1024U
  #define PWMA_PWMVAL3_PWMVAL11_MASK    2048U
  #define PWMA_PWMVAL3_PWMVAL12_MASK    4096U
  #define PWMA_PWMVAL3_PWMVAL13_MASK    8192U
  #define PWMA_PWMVAL3_PWMVAL14_MASK    16384U
  #define PWMA_PWMVAL3_PWMVAL15_MASK    32768U
  #define PWMA_PWMVAL3                  *((volatile word *)0x00000E09)


  /*** PWMA_PWMVAL4 - PWMA value register 4; 0x00000E0A ***/
  union {
    word Word;
  } PWMA_PWMVAL4_STR;
  
  #define PWMA_PWMVAL4_PWMVAL0_MASK     1U
  #define PWMA_PWMVAL4_PWMVAL1_MASK     2U
  #define PWMA_PWMVAL4_PWMVAL2_MASK     4U
  #define PWMA_PWMVAL4_PWMVAL3_MASK     8U
  #define PWMA_PWMVAL4_PWMVAL4_MASK     16U
  #define PWMA_PWMVAL4_PWMVAL5_MASK     32U
  #define PWMA_PWMVAL4_PWMVAL6_MASK     64U
  #define PWMA_PWMVAL4_PWMVAL7_MASK     128U
  #define PWMA_PWMVAL4_PWMVAL8_MASK     256U
  #define PWMA_PWMVAL4_PWMVAL9_MASK     512U
  #define PWMA_PWMVAL4_PWMVAL10_MASK    1024U
  #define PWMA_PWMVAL4_PWMVAL11_MASK    2048U
  #define PWMA_PWMVAL4_PWMVAL12_MASK    4096U
  #define PWMA_PWMVAL4_PWMVAL13_MASK    8192U
  #define PWMA_PWMVAL4_PWMVAL14_MASK    16384U
  #define PWMA_PWMVAL4_PWMVAL15_MASK    32768U
  #define PWMA_PWMVAL4                  *((volatile word *)0x00000E0A)


  /*** PWMA_PWMVAL5 - PWMA value register 5; 0x00000E0B ***/
  union {
    word Word;
  } PWMA_PWMVAL5_STR;
  
  #define PWMA_PWMVAL5_PWMVAL0_MASK     1U
  #define PWMA_PWMVAL5_PWMVAL1_MASK     2U
  #define PWMA_PWMVAL5_PWMVAL2_MASK     4U
  #define PWMA_PWMVAL5_PWMVAL3_MASK     8U
  #define PWMA_PWMVAL5_PWMVAL4_MASK     16U
  #define PWMA_PWMVAL5_PWMVAL5_MASK     32U
  #define PWMA_PWMVAL5_PWMVAL6_MASK     64U
  #define PWMA_PWMVAL5_PWMVAL7_MASK     128U
  #define PWMA_PWMVAL5_PWMVAL8_MASK     256U
  #define PWMA_PWMVAL5_PWMVAL9_MASK     512U
  #define PWMA_PWMVAL5_PWMVAL10_MASK    1024U
  #define PWMA_PWMVAL5_PWMVAL11_MASK    2048U
  #define PWMA_PWMVAL5_PWMVAL12_MASK    4096U
  #define PWMA_PWMVAL5_PWMVAL13_MASK    8192U
  #define PWMA_PWMVAL5_PWMVAL14_MASK    16384U
  #define PWMA_PWMVAL5_PWMVAL15_MASK    32768U
  #define PWMA_PWMVAL5                  *((volatile word *)0x00000E0B)


  /*** PWMA_PMDEADTM - PWMA deadtime register; 0x00000E0C ***/
  union {
    word Word;
  } PWMA_PMDEADTM_STR;
  
  #define PWMA_PMDEADTM_PWMDT0_MASK     1U
  #define PWMA_PMDEADTM_PWMDT1_MASK     2U
  #define PWMA_PMDEADTM_PWMDT2_MASK     4U
  #define PWMA_PMDEADTM_PWMDT3_MASK     8U
  #define PWMA_PMDEADTM_PWMDT4_MASK     16U
  #define PWMA_PMDEADTM_PWMDT5_MASK     32U
  #define PWMA_PMDEADTM_PWMDT6_MASK     64U
  #define PWMA_PMDEADTM_PWMDT7_MASK     128U
  #define PWMA_PMDEADTM_PWMDT_MASK      255U
  #define PWMA_PMDEADTM_PWMDT_BITNUM    0U
  #define PWMA_PMDEADTM                 *((volatile word *)0x00000E0C)


  /*** PWMA_PMDISMAP1 - PWMA disable mapping register one; 0x00000E0D ***/
  union {
    word Word;
  } PWMA_PMDISMAP1_STR;
  
  #define PWMA_PMDISMAP1_DISMAP0_MASK   1U
  #define PWMA_PMDISMAP1_DISMAP1_MASK   2U
  #define PWMA_PMDISMAP1_DISMAP2_MASK   4U
  #define PWMA_PMDISMAP1_DISMAP3_MASK   8U
  #define PWMA_PMDISMAP1_DISMAP4_MASK   16U
  #define PWMA_PMDISMAP1_DISMAP5_MASK   32U
  #define PWMA_PMDISMAP1_DISMAP6_MASK   64U
  #define PWMA_PMDISMAP1_DISMAP7_MASK   128U
  #define PWMA_PMDISMAP1_DISMAP8_MASK   256U
  #define PWMA_PMDISMAP1_DISMAP9_MASK   512U
  #define PWMA_PMDISMAP1_DISMAP10_MASK  1024U
  #define PWMA_PMDISMAP1_DISMAP11_MASK  2048U
  #define PWMA_PMDISMAP1_DISMAP12_MASK  4096U
  #define PWMA_PMDISMAP1_DISMAP13_MASK  8192U
  #define PWMA_PMDISMAP1_DISMAP14_MASK  16384U
  #define PWMA_PMDISMAP1_DISMAP15_MASK  32768U
  #define PWMA_PMDISMAP1                *((volatile word *)0x00000E0D)


  /*** PWMA_PMDISMAP2 - PWMA disable mapping register two; 0x00000E0E ***/
  union {
    word Word;
  } PWMA_PMDISMAP2_STR;
  
  #define PWMA_PMDISMAP2_DISMAP0_MASK   1U
  #define PWMA_PMDISMAP2_DISMAP1_MASK   2U
  #define PWMA_PMDISMAP2_DISMAP2_MASK   4U
  #define PWMA_PMDISMAP2_DISMAP3_MASK   8U
  #define PWMA_PMDISMAP2_DISMAP4_MASK   16U
  #define PWMA_PMDISMAP2_DISMAP5_MASK   32U
  #define PWMA_PMDISMAP2_DISMAP6_MASK   64U
  #define PWMA_PMDISMAP2_DISMAP7_MASK   128U
  #define PWMA_PMDISMAP2_DISMAP_MASK    255U
  #define PWMA_PMDISMAP2_DISMAP_BITNUM  0U
  #define PWMA_PMDISMAP2                *((volatile word *)0x00000E0E)


  /*** PWMA_PMCFG - PWMA config register; 0x00000E0F ***/
  union {
    word Word;
  } PWMA_PMCFG_STR;
  
  #define PWMA_PMCFG_WP_MASK            1U
  #define PWMA_PMCFG_INDEP01_MASK       2U
  #define PWMA_PMCFG_INDEP23_MASK       4U
  #define PWMA_PMCFG_INDEP45_MASK       8U
  #define PWMA_PMCFG_BOTNEG01_MASK      16U
  #define PWMA_PMCFG_BOTNEG23_MASK      32U
  #define PWMA_PMCFG_BOTNEG45_MASK      64U
  #define PWMA_PMCFG_TOPNEG01_MASK      256U
  #define PWMA_PMCFG_TOPNEG23_MASK      512U
  #define PWMA_PMCFG_TOPNEG45_MASK      1024U
  #define PWMA_PMCFG_EDG_MASK           4096U
  #define PWMA_PMCFG                    *((volatile word *)0x00000E0F)


  /*** PWMA_PMCCR - PWMA channel control register; 0x00000E10 ***/
  union {
    word Word;
  } PWMA_PMCCR_STR;
  
  #define PWMA_PMCCR_SWP01_MASK         1U
  #define PWMA_PMCCR_SWP23_MASK         2U
  #define PWMA_PMCCR_SWP45_MASK         4U
  #define PWMA_PMCCR_VLMODE0_MASK       16U
  #define PWMA_PMCCR_VLMODE1_MASK       32U
  #define PWMA_PMCCR_MSK0_MASK          256U
  #define PWMA_PMCCR_MSK1_MASK          512U
  #define PWMA_PMCCR_MSK2_MASK          1024U
  #define PWMA_PMCCR_MSK3_MASK          2048U
  #define PWMA_PMCCR_MSK4_MASK          4096U
  #define PWMA_PMCCR_MSK5_MASK          8192U
  #define PWMA_PMCCR_ENHA_MASK          32768U
  #define PWMA_PMCCR_VLMODE_MASK        48U
  #define PWMA_PMCCR_VLMODE_BITNUM      4U
  #define PWMA_PMCCR_MSK_MASK           16128U
  #define PWMA_PMCCR_MSK_BITNUM         8U
  #define PWMA_PMCCR                    *((volatile word *)0x00000E10)


  /*** PWMA_PMPORT - PWMA port register; 0x00000E11 ***/
  union {
    word Word;
  } PWMA_PMPORT_STR;
  
  #define PWMA_PMPORT_PORT0_MASK        1U
  #define PWMA_PMPORT_PORT1_MASK        2U
  #define PWMA_PMPORT_PORT2_MASK        4U
  #define PWMA_PMPORT_PORT3_MASK        8U
  #define PWMA_PMPORT_PORT4_MASK        16U
  #define PWMA_PMPORT_PORT5_MASK        32U
  #define PWMA_PMPORT_PORT6_MASK        64U
  #define PWMA_PMPORT_PORT_MASK         127U
  #define PWMA_PMPORT_PORT_BITNUM       0U
  #define PWMA_PMPORT                   *((volatile word *)0x00000E11)


  word Reserved0[80];                  /* Reserved (unused) registers */

} PWMA_PRPH;

/******************************************
*** Peripheral ITCN
*******************************************/
typedef volatile struct {
  /*** GPR2 - Group Priority Register 2; 0x00000E62 ***/
  union {
    word Word;
  } GPR2_STR;
  
  #define GPR2_PLR100_MASK              256U
  #define GPR2_PLR101_MASK              512U
  #define GPR2_PLR102_MASK              1024U
  #define GPR2_PLR110_MASK              4096U
  #define GPR2_PLR111_MASK              8192U
  #define GPR2_PLR112_MASK              16384U
  #define GPR2_PLR10_MASK               1792U
  #define GPR2_PLR10_BITNUM             8U
  #define GPR2_PLR11_MASK               28672U
  #define GPR2_PLR11_BITNUM             12U
  #define GPR2                          *((volatile word *)0x00000E62)


  /*** GPR3 - Group Priority Register 3; 0x00000E63 ***/
  union {
    word Word;
  } GPR3_STR;
  
  #define GPR3_PLR120_MASK              1U
  #define GPR3_PLR121_MASK              2U
  #define GPR3_PLR122_MASK              4U
  #define GPR3_PLR130_MASK              16U
  #define GPR3_PLR131_MASK              32U
  #define GPR3_PLR132_MASK              64U
  #define GPR3_PLR140_MASK              256U
  #define GPR3_PLR141_MASK              512U
  #define GPR3_PLR142_MASK              1024U
  #define GPR3_PLR150_MASK              4096U
  #define GPR3_PLR151_MASK              8192U
  #define GPR3_PLR152_MASK              16384U
  #define GPR3_PLR12_MASK               7U
  #define GPR3_PLR12_BITNUM             0U
  #define GPR3_PLR13_MASK               112U
  #define GPR3_PLR13_BITNUM             4U
  #define GPR3_PLR14_MASK               1792U
  #define GPR3_PLR14_BITNUM             8U
  #define GPR3_PLR15_MASK               28672U
  #define GPR3_PLR15_BITNUM             12U
  #define GPR3                          *((volatile word *)0x00000E63)


  /*** GPR4 - Group Priority Register 4; 0x00000E64 ***/
  union {
    word Word;
  } GPR4_STR;
  
  #define GPR4_PLR160_MASK              1U
  #define GPR4_PLR161_MASK              2U
  #define GPR4_PLR162_MASK              4U
  #define GPR4_PLR170_MASK              16U
  #define GPR4_PLR171_MASK              32U
  #define GPR4_PLR172_MASK              64U
  #define GPR4_PLR180_MASK              256U
  #define GPR4_PLR181_MASK              512U
  #define GPR4_PLR182_MASK              1024U
  #define GPR4_PLR190_MASK              4096U
  #define GPR4_PLR191_MASK              8192U
  #define GPR4_PLR192_MASK              16384U
  #define GPR4_PLR16_MASK               7U
  #define GPR4_PLR16_BITNUM             0U
  #define GPR4_PLR17_MASK               112U
  #define GPR4_PLR17_BITNUM             4U
  #define GPR4_PLR18_MASK               1792U
  #define GPR4_PLR18_BITNUM             8U
  #define GPR4_PLR19_MASK               28672U
  #define GPR4_PLR19_BITNUM             12U
  #define GPR4                          *((volatile word *)0x00000E64)


  /*** GPR5 - Group Priority Register 5; 0x00000E65 ***/
  union {
    word Word;
  } GPR5_STR;
  
  #define GPR5_PLR200_MASK              1U
  #define GPR5_PLR201_MASK              2U
  #define GPR5_PLR202_MASK              4U
  #define GPR5_PLR210_MASK              16U
  #define GPR5_PLR211_MASK              32U
  #define GPR5_PLR212_MASK              64U
  #define GPR5_PLR220_MASK              256U
  #define GPR5_PLR221_MASK              512U
  #define GPR5_PLR222_MASK              1024U
  #define GPR5_PLR230_MASK              4096U
  #define GPR5_PLR231_MASK              8192U
  #define GPR5_PLR232_MASK              16384U
  #define GPR5_PLR20_MASK               7U
  #define GPR5_PLR20_BITNUM             0U
  #define GPR5_PLR21_MASK               112U
  #define GPR5_PLR21_BITNUM             4U
  #define GPR5_PLR22_MASK               1792U
  #define GPR5_PLR22_BITNUM             8U
  #define GPR5_PLR23_MASK               28672U
  #define GPR5_PLR23_BITNUM             12U
  #define GPR5                          *((volatile word *)0x00000E65)


  /*** GPR6 - Group Priority Register 6; 0x00000E66 ***/
  union {
    word Word;
  } GPR6_STR;
  
  #define GPR6_PLR240_MASK              1U
  #define GPR6_PLR241_MASK              2U
  #define GPR6_PLR242_MASK              4U
  #define GPR6_PLR250_MASK              16U
  #define GPR6_PLR251_MASK              32U
  #define GPR6_PLR252_MASK              64U
  #define GPR6_PLR260_MASK              256U
  #define GPR6_PLR261_MASK              512U
  #define GPR6_PLR262_MASK              1024U
  #define GPR6_PLR270_MASK              4096U
  #define GPR6_PLR271_MASK              8192U
  #define GPR6_PLR272_MASK              16384U
  #define GPR6_PLR24_MASK               7U
  #define GPR6_PLR24_BITNUM             0U
  #define GPR6_PLR25_MASK               112U
  #define GPR6_PLR25_BITNUM             4U
  #define GPR6_PLR26_MASK               1792U
  #define GPR6_PLR26_BITNUM             8U
  #define GPR6_PLR27_MASK               28672U
  #define GPR6_PLR27_BITNUM             12U
  #define GPR6                          *((volatile word *)0x00000E66)


  /*** GPR7 - Group Priority Register 7; 0x00000E67 ***/
  union {
    word Word;
  } GPR7_STR;
  
  #define GPR7_PLR280_MASK              1U
  #define GPR7_PLR281_MASK              2U
  #define GPR7_PLR282_MASK              4U
  #define GPR7_PLR290_MASK              16U
  #define GPR7_PLR291_MASK              32U
  #define GPR7_PLR292_MASK              64U
  #define GPR7_PLR300_MASK              256U
  #define GPR7_PLR301_MASK              512U
  #define GPR7_PLR302_MASK              1024U
  #define GPR7_PLR310_MASK              4096U
  #define GPR7_PLR311_MASK              8192U
  #define GPR7_PLR312_MASK              16384U
  #define GPR7_PLR28_MASK               7U
  #define GPR7_PLR28_BITNUM             0U
  #define GPR7_PLR29_MASK               112U
  #define GPR7_PLR29_BITNUM             4U
  #define GPR7_PLR30_MASK               1792U
  #define GPR7_PLR30_BITNUM             8U
  #define GPR7_PLR31_MASK               28672U
  #define GPR7_PLR31_BITNUM             12U
  #define GPR7                          *((volatile word *)0x00000E67)


  /*** GPR8 - Group Priority Register 8; 0x00000E68 ***/
  union {
    word Word;
  } GPR8_STR;
  
  #define GPR8_PLR320_MASK              1U
  #define GPR8_PLR321_MASK              2U
  #define GPR8_PLR322_MASK              4U
  #define GPR8_PLR330_MASK              16U
  #define GPR8_PLR331_MASK              32U
  #define GPR8_PLR332_MASK              64U
  #define GPR8_PLR340_MASK              256U
  #define GPR8_PLR341_MASK              512U
  #define GPR8_PLR342_MASK              1024U
  #define GPR8_PLR350_MASK              4096U
  #define GPR8_PLR351_MASK              8192U
  #define GPR8_PLR352_MASK              16384U
  #define GPR8_PLR32_MASK               7U
  #define GPR8_PLR32_BITNUM             0U
  #define GPR8_PLR33_MASK               112U
  #define GPR8_PLR33_BITNUM             4U
  #define GPR8_PLR34_MASK               1792U
  #define GPR8_PLR34_BITNUM             8U
  #define GPR8_PLR35_MASK               28672U
  #define GPR8_PLR35_BITNUM             12U
  #define GPR8                          *((volatile word *)0x00000E68)


  /*** GPR9 - Group Priority Register 9; 0x00000E69 ***/
  union {
    word Word;
  } GPR9_STR;
  
  #define GPR9_PLR360_MASK              1U
  #define GPR9_PLR361_MASK              2U
  #define GPR9_PLR362_MASK              4U
  #define GPR9_PLR370_MASK              16U
  #define GPR9_PLR371_MASK              32U
  #define GPR9_PLR372_MASK              64U
  #define GPR9_PLR380_MASK              256U
  #define GPR9_PLR381_MASK              512U
  #define GPR9_PLR382_MASK              1024U
  #define GPR9_PLR390_MASK              4096U
  #define GPR9_PLR391_MASK              8192U
  #define GPR9_PLR392_MASK              16384U
  #define GPR9_PLR36_MASK               7U
  #define GPR9_PLR36_BITNUM             0U
  #define GPR9_PLR37_MASK               112U
  #define GPR9_PLR37_BITNUM             4U
  #define GPR9_PLR38_MASK               1792U
  #define GPR9_PLR38_BITNUM             8U
  #define GPR9_PLR39_MASK               28672U
  #define GPR9_PLR39_BITNUM             12U
  #define GPR9                          *((volatile word *)0x00000E69)


  /*** GPR10 - Group Priority Register 10; 0x00000E6A ***/
  union {
    word Word;
  } GPR10_STR;
  
  #define GPR10_PLR400_MASK             1U
  #define GPR10_PLR401_MASK             2U
  #define GPR10_PLR402_MASK             4U
  #define GPR10_PLR410_MASK             16U
  #define GPR10_PLR411_MASK             32U
  #define GPR10_PLR412_MASK             64U
  #define GPR10_PLR420_MASK             256U
  #define GPR10_PLR421_MASK             512U
  #define GPR10_PLR422_MASK             1024U
  #define GPR10_PLR430_MASK             4096U
  #define GPR10_PLR431_MASK             8192U
  #define GPR10_PLR432_MASK             16384U
  #define GPR10_PLR40_MASK              7U
  #define GPR10_PLR40_BITNUM            0U
  #define GPR10_PLR41_MASK              112U
  #define GPR10_PLR41_BITNUM            4U
  #define GPR10_PLR42_MASK              1792U
  #define GPR10_PLR42_BITNUM            8U
  #define GPR10_PLR43_MASK              28672U
  #define GPR10_PLR43_BITNUM            12U
  #define GPR10                         *((volatile word *)0x00000E6A)


  /*** GPR11 - Group Priority Register 11; 0x00000E6B ***/
  union {
    word Word;
  } GPR11_STR;
  
  #define GPR11_PLR440_MASK             1U
  #define GPR11_PLR441_MASK             2U
  #define GPR11_PLR442_MASK             4U
  #define GPR11_PLR450_MASK             16U
  #define GPR11_PLR451_MASK             32U
  #define GPR11_PLR452_MASK             64U
  #define GPR11_PLR460_MASK             256U
  #define GPR11_PLR461_MASK             512U
  #define GPR11_PLR462_MASK             1024U
  #define GPR11_PLR470_MASK             4096U
  #define GPR11_PLR471_MASK             8192U
  #define GPR11_PLR472_MASK             16384U
  #define GPR11_PLR44_MASK              7U
  #define GPR11_PLR44_BITNUM            0U
  #define GPR11_PLR45_MASK              112U
  #define GPR11_PLR45_BITNUM            4U
  #define GPR11_PLR46_MASK              1792U
  #define GPR11_PLR46_BITNUM            8U
  #define GPR11_PLR47_MASK              28672U
  #define GPR11_PLR47_BITNUM            12U
  #define GPR11                         *((volatile word *)0x00000E6B)


  /*** GPR12 - Group Priority Register 12; 0x00000E6C ***/
  union {
    word Word;
  } GPR12_STR;
  
  #define GPR12_PLR480_MASK             1U
  #define GPR12_PLR481_MASK             2U
  #define GPR12_PLR482_MASK             4U
  #define GPR12_PLR490_MASK             16U
  #define GPR12_PLR491_MASK             32U
  #define GPR12_PLR492_MASK             64U
  #define GPR12_PLR500_MASK             256U
  #define GPR12_PLR501_MASK             512U
  #define GPR12_PLR502_MASK             1024U
  #define GPR12_PLR510_MASK             4096U
  #define GPR12_PLR511_MASK             8192U
  #define GPR12_PLR512_MASK             16384U
  #define GPR12_PLR48_MASK              7U
  #define GPR12_PLR48_BITNUM            0U
  #define GPR12_PLR49_MASK              112U
  #define GPR12_PLR49_BITNUM            4U
  #define GPR12_PLR50_MASK              1792U
  #define GPR12_PLR50_BITNUM            8U
  #define GPR12_PLR51_MASK              28672U
  #define GPR12_PLR51_BITNUM            12U
  #define GPR12                         *((volatile word *)0x00000E6C)


  /*** GPR13 - Group Priority Register 13; 0x00000E6D ***/
  union {
    word Word;
  } GPR13_STR;
  
  #define GPR13_PLR520_MASK             1U
  #define GPR13_PLR521_MASK             2U
  #define GPR13_PLR522_MASK             4U
  #define GPR13_PLR530_MASK             16U
  #define GPR13_PLR531_MASK             32U
  #define GPR13_PLR532_MASK             64U
  #define GPR13_PLR540_MASK             256U
  #define GPR13_PLR541_MASK             512U
  #define GPR13_PLR542_MASK             1024U
  #define GPR13_PLR550_MASK             4096U
  #define GPR13_PLR551_MASK             8192U
  #define GPR13_PLR552_MASK             16384U
  #define GPR13_PLR52_MASK              7U
  #define GPR13_PLR52_BITNUM            0U
  #define GPR13_PLR53_MASK              112U
  #define GPR13_PLR53_BITNUM            4U
  #define GPR13_PLR54_MASK              1792U
  #define GPR13_PLR54_BITNUM            8U
  #define GPR13_PLR55_MASK              28672U
  #define GPR13_PLR55_BITNUM            12U
  #define GPR13                         *((volatile word *)0x00000E6D)


  /*** GPR14 - Group Priority Register 14; 0x00000E6E ***/
  union {
    word Word;
  } GPR14_STR;
  
  #define GPR14_PLR560_MASK             1U
  #define GPR14_PLR561_MASK             2U
  #define GPR14_PLR562_MASK             4U
  #define GPR14_PLR570_MASK             16U
  #define GPR14_PLR571_MASK             32U
  #define GPR14_PLR572_MASK             64U
  #define GPR14_PLR580_MASK             256U
  #define GPR14_PLR581_MASK             512U
  #define GPR14_PLR582_MASK             1024U
  #define GPR14_PLR590_MASK             4096U
  #define GPR14_PLR591_MASK             8192U
  #define GPR14_PLR592_MASK             16384U
  #define GPR14_PLR56_MASK              7U
  #define GPR14_PLR56_BITNUM            0U
  #define GPR14_PLR57_MASK              112U
  #define GPR14_PLR57_BITNUM            4U
  #define GPR14_PLR58_MASK              1792U
  #define GPR14_PLR58_BITNUM            8U
  #define GPR14_PLR59_MASK              28672U
  #define GPR14_PLR59_BITNUM            12U
  #define GPR14                         *((volatile word *)0x00000E6E)


  /*** GPR15 - Group Priority Register 15; 0x00000E6F ***/
  union {
    word Word;
  } GPR15_STR;
  
  #define GPR15_PLR600_MASK             1U
  #define GPR15_PLR601_MASK             2U
  #define GPR15_PLR602_MASK             4U
  #define GPR15_PLR610_MASK             16U
  #define GPR15_PLR611_MASK             32U
  #define GPR15_PLR612_MASK             64U
  #define GPR15_PLR620_MASK             256U
  #define GPR15_PLR621_MASK             512U
  #define GPR15_PLR622_MASK             1024U
  #define GPR15_PLR630_MASK             4096U
  #define GPR15_PLR631_MASK             8192U
  #define GPR15_PLR632_MASK             16384U
  #define GPR15_PLR60_MASK              7U
  #define GPR15_PLR60_BITNUM            0U
  #define GPR15_PLR61_MASK              112U
  #define GPR15_PLR61_BITNUM            4U
  #define GPR15_PLR62_MASK              1792U
  #define GPR15_PLR62_BITNUM            8U
  #define GPR15_PLR63_MASK              28672U
  #define GPR15_PLR63_BITNUM            12U
  #define GPR15                         *((volatile word *)0x00000E6F)


  /*** TIRQ0 - Test Interrupt Request Register 0; 0x00000E70 ***/
  union {
    word Word;
  } TIRQ0_STR;
  
  #define TIRQ0_INT0_MASK               1U
  #define TIRQ0_INT1_MASK               2U
  #define TIRQ0_INT2_MASK               4U
  #define TIRQ0_INT3_MASK               8U
  #define TIRQ0_INT4_MASK               16U
  #define TIRQ0_INT5_MASK               32U
  #define TIRQ0_INT6_MASK               64U
  #define TIRQ0_INT7_MASK               128U
  #define TIRQ0_INT8_MASK               256U
  #define TIRQ0_INT9_MASK               512U
  #define TIRQ0_INT10_MASK              1024U
  #define TIRQ0_INT11_MASK              2048U
  #define TIRQ0_INT12_MASK              4096U
  #define TIRQ0_INT13_MASK              8192U
  #define TIRQ0_INT14_MASK              16384U
  #define TIRQ0_INT15_MASK              32768U
  #define TIRQ0                         *((volatile word *)0x00000E70)


  /*** TIRQ1 - Test Interrupt Request Register 1; 0x00000E71 ***/
  union {
    word Word;
  } TIRQ1_STR;
  
  #define TIRQ1_INT16_MASK              1U
  #define TIRQ1_INT17_MASK              2U
  #define TIRQ1_INT18_MASK              4U
  #define TIRQ1_INT19_MASK              8U
  #define TIRQ1_INT20_MASK              16U
  #define TIRQ1_INT21_MASK              32U
  #define TIRQ1_INT22_MASK              64U
  #define TIRQ1_INT23_MASK              128U
  #define TIRQ1_INT24_MASK              256U
  #define TIRQ1_INT25_MASK              512U
  #define TIRQ1_INT26_MASK              1024U
  #define TIRQ1_INT27_MASK              2048U
  #define TIRQ1_INT28_MASK              4096U
  #define TIRQ1_INT29_MASK              8192U
  #define TIRQ1_INT30_MASK              16384U
  #define TIRQ1_INT31_MASK              32768U
  #define TIRQ1                         *((volatile word *)0x00000E71)


  /*** TIRQ2 - Test Interrupt Request Register 2; 0x00000E72 ***/
  union {
    word Word;
  } TIRQ2_STR;
  
  #define TIRQ2_INT32_MASK              1U
  #define TIRQ2_INT33_MASK              2U
  #define TIRQ2_INT34_MASK              4U
  #define TIRQ2_INT35_MASK              8U
  #define TIRQ2_INT36_MASK              16U
  #define TIRQ2_INT37_MASK              32U
  #define TIRQ2_INT38_MASK              64U
  #define TIRQ2_INT39_MASK              128U
  #define TIRQ2_INT40_MASK              256U
  #define TIRQ2_INT41_MASK              512U
  #define TIRQ2_INT42_MASK              1024U
  #define TIRQ2_INT43_MASK              2048U
  #define TIRQ2_INT44_MASK              4096U
  #define TIRQ2_INT45_MASK              8192U
  #define TIRQ2_INT46_MASK              16384U
  #define TIRQ2_INT47_MASK              32768U
  #define TIRQ2                         *((volatile word *)0x00000E72)


  /*** TIRQ3 - Test Interrupt Request Register 3; 0x00000E73 ***/
  union {
    word Word;
  } TIRQ3_STR;
  
  #define TIRQ3_INT48_MASK              1U
  #define TIRQ3_INT49_MASK              2U
  #define TIRQ3_INT50_MASK              4U
  #define TIRQ3_INT51_MASK              8U
  #define TIRQ3_INT52_MASK              16U
  #define TIRQ3_INT53_MASK              32U
  #define TIRQ3_INT54_MASK              64U
  #define TIRQ3_INT55_MASK              128U
  #define TIRQ3_INT56_MASK              256U
  #define TIRQ3_INT57_MASK              512U
  #define TIRQ3_INT58_MASK              1024U
  #define TIRQ3_INT59_MASK              2048U
  #define TIRQ3_INT60_MASK              4096U
  #define TIRQ3_INT61_MASK              8192U
  #define TIRQ3_INT62_MASK              16384U
  #define TIRQ3_INT63_MASK              32768U
  #define TIRQ3                         *((volatile word *)0x00000E73)


  word Reserved0[4];                   /* Reserved (unused) registers */
  
  /*** TISR0 - Test Interrupt Source Register 0; 0x00000E78 ***/
  union {
    word Word;
  } TISR0_STR;
  
  #define TISR0_INT0_MASK               1U
  #define TISR0_INT1_MASK               2U
  #define TISR0_INT2_MASK               4U
  #define TISR0_INT3_MASK               8U
  #define TISR0_INT4_MASK               16U
  #define TISR0_INT5_MASK               32U
  #define TISR0_INT6_MASK               64U
  #define TISR0_INT7_MASK               128U
  #define TISR0_INT8_MASK               256U
  #define TISR0_INT9_MASK               512U
  #define TISR0_INT10_MASK              1024U
  #define TISR0_INT11_MASK              2048U
  #define TISR0_INT12_MASK              4096U
  #define TISR0_INT13_MASK              8192U
  #define TISR0_INT14_MASK              16384U
  #define TISR0_INT15_MASK              32768U
  #define TISR0                         *((volatile word *)0x00000E78)


  /*** TISR1 - Test Interrupt Source Register 1; 0x00000E79 ***/
  union {
    word Word;
  } TISR1_STR;
  
  #define TISR1_INT16_MASK              1U
  #define TISR1_INT17_MASK              2U
  #define TISR1_INT18_MASK              4U
  #define TISR1_INT19_MASK              8U
  #define TISR1_INT20_MASK              16U
  #define TISR1_INT21_MASK              32U
  #define TISR1_INT22_MASK              64U
  #define TISR1_INT23_MASK              128U
  #define TISR1_INT24_MASK              256U
  #define TISR1_INT25_MASK              512U
  #define TISR1_INT26_MASK              1024U
  #define TISR1_INT27_MASK              2048U
  #define TISR1_INT28_MASK              4096U
  #define TISR1_INT29_MASK              8192U
  #define TISR1_INT30_MASK              16384U
  #define TISR1_INT31_MASK              32768U
  #define TISR1                         *((volatile word *)0x00000E79)


  /*** TISR2 - Test Interrupt Source Register 2; 0x00000E7A ***/
  union {
    word Word;
  } TISR2_STR;
  
  #define TISR2_INT32_MASK              1U
  #define TISR2_INT33_MASK              2U
  #define TISR2_INT34_MASK              4U
  #define TISR2_INT35_MASK              8U
  #define TISR2_INT36_MASK              16U
  #define TISR2_INT37_MASK              32U
  #define TISR2_INT38_MASK              64U
  #define TISR2_INT39_MASK              128U
  #define TISR2_INT40_MASK              256U
  #define TISR2_INT41_MASK              512U
  #define TISR2_INT42_MASK              1024U
  #define TISR2_INT43_MASK              2048U
  #define TISR2_INT44_MASK              4096U
  #define TISR2_INT45_MASK              8192U
  #define TISR2_INT46_MASK              16384U
  #define TISR2_INT47_MASK              32768U
  #define TISR2                         *((volatile word *)0x00000E7A)


  /*** TISR3 - Test Interrupt Source Register 3; 0x00000E7B ***/
  union {
    word Word;
  } TISR3_STR;
  
  #define TISR3_INT48_MASK              1U
  #define TISR3_INT49_MASK              2U
  #define TISR3_INT50_MASK              4U
  #define TISR3_INT51_MASK              8U
  #define TISR3_INT52_MASK              16U
  #define TISR3_INT53_MASK              32U
  #define TISR3_INT54_MASK              64U
  #define TISR3_INT55_MASK              128U
  #define TISR3_INT56_MASK              256U
  #define TISR3_INT57_MASK              512U
  #define TISR3_INT58_MASK              1024U
  #define TISR3_INT59_MASK              2048U
  #define TISR3_INT60_MASK              4096U
  #define TISR3_INT61_MASK              8192U
  #define TISR3_INT62_MASK              16384U
  #define TISR3_INT63_MASK              32768U
  #define TISR3                         *((volatile word *)0x00000E7B)


  /*** TCSR - Test Control and Status Register; 0x00000E7C ***/
  union {
    word Word;
  } TCSR_STR;
  
  #define TCSR_tst_iack0_MASK           1U
  #define TCSR_tst_iack1_MASK           2U
  #define TCSR_tst_iack2_MASK           4U
  #define TCSR_PTM_MASK                 64U
  #define TCSR_Tmode_MASK               128U
  #define TCSR_vector0_MASK             256U
  #define TCSR_vector1_MASK             512U
  #define TCSR_vector2_MASK             1024U
  #define TCSR_vector3_MASK             2048U
  #define TCSR_vector4_MASK             4096U
  #define TCSR_vector5_MASK             8192U
  #define TCSR_IRQ0_MASK                32768U
  #define TCSR_tst_iack_MASK            7U
  #define TCSR_tst_iack_BITNUM          0U
  #define TCSR_vector_MASK              16128U
  #define TCSR_vector_BITNUM            8U
  #define TCSR                          *((volatile word *)0x00000E7C)


  word Reserved1[3];                   /* Reserved (unused) registers */

} ITCN_PRPH;

/******************************************
*** Peripheral ADCA
*******************************************/
typedef volatile struct {
  /*** ADCA_ADCR1 - ADCA Control Register; 0x00000E80 ***/
  union {
    word Word;
  } ADCA_ADCR1_STR;
  
  #define ADCA_ADCR1_SMODE0_MASK        1U
  #define ADCA_ADCR1_SMODE1_MASK        2U
  #define ADCA_ADCR1_SMODE2_MASK        4U
  #define ADCA_ADCR1_CHNCFG0_MASK       16U
  #define ADCA_ADCR1_CHNCFG1_MASK       32U
  #define ADCA_ADCR1_CHNCFG2_MASK       64U
  #define ADCA_ADCR1_CHNCFG3_MASK       128U
  #define ADCA_ADCR1_HLMTIE_MASK        256U
  #define ADCA_ADCR1_LLMTIE_MASK        512U
  #define ADCA_ADCR1_ZCIE_MASK          1024U
  #define ADCA_ADCR1_EOSIE_MASK         2048U
  #define ADCA_ADCR1_SYNC_MASK          4096U
  #define ADCA_ADCR1_START_MASK         8192U
  #define ADCA_ADCR1_STOP_MASK          16384U
  #define ADCA_ADCR1_SMODE_MASK         7U
  #define ADCA_ADCR1_SMODE_BITNUM       0U
  #define ADCA_ADCR1_CHNCFG_MASK        240U
  #define ADCA_ADCR1_CHNCFG_BITNUM      4U
  #define ADCA_ADCR1                    *((volatile word *)0x00000E80)


  /*** ADCA_ADCR2 - ADCA Control Register 2; 0x00000E81 ***/
  union {
    word Word;
  } ADCA_ADCR2_STR;
  
  #define ADCA_ADCR2_DIV0_MASK          1U
  #define ADCA_ADCR2_DIV1_MASK          2U
  #define ADCA_ADCR2_DIV2_MASK          4U
  #define ADCA_ADCR2_DIV3_MASK          8U
  #define ADCA_ADCR2_DIV_MASK           15U
  #define ADCA_ADCR2_DIV_BITNUM         0U
  #define ADCA_ADCR2                    *((volatile word *)0x00000E81)


  /*** ADCA_ADZCC - ADCA Zero Crossing Control Register; 0x00000E82 ***/
  union {
    word Word;
  } ADCA_ADZCC_STR;
  
  #define ADCA_ADZCC_ZCE00_MASK         1U
  #define ADCA_ADZCC_ZCE01_MASK         2U
  #define ADCA_ADZCC_ZCE10_MASK         4U
  #define ADCA_ADZCC_ZCE11_MASK         8U
  #define ADCA_ADZCC_ZCE20_MASK         16U
  #define ADCA_ADZCC_ZCE21_MASK         32U
  #define ADCA_ADZCC_ZCE30_MASK         64U
  #define ADCA_ADZCC_ZCE31_MASK         128U
  #define ADCA_ADZCC_ZCE40_MASK         256U
  #define ADCA_ADZCC_ZCE41_MASK         512U
  #define ADCA_ADZCC_ZCE50_MASK         1024U
  #define ADCA_ADZCC_ZCE51_MASK         2048U
  #define ADCA_ADZCC_ZCE60_MASK         4096U
  #define ADCA_ADZCC_ZCE61_MASK         8192U
  #define ADCA_ADZCC_ZCE70_MASK         16384U
  #define ADCA_ADZCC_ZCE71_MASK         32768U
  #define ADCA_ADZCC_ZCE0_MASK          3U
  #define ADCA_ADZCC_ZCE0_BITNUM        0U
  #define ADCA_ADZCC_ZCE1_MASK          12U
  #define ADCA_ADZCC_ZCE1_BITNUM        2U
  #define ADCA_ADZCC_ZCE2_MASK          48U
  #define ADCA_ADZCC_ZCE2_BITNUM        4U
  #define ADCA_ADZCC_ZCE3_MASK          192U
  #define ADCA_ADZCC_ZCE3_BITNUM        6U
  #define ADCA_ADZCC_ZCE4_MASK          768U
  #define ADCA_ADZCC_ZCE4_BITNUM        8U
  #define ADCA_ADZCC_ZCE5_MASK          3072U
  #define ADCA_ADZCC_ZCE5_BITNUM        10U
  #define ADCA_ADZCC_ZCE6_MASK          12288U
  #define ADCA_ADZCC_ZCE6_BITNUM        12U
  #define ADCA_ADZCC_ZCE7_MASK          49152U
  #define ADCA_ADZCC_ZCE7_BITNUM        14U
  #define ADCA_ADZCC                    *((volatile word *)0x00000E82)


  /*** ADCA_ADLST1 - ADCA Channel List Registers; 0x00000E83 ***/
  union {
    word Word;
  } ADCA_ADLST1_STR;
  
  #define ADCA_ADLST1_SAMPLE00_MASK     1U
  #define ADCA_ADLST1_SAMPLE01_MASK     2U
  #define ADCA_ADLST1_SAMPLE02_MASK     4U
  #define ADCA_ADLST1_SAMPLE10_MASK     16U
  #define ADCA_ADLST1_SAMPLE11_MASK     32U
  #define ADCA_ADLST1_SAMPLE12_MASK     64U
  #define ADCA_ADLST1_SAMPLE20_MASK     256U
  #define ADCA_ADLST1_SAMPLE21_MASK     512U
  #define ADCA_ADLST1_SAMPLE22_MASK     1024U
  #define ADCA_ADLST1_SAMPLE30_MASK     4096U
  #define ADCA_ADLST1_SAMPLE31_MASK     8192U
  #define ADCA_ADLST1_SAMPLE32_MASK     16384U
  #define ADCA_ADLST1_SAMPLE0_MASK      7U
  #define ADCA_ADLST1_SAMPLE0_BITNUM    0U
  #define ADCA_ADLST1_SAMPLE1_MASK      112U
  #define ADCA_ADLST1_SAMPLE1_BITNUM    4U
  #define ADCA_ADLST1_SAMPLE2_MASK      1792U
  #define ADCA_ADLST1_SAMPLE2_BITNUM    8U
  #define ADCA_ADLST1_SAMPLE3_MASK      28672U
  #define ADCA_ADLST1_SAMPLE3_BITNUM    12U
  #define ADCA_ADLST1                   *((volatile word *)0x00000E83)


  /*** ADCA_ADLST2 - ADCA Channel List Registers 2; 0x00000E84 ***/
  union {
    word Word;
  } ADCA_ADLST2_STR;
  
  #define ADCA_ADLST2_SAMPLE40_MASK     1U
  #define ADCA_ADLST2_SAMPLE41_MASK     2U
  #define ADCA_ADLST2_SAMPLE42_MASK     4U
  #define ADCA_ADLST2_SAMPLE50_MASK     16U
  #define ADCA_ADLST2_SAMPLE51_MASK     32U
  #define ADCA_ADLST2_SAMPLE52_MASK     64U
  #define ADCA_ADLST2_SAMPLE60_MASK     256U
  #define ADCA_ADLST2_SAMPLE61_MASK     512U
  #define ADCA_ADLST2_SAMPLE62_MASK     1024U
  #define ADCA_ADLST2_SAMPLE70_MASK     4096U
  #define ADCA_ADLST2_SAMPLE71_MASK     8192U
  #define ADCA_ADLST2_SAMPLE72_MASK     16384U
  #define ADCA_ADLST2_SAMPLE4_MASK      7U
  #define ADCA_ADLST2_SAMPLE4_BITNUM    0U
  #define ADCA_ADLST2_SAMPLE5_MASK      112U
  #define ADCA_ADLST2_SAMPLE5_BITNUM    4U
  #define ADCA_ADLST2_SAMPLE6_MASK      1792U
  #define ADCA_ADLST2_SAMPLE6_BITNUM    8U
  #define ADCA_ADLST2_SAMPLE7_MASK      28672U
  #define ADCA_ADLST2_SAMPLE7_BITNUM    12U
  #define ADCA_ADLST2                   *((volatile word *)0x00000E84)


  /*** ADCA_ADSDIS - ADCA Sample Disable Register; 0x00000E85 ***/
  union {
    word Word;
  } ADCA_ADSDIS_STR;
  
  #define ADCA_ADSDIS_DS0_MASK          1U
  #define ADCA_ADSDIS_DS1_MASK          2U
  #define ADCA_ADSDIS_DS2_MASK          4U
  #define ADCA_ADSDIS_DS3_MASK          8U
  #define ADCA_ADSDIS_DS4_MASK          16U
  #define ADCA_ADSDIS_DS5_MASK          32U
  #define ADCA_ADSDIS_DS6_MASK          64U
  #define ADCA_ADSDIS_DS7_MASK          128U
  #define ADCA_ADSDIS_TEST0_MASK        16384U
  #define ADCA_ADSDIS_TEST1_MASK        32768U
  #define ADCA_ADSDIS_DS_MASK           255U
  #define ADCA_ADSDIS_DS_BITNUM         0U
  #define ADCA_ADSDIS_TEST_MASK         49152U
  #define ADCA_ADSDIS_TEST_BITNUM       14U
  #define ADCA_ADSDIS                   *((volatile word *)0x00000E85)


  /*** ADCA_ADSTAT - ADCA Status Register; 0x00000E86 ***/
  union {
    word Word;
  } ADCA_ADSTAT_STR;
  
  #define ADCA_ADSTAT_RDY0_MASK         1U
  #define ADCA_ADSTAT_RDY1_MASK         2U
  #define ADCA_ADSTAT_RDY2_MASK         4U
  #define ADCA_ADSTAT_RDY3_MASK         8U
  #define ADCA_ADSTAT_RDY4_MASK         16U
  #define ADCA_ADSTAT_RDY5_MASK         32U
  #define ADCA_ADSTAT_RDY6_MASK         64U
  #define ADCA_ADSTAT_RDY7_MASK         128U
  #define ADCA_ADSTAT_HLMTI_MASK        256U
  #define ADCA_ADSTAT_LLMTI_MASK        512U
  #define ADCA_ADSTAT_ZCI_MASK          1024U
  #define ADCA_ADSTAT_EOSI_MASK         2048U
  #define ADCA_ADSTAT_CIP_MASK          32768U
  #define ADCA_ADSTAT_RDY_MASK          255U
  #define ADCA_ADSTAT_RDY_BITNUM        0U
  #define ADCA_ADSTAT                   *((volatile word *)0x00000E86)


  /*** ADCA_ADLSTAT - ADCA Limit Status Register; 0x00000E87 ***/
  union {
    word Word;
  } ADCA_ADLSTAT_STR;
  
  #define ADCA_ADLSTAT_LLS0_MASK        1U
  #define ADCA_ADLSTAT_LLS1_MASK        2U
  #define ADCA_ADLSTAT_LLS2_MASK        4U
  #define ADCA_ADLSTAT_LLS3_MASK        8U
  #define ADCA_ADLSTAT_LLS4_MASK        16U
  #define ADCA_ADLSTAT_LLS5_MASK        32U
  #define ADCA_ADLSTAT_LLS6_MASK        64U
  #define ADCA_ADLSTAT_LLS7_MASK        128U
  #define ADCA_ADLSTAT_HLS0_MASK        256U
  #define ADCA_ADLSTAT_HLS1_MASK        512U
  #define ADCA_ADLSTAT_HLS2_MASK        1024U
  #define ADCA_ADLSTAT_HLS3_MASK        2048U
  #define ADCA_ADLSTAT_HLS4_MASK        4096U
  #define ADCA_ADLSTAT_HLS5_MASK        8192U
  #define ADCA_ADLSTAT_HLS6_MASK        16384U
  #define ADCA_ADLSTAT_HLS7_MASK        32768U
  #define ADCA_ADLSTAT_LLS_MASK         255U
  #define ADCA_ADLSTAT_LLS_BITNUM       0U
  #define ADCA_ADLSTAT_HLS_MASK         65280U
  #define ADCA_ADLSTAT_HLS_BITNUM       8U
  #define ADCA_ADLSTAT                  *((volatile word *)0x00000E87)


  /*** ADCA_ADZCSTAT - ADCA Zero Crossing Status Register; 0x00000E88 ***/
  union {
    word Word;
  } ADCA_ADZCSTAT_STR;
  
  #define ADCA_ADZCSTAT_ZCS0_MASK       1U
  #define ADCA_ADZCSTAT_ZCS1_MASK       2U
  #define ADCA_ADZCSTAT_ZCS2_MASK       4U
  #define ADCA_ADZCSTAT_ZCS3_MASK       8U
  #define ADCA_ADZCSTAT_ZCS4_MASK       16U
  #define ADCA_ADZCSTAT_ZCS5_MASK       32U
  #define ADCA_ADZCSTAT_ZCS6_MASK       64U
  #define ADCA_ADZCSTAT_ZCS7_MASK       128U
  #define ADCA_ADZCSTAT_ZCS_MASK        255U
  #define ADCA_ADZCSTAT_ZCS_BITNUM      0U
  #define ADCA_ADZCSTAT                 *((volatile word *)0x00000E88)


  /*** ADCA_ADRSLT0 - ADCA Result Register 0; 0x00000E89 ***/
  union {
    word Word;
  } ADCA_ADRSLT0_STR;
  
  #define ADCA_ADRSLT0_RSLT0_MASK       8U
  #define ADCA_ADRSLT0_RSLT1_MASK       16U
  #define ADCA_ADRSLT0_RSLT2_MASK       32U
  #define ADCA_ADRSLT0_RSLT3_MASK       64U
  #define ADCA_ADRSLT0_RSLT4_MASK       128U
  #define ADCA_ADRSLT0_RSLT5_MASK       256U
  #define ADCA_ADRSLT0_RSLT6_MASK       512U
  #define ADCA_ADRSLT0_RSLT7_MASK       1024U
  #define ADCA_ADRSLT0_RSLT8_MASK       2048U
  #define ADCA_ADRSLT0_RSLT9_MASK       4096U
  #define ADCA_ADRSLT0_RSLT10_MASK      8192U
  #define ADCA_ADRSLT0_RSLT11_MASK      16384U
  #define ADCA_ADRSLT0_SEXT_MASK        32768U
  #define ADCA_ADRSLT0_RSLT_MASK        32760U
  #define ADCA_ADRSLT0_RSLT_BITNUM      3U
  #define ADCA_ADRSLT0                  *((volatile word *)0x00000E89)


  /*** ADCA_ADRSLT1 - ADCA Result Register 1; 0x00000E8A ***/
  union {
    word Word;
  } ADCA_ADRSLT1_STR;
  
  #define ADCA_ADRSLT1_RSLT0_MASK       8U
  #define ADCA_ADRSLT1_RSLT1_MASK       16U
  #define ADCA_ADRSLT1_RSLT2_MASK       32U
  #define ADCA_ADRSLT1_RSLT3_MASK       64U
  #define ADCA_ADRSLT1_RSLT4_MASK       128U
  #define ADCA_ADRSLT1_RSLT5_MASK       256U
  #define ADCA_ADRSLT1_RSLT6_MASK       512U
  #define ADCA_ADRSLT1_RSLT7_MASK       1024U
  #define ADCA_ADRSLT1_RSLT8_MASK       2048U
  #define ADCA_ADRSLT1_RSLT9_MASK       4096U
  #define ADCA_ADRSLT1_RSLT10_MASK      8192U
  #define ADCA_ADRSLT1_RSLT11_MASK      16384U
  #define ADCA_ADRSLT1_SEXT_MASK        32768U
  #define ADCA_ADRSLT1_RSLT_MASK        32760U
  #define ADCA_ADRSLT1_RSLT_BITNUM      3U
  #define ADCA_ADRSLT1                  *((volatile word *)0x00000E8A)


  /*** ADCA_ADRSLT2 - ADCA Result Register 2; 0x00000E8B ***/
  union {
    word Word;
  } ADCA_ADRSLT2_STR;
  
  #define ADCA_ADRSLT2_RSLT0_MASK       8U
  #define ADCA_ADRSLT2_RSLT1_MASK       16U
  #define ADCA_ADRSLT2_RSLT2_MASK       32U
  #define ADCA_ADRSLT2_RSLT3_MASK       64U
  #define ADCA_ADRSLT2_RSLT4_MASK       128U
  #define ADCA_ADRSLT2_RSLT5_MASK       256U
  #define ADCA_ADRSLT2_RSLT6_MASK       512U
  #define ADCA_ADRSLT2_RSLT7_MASK       1024U
  #define ADCA_ADRSLT2_RSLT8_MASK       2048U
  #define ADCA_ADRSLT2_RSLT9_MASK       4096U
  #define ADCA_ADRSLT2_RSLT10_MASK      8192U
  #define ADCA_ADRSLT2_RSLT11_MASK      16384U
  #define ADCA_ADRSLT2_SEXT_MASK        32768U
  #define ADCA_ADRSLT2_RSLT_MASK        32760U
  #define ADCA_ADRSLT2_RSLT_BITNUM      3U
  #define ADCA_ADRSLT2                  *((volatile word *)0x00000E8B)


  /*** ADCA_ADRSLT3 - ADCA Result Register 3; 0x00000E8C ***/
  union {
    word Word;
  } ADCA_ADRSLT3_STR;
  
  #define ADCA_ADRSLT3_RSLT0_MASK       8U
  #define ADCA_ADRSLT3_RSLT1_MASK       16U
  #define ADCA_ADRSLT3_RSLT2_MASK       32U
  #define ADCA_ADRSLT3_RSLT3_MASK       64U
  #define ADCA_ADRSLT3_RSLT4_MASK       128U
  #define ADCA_ADRSLT3_RSLT5_MASK       256U
  #define ADCA_ADRSLT3_RSLT6_MASK       512U
  #define ADCA_ADRSLT3_RSLT7_MASK       1024U
  #define ADCA_ADRSLT3_RSLT8_MASK       2048U
  #define ADCA_ADRSLT3_RSLT9_MASK       4096U
  #define ADCA_ADRSLT3_RSLT10_MASK      8192U
  #define ADCA_ADRSLT3_RSLT11_MASK      16384U
  #define ADCA_ADRSLT3_SEXT_MASK        32768U
  #define ADCA_ADRSLT3_RSLT_MASK        32760U
  #define ADCA_ADRSLT3_RSLT_BITNUM      3U
  #define ADCA_ADRSLT3                  *((volatile word *)0x00000E8C)


  /*** ADCA_ADRSLT4 - ADCA Result Register 4; 0x00000E8D ***/
  union {
    word Word;
  } ADCA_ADRSLT4_STR;
  
  #define ADCA_ADRSLT4_RSLT0_MASK       8U
  #define ADCA_ADRSLT4_RSLT1_MASK       16U
  #define ADCA_ADRSLT4_RSLT2_MASK       32U
  #define ADCA_ADRSLT4_RSLT3_MASK       64U
  #define ADCA_ADRSLT4_RSLT4_MASK       128U
  #define ADCA_ADRSLT4_RSLT5_MASK       256U
  #define ADCA_ADRSLT4_RSLT6_MASK       512U
  #define ADCA_ADRSLT4_RSLT7_MASK       1024U
  #define ADCA_ADRSLT4_RSLT8_MASK       2048U
  #define ADCA_ADRSLT4_RSLT9_MASK       4096U
  #define ADCA_ADRSLT4_RSLT10_MASK      8192U
  #define ADCA_ADRSLT4_RSLT11_MASK      16384U
  #define ADCA_ADRSLT4_SEXT_MASK        32768U
  #define ADCA_ADRSLT4_RSLT_MASK        32760U
  #define ADCA_ADRSLT4_RSLT_BITNUM      3U
  #define ADCA_ADRSLT4                  *((volatile word *)0x00000E8D)


  /*** ADCA_ADRSLT5 - ADCA Result Register 5; 0x00000E8E ***/
  union {
    word Word;
  } ADCA_ADRSLT5_STR;
  
  #define ADCA_ADRSLT5_RSLT0_MASK       8U
  #define ADCA_ADRSLT5_RSLT1_MASK       16U
  #define ADCA_ADRSLT5_RSLT2_MASK       32U
  #define ADCA_ADRSLT5_RSLT3_MASK       64U
  #define ADCA_ADRSLT5_RSLT4_MASK       128U
  #define ADCA_ADRSLT5_RSLT5_MASK       256U
  #define ADCA_ADRSLT5_RSLT6_MASK       512U
  #define ADCA_ADRSLT5_RSLT7_MASK       1024U
  #define ADCA_ADRSLT5_RSLT8_MASK       2048U
  #define ADCA_ADRSLT5_RSLT9_MASK       4096U
  #define ADCA_ADRSLT5_RSLT10_MASK      8192U
  #define ADCA_ADRSLT5_RSLT11_MASK      16384U
  #define ADCA_ADRSLT5_SEXT_MASK        32768U
  #define ADCA_ADRSLT5_RSLT_MASK        32760U
  #define ADCA_ADRSLT5_RSLT_BITNUM      3U
  #define ADCA_ADRSLT5                  *((volatile word *)0x00000E8E)


  /*** ADCA_ADRSLT6 - ADCA Result Register 6; 0x00000E8F ***/
  union {
    word Word;
  } ADCA_ADRSLT6_STR;
  
  #define ADCA_ADRSLT6_RSLT0_MASK       8U
  #define ADCA_ADRSLT6_RSLT1_MASK       16U
  #define ADCA_ADRSLT6_RSLT2_MASK       32U
  #define ADCA_ADRSLT6_RSLT3_MASK       64U
  #define ADCA_ADRSLT6_RSLT4_MASK       128U
  #define ADCA_ADRSLT6_RSLT5_MASK       256U
  #define ADCA_ADRSLT6_RSLT6_MASK       512U
  #define ADCA_ADRSLT6_RSLT7_MASK       1024U
  #define ADCA_ADRSLT6_RSLT8_MASK       2048U
  #define ADCA_ADRSLT6_RSLT9_MASK       4096U
  #define ADCA_ADRSLT6_RSLT10_MASK      8192U
  #define ADCA_ADRSLT6_RSLT11_MASK      16384U
  #define ADCA_ADRSLT6_SEXT_MASK        32768U
  #define ADCA_ADRSLT6_RSLT_MASK        32760U
  #define ADCA_ADRSLT6_RSLT_BITNUM      3U
  #define ADCA_ADRSLT6                  *((volatile word *)0x00000E8F)


  /*** ADCA_ADRSLT7 - ADCA Result Register 7; 0x00000E90 ***/
  union {
    word Word;
  } ADCA_ADRSLT7_STR;
  
  #define ADCA_ADRSLT7_RSLT0_MASK       8U
  #define ADCA_ADRSLT7_RSLT1_MASK       16U
  #define ADCA_ADRSLT7_RSLT2_MASK       32U
  #define ADCA_ADRSLT7_RSLT3_MASK       64U
  #define ADCA_ADRSLT7_RSLT4_MASK       128U
  #define ADCA_ADRSLT7_RSLT5_MASK       256U
  #define ADCA_ADRSLT7_RSLT6_MASK       512U
  #define ADCA_ADRSLT7_RSLT7_MASK       1024U
  #define ADCA_ADRSLT7_RSLT8_MASK       2048U
  #define ADCA_ADRSLT7_RSLT9_MASK       4096U
  #define ADCA_ADRSLT7_RSLT10_MASK      8192U
  #define ADCA_ADRSLT7_RSLT11_MASK      16384U
  #define ADCA_ADRSLT7_SEXT_MASK        32768U
  #define ADCA_ADRSLT7_RSLT_MASK        32760U
  #define ADCA_ADRSLT7_RSLT_BITNUM      3U
  #define ADCA_ADRSLT7                  *((volatile word *)0x00000E90)


  /*** ADCA_ADLLMT0 - ADCA Low Limit Register 0; 0x00000E91 ***/
  union {
    word Word;
  } ADCA_ADLLMT0_STR;
  
  #define ADCA_ADLLMT0_LLMT0_MASK       8U
  #define ADCA_ADLLMT0_LLMT1_MASK       16U
  #define ADCA_ADLLMT0_LLMT2_MASK       32U
  #define ADCA_ADLLMT0_LLMT3_MASK       64U
  #define ADCA_ADLLMT0_LLMT4_MASK       128U
  #define ADCA_ADLLMT0_LLMT5_MASK       256U
  #define ADCA_ADLLMT0_LLMT6_MASK       512U
  #define ADCA_ADLLMT0_LLMT7_MASK       1024U
  #define ADCA_ADLLMT0_LLMT8_MASK       2048U
  #define ADCA_ADLLMT0_LLMT9_MASK       4096U
  #define ADCA_ADLLMT0_LLMT10_MASK      8192U
  #define ADCA_ADLLMT0_LLMT11_MASK      16384U
  #define ADCA_ADLLMT0_LLMT_MASK        32760U
  #define ADCA_ADLLMT0_LLMT_BITNUM      3U
  #define ADCA_ADLLMT0                  *((volatile word *)0x00000E91)


  /*** ADCA_ADLLMT1 - ADCA Low Limit Register 1; 0x00000E92 ***/
  union {
    word Word;
  } ADCA_ADLLMT1_STR;
  
  #define ADCA_ADLLMT1_LLMT0_MASK       8U
  #define ADCA_ADLLMT1_LLMT1_MASK       16U
  #define ADCA_ADLLMT1_LLMT2_MASK       32U
  #define ADCA_ADLLMT1_LLMT3_MASK       64U
  #define ADCA_ADLLMT1_LLMT4_MASK       128U
  #define ADCA_ADLLMT1_LLMT5_MASK       256U
  #define ADCA_ADLLMT1_LLMT6_MASK       512U
  #define ADCA_ADLLMT1_LLMT7_MASK       1024U
  #define ADCA_ADLLMT1_LLMT8_MASK       2048U
  #define ADCA_ADLLMT1_LLMT9_MASK       4096U
  #define ADCA_ADLLMT1_LLMT10_MASK      8192U
  #define ADCA_ADLLMT1_LLMT11_MASK      16384U
  #define ADCA_ADLLMT1_LLMT_MASK        32760U
  #define ADCA_ADLLMT1_LLMT_BITNUM      3U
  #define ADCA_ADLLMT1                  *((volatile word *)0x00000E92)


  /*** ADCA_ADLLMT2 - ADCA Low Limit Register 2; 0x00000E93 ***/
  union {
    word Word;
  } ADCA_ADLLMT2_STR;
  
  #define ADCA_ADLLMT2_LLMT0_MASK       8U
  #define ADCA_ADLLMT2_LLMT1_MASK       16U
  #define ADCA_ADLLMT2_LLMT2_MASK       32U
  #define ADCA_ADLLMT2_LLMT3_MASK       64U
  #define ADCA_ADLLMT2_LLMT4_MASK       128U
  #define ADCA_ADLLMT2_LLMT5_MASK       256U
  #define ADCA_ADLLMT2_LLMT6_MASK       512U
  #define ADCA_ADLLMT2_LLMT7_MASK       1024U
  #define ADCA_ADLLMT2_LLMT8_MASK       2048U
  #define ADCA_ADLLMT2_LLMT9_MASK       4096U
  #define ADCA_ADLLMT2_LLMT10_MASK      8192U
  #define ADCA_ADLLMT2_LLMT11_MASK      16384U
  #define ADCA_ADLLMT2_LLMT_MASK        32760U
  #define ADCA_ADLLMT2_LLMT_BITNUM      3U
  #define ADCA_ADLLMT2                  *((volatile word *)0x00000E93)


  /*** ADCA_ADLLMT3 - ADCA Low Limit Register 3; 0x00000E94 ***/
  union {
    word Word;
  } ADCA_ADLLMT3_STR;
  
  #define ADCA_ADLLMT3_LLMT0_MASK       8U
  #define ADCA_ADLLMT3_LLMT1_MASK       16U
  #define ADCA_ADLLMT3_LLMT2_MASK       32U
  #define ADCA_ADLLMT3_LLMT3_MASK       64U
  #define ADCA_ADLLMT3_LLMT4_MASK       128U
  #define ADCA_ADLLMT3_LLMT5_MASK       256U
  #define ADCA_ADLLMT3_LLMT6_MASK       512U
  #define ADCA_ADLLMT3_LLMT7_MASK       1024U
  #define ADCA_ADLLMT3_LLMT8_MASK       2048U
  #define ADCA_ADLLMT3_LLMT9_MASK       4096U
  #define ADCA_ADLLMT3_LLMT10_MASK      8192U
  #define ADCA_ADLLMT3_LLMT11_MASK      16384U
  #define ADCA_ADLLMT3_LLMT_MASK        32760U
  #define ADCA_ADLLMT3_LLMT_BITNUM      3U
  #define ADCA_ADLLMT3                  *((volatile word *)0x00000E94)


  /*** ADCA_ADLLMT4 - ADCA Low Limit Register 4; 0x00000E95 ***/
  union {
    word Word;
  } ADCA_ADLLMT4_STR;
  
  #define ADCA_ADLLMT4_LLMT0_MASK       8U
  #define ADCA_ADLLMT4_LLMT1_MASK       16U
  #define ADCA_ADLLMT4_LLMT2_MASK       32U
  #define ADCA_ADLLMT4_LLMT3_MASK       64U
  #define ADCA_ADLLMT4_LLMT4_MASK       128U
  #define ADCA_ADLLMT4_LLMT5_MASK       256U
  #define ADCA_ADLLMT4_LLMT6_MASK       512U
  #define ADCA_ADLLMT4_LLMT7_MASK       1024U
  #define ADCA_ADLLMT4_LLMT8_MASK       2048U
  #define ADCA_ADLLMT4_LLMT9_MASK       4096U
  #define ADCA_ADLLMT4_LLMT10_MASK      8192U
  #define ADCA_ADLLMT4_LLMT11_MASK      16384U
  #define ADCA_ADLLMT4_LLMT_MASK        32760U
  #define ADCA_ADLLMT4_LLMT_BITNUM      3U
  #define ADCA_ADLLMT4                  *((volatile word *)0x00000E95)


  /*** ADCA_ADLLMT5 - ADCA Low Limit Register 5; 0x00000E96 ***/
  union {
    word Word;
  } ADCA_ADLLMT5_STR;
  
  #define ADCA_ADLLMT5_LLMT0_MASK       8U
  #define ADCA_ADLLMT5_LLMT1_MASK       16U
  #define ADCA_ADLLMT5_LLMT2_MASK       32U
  #define ADCA_ADLLMT5_LLMT3_MASK       64U
  #define ADCA_ADLLMT5_LLMT4_MASK       128U
  #define ADCA_ADLLMT5_LLMT5_MASK       256U
  #define ADCA_ADLLMT5_LLMT6_MASK       512U
  #define ADCA_ADLLMT5_LLMT7_MASK       1024U
  #define ADCA_ADLLMT5_LLMT8_MASK       2048U
  #define ADCA_ADLLMT5_LLMT9_MASK       4096U
  #define ADCA_ADLLMT5_LLMT10_MASK      8192U
  #define ADCA_ADLLMT5_LLMT11_MASK      16384U
  #define ADCA_ADLLMT5_LLMT_MASK        32760U
  #define ADCA_ADLLMT5_LLMT_BITNUM      3U
  #define ADCA_ADLLMT5                  *((volatile word *)0x00000E96)


  /*** ADCA_ADLLMT6 - ADCA Low Limit Register 6; 0x00000E97 ***/
  union {
    word Word;
  } ADCA_ADLLMT6_STR;
  
  #define ADCA_ADLLMT6_LLMT0_MASK       8U
  #define ADCA_ADLLMT6_LLMT1_MASK       16U
  #define ADCA_ADLLMT6_LLMT2_MASK       32U
  #define ADCA_ADLLMT6_LLMT3_MASK       64U
  #define ADCA_ADLLMT6_LLMT4_MASK       128U
  #define ADCA_ADLLMT6_LLMT5_MASK       256U
  #define ADCA_ADLLMT6_LLMT6_MASK       512U
  #define ADCA_ADLLMT6_LLMT7_MASK       1024U
  #define ADCA_ADLLMT6_LLMT8_MASK       2048U
  #define ADCA_ADLLMT6_LLMT9_MASK       4096U
  #define ADCA_ADLLMT6_LLMT10_MASK      8192U
  #define ADCA_ADLLMT6_LLMT11_MASK      16384U
  #define ADCA_ADLLMT6_LLMT_MASK        32760U
  #define ADCA_ADLLMT6_LLMT_BITNUM      3U
  #define ADCA_ADLLMT6                  *((volatile word *)0x00000E97)


  /*** ADCA_ADLLMT7 - ADCA Low Limit Register 7; 0x00000E98 ***/
  union {
    word Word;
  } ADCA_ADLLMT7_STR;
  
  #define ADCA_ADLLMT7_LLMT0_MASK       8U
  #define ADCA_ADLLMT7_LLMT1_MASK       16U
  #define ADCA_ADLLMT7_LLMT2_MASK       32U
  #define ADCA_ADLLMT7_LLMT3_MASK       64U
  #define ADCA_ADLLMT7_LLMT4_MASK       128U
  #define ADCA_ADLLMT7_LLMT5_MASK       256U
  #define ADCA_ADLLMT7_LLMT6_MASK       512U
  #define ADCA_ADLLMT7_LLMT7_MASK       1024U
  #define ADCA_ADLLMT7_LLMT8_MASK       2048U
  #define ADCA_ADLLMT7_LLMT9_MASK       4096U
  #define ADCA_ADLLMT7_LLMT10_MASK      8192U
  #define ADCA_ADLLMT7_LLMT11_MASK      16384U
  #define ADCA_ADLLMT7_LLMT_MASK        32760U
  #define ADCA_ADLLMT7_LLMT_BITNUM      3U
  #define ADCA_ADLLMT7                  *((volatile word *)0x00000E98)


  /*** ADCA_ADHLMT0 - ADCA High Limit Register 0; 0x00000E99 ***/
  union {
    word Word;
  } ADCA_ADHLMT0_STR;
  
  #define ADCA_ADHLMT0_HLMT0_MASK       8U
  #define ADCA_ADHLMT0_HLMT1_MASK       16U
  #define ADCA_ADHLMT0_HLMT2_MASK       32U
  #define ADCA_ADHLMT0_HLMT3_MASK       64U
  #define ADCA_ADHLMT0_HLMT4_MASK       128U
  #define ADCA_ADHLMT0_HLMT5_MASK       256U
  #define ADCA_ADHLMT0_HLMT6_MASK       512U
  #define ADCA_ADHLMT0_HLMT7_MASK       1024U
  #define ADCA_ADHLMT0_HLMT8_MASK       2048U
  #define ADCA_ADHLMT0_HLMT9_MASK       4096U
  #define ADCA_ADHLMT0_HLMT10_MASK      8192U
  #define ADCA_ADHLMT0_HLMT11_MASK      16384U
  #define ADCA_ADHLMT0_HLMT_MASK        32760U
  #define ADCA_ADHLMT0_HLMT_BITNUM      3U
  #define ADCA_ADHLMT0                  *((volatile word *)0x00000E99)


  /*** ADCA_ADHLMT1 - ADCA High Limit Register 1; 0x00000E9A ***/
  union {
    word Word;
  } ADCA_ADHLMT1_STR;
  
  #define ADCA_ADHLMT1_HLMT0_MASK       8U
  #define ADCA_ADHLMT1_HLMT1_MASK       16U
  #define ADCA_ADHLMT1_HLMT2_MASK       32U
  #define ADCA_ADHLMT1_HLMT3_MASK       64U
  #define ADCA_ADHLMT1_HLMT4_MASK       128U
  #define ADCA_ADHLMT1_HLMT5_MASK       256U
  #define ADCA_ADHLMT1_HLMT6_MASK       512U
  #define ADCA_ADHLMT1_HLMT7_MASK       1024U
  #define ADCA_ADHLMT1_HLMT8_MASK       2048U
  #define ADCA_ADHLMT1_HLMT9_MASK       4096U
  #define ADCA_ADHLMT1_HLMT10_MASK      8192U
  #define ADCA_ADHLMT1_HLMT11_MASK      16384U
  #define ADCA_ADHLMT1_HLMT_MASK        32760U
  #define ADCA_ADHLMT1_HLMT_BITNUM      3U
  #define ADCA_ADHLMT1                  *((volatile word *)0x00000E9A)


  /*** ADCA_ADHLMT2 - ADCA High Limit Register 2; 0x00000E9B ***/
  union {
    word Word;
  } ADCA_ADHLMT2_STR;
  
  #define ADCA_ADHLMT2_HLMT0_MASK       8U
  #define ADCA_ADHLMT2_HLMT1_MASK       16U
  #define ADCA_ADHLMT2_HLMT2_MASK       32U
  #define ADCA_ADHLMT2_HLMT3_MASK       64U
  #define ADCA_ADHLMT2_HLMT4_MASK       128U
  #define ADCA_ADHLMT2_HLMT5_MASK       256U
  #define ADCA_ADHLMT2_HLMT6_MASK       512U
  #define ADCA_ADHLMT2_HLMT7_MASK       1024U
  #define ADCA_ADHLMT2_HLMT8_MASK       2048U
  #define ADCA_ADHLMT2_HLMT9_MASK       4096U
  #define ADCA_ADHLMT2_HLMT10_MASK      8192U
  #define ADCA_ADHLMT2_HLMT11_MASK      16384U
  #define ADCA_ADHLMT2_HLMT_MASK        32760U
  #define ADCA_ADHLMT2_HLMT_BITNUM      3U
  #define ADCA_ADHLMT2                  *((volatile word *)0x00000E9B)


  /*** ADCA_ADHLMT3 - ADCA High Limit Register 3; 0x00000E9C ***/
  union {
    word Word;
  } ADCA_ADHLMT3_STR;
  
  #define ADCA_ADHLMT3_HLMT0_MASK       8U
  #define ADCA_ADHLMT3_HLMT1_MASK       16U
  #define ADCA_ADHLMT3_HLMT2_MASK       32U
  #define ADCA_ADHLMT3_HLMT3_MASK       64U
  #define ADCA_ADHLMT3_HLMT4_MASK       128U
  #define ADCA_ADHLMT3_HLMT5_MASK       256U
  #define ADCA_ADHLMT3_HLMT6_MASK       512U
  #define ADCA_ADHLMT3_HLMT7_MASK       1024U
  #define ADCA_ADHLMT3_HLMT8_MASK       2048U
  #define ADCA_ADHLMT3_HLMT9_MASK       4096U
  #define ADCA_ADHLMT3_HLMT10_MASK      8192U
  #define ADCA_ADHLMT3_HLMT11_MASK      16384U
  #define ADCA_ADHLMT3_HLMT_MASK        32760U
  #define ADCA_ADHLMT3_HLMT_BITNUM      3U
  #define ADCA_ADHLMT3                  *((volatile word *)0x00000E9C)


  /*** ADCA_ADHLMT4 - ADCA High Limit Register 4; 0x00000E9D ***/
  union {
    word Word;
  } ADCA_ADHLMT4_STR;
  
  #define ADCA_ADHLMT4_HLMT0_MASK       8U
  #define ADCA_ADHLMT4_HLMT1_MASK       16U
  #define ADCA_ADHLMT4_HLMT2_MASK       32U
  #define ADCA_ADHLMT4_HLMT3_MASK       64U
  #define ADCA_ADHLMT4_HLMT4_MASK       128U
  #define ADCA_ADHLMT4_HLMT5_MASK       256U
  #define ADCA_ADHLMT4_HLMT6_MASK       512U
  #define ADCA_ADHLMT4_HLMT7_MASK       1024U
  #define ADCA_ADHLMT4_HLMT8_MASK       2048U
  #define ADCA_ADHLMT4_HLMT9_MASK       4096U
  #define ADCA_ADHLMT4_HLMT10_MASK      8192U
  #define ADCA_ADHLMT4_HLMT11_MASK      16384U
  #define ADCA_ADHLMT4_HLMT_MASK        32760U
  #define ADCA_ADHLMT4_HLMT_BITNUM      3U
  #define ADCA_ADHLMT4                  *((volatile word *)0x00000E9D)


  /*** ADCA_ADHLMT5 - ADCA High Limit Register 5; 0x00000E9E ***/
  union {
    word Word;
  } ADCA_ADHLMT5_STR;
  
  #define ADCA_ADHLMT5_HLMT0_MASK       8U
  #define ADCA_ADHLMT5_HLMT1_MASK       16U
  #define ADCA_ADHLMT5_HLMT2_MASK       32U
  #define ADCA_ADHLMT5_HLMT3_MASK       64U
  #define ADCA_ADHLMT5_HLMT4_MASK       128U
  #define ADCA_ADHLMT5_HLMT5_MASK       256U
  #define ADCA_ADHLMT5_HLMT6_MASK       512U
  #define ADCA_ADHLMT5_HLMT7_MASK       1024U
  #define ADCA_ADHLMT5_HLMT8_MASK       2048U
  #define ADCA_ADHLMT5_HLMT9_MASK       4096U
  #define ADCA_ADHLMT5_HLMT10_MASK      8192U
  #define ADCA_ADHLMT5_HLMT11_MASK      16384U
  #define ADCA_ADHLMT5_HLMT_MASK        32760U
  #define ADCA_ADHLMT5_HLMT_BITNUM      3U
  #define ADCA_ADHLMT5                  *((volatile word *)0x00000E9E)


  /*** ADCA_ADHLMT6 - ADCA High Limit Register 6; 0x00000E9F ***/
  union {
    word Word;
  } ADCA_ADHLMT6_STR;
  
  #define ADCA_ADHLMT6_HLMT0_MASK       8U
  #define ADCA_ADHLMT6_HLMT1_MASK       16U
  #define ADCA_ADHLMT6_HLMT2_MASK       32U
  #define ADCA_ADHLMT6_HLMT3_MASK       64U
  #define ADCA_ADHLMT6_HLMT4_MASK       128U
  #define ADCA_ADHLMT6_HLMT5_MASK       256U
  #define ADCA_ADHLMT6_HLMT6_MASK       512U
  #define ADCA_ADHLMT6_HLMT7_MASK       1024U
  #define ADCA_ADHLMT6_HLMT8_MASK       2048U
  #define ADCA_ADHLMT6_HLMT9_MASK       4096U
  #define ADCA_ADHLMT6_HLMT10_MASK      8192U
  #define ADCA_ADHLMT6_HLMT11_MASK      16384U
  #define ADCA_ADHLMT6_HLMT_MASK        32760U
  #define ADCA_ADHLMT6_HLMT_BITNUM      3U
  #define ADCA_ADHLMT6                  *((volatile word *)0x00000E9F)


  /*** ADCA_ADHLMT7 - ADCA High Limit Register 7; 0x00000EA0 ***/
  union {
    word Word;
  } ADCA_ADHLMT7_STR;
  
  #define ADCA_ADHLMT7_HLMT0_MASK       8U
  #define ADCA_ADHLMT7_HLMT1_MASK       16U
  #define ADCA_ADHLMT7_HLMT2_MASK       32U
  #define ADCA_ADHLMT7_HLMT3_MASK       64U
  #define ADCA_ADHLMT7_HLMT4_MASK       128U
  #define ADCA_ADHLMT7_HLMT5_MASK       256U
  #define ADCA_ADHLMT7_HLMT6_MASK       512U
  #define ADCA_ADHLMT7_HLMT7_MASK       1024U
  #define ADCA_ADHLMT7_HLMT8_MASK       2048U
  #define ADCA_ADHLMT7_HLMT9_MASK       4096U
  #define ADCA_ADHLMT7_HLMT10_MASK      8192U
  #define ADCA_ADHLMT7_HLMT11_MASK      16384U
  #define ADCA_ADHLMT7_HLMT_MASK        32760U
  #define ADCA_ADHLMT7_HLMT_BITNUM      3U
  #define ADCA_ADHLMT7                  *((volatile word *)0x00000EA0)


  /*** ADCA_ADOFS0 - ADCA Offset Register 0; 0x00000EA1 ***/
  union {
    word Word;
  } ADCA_ADOFS0_STR;
  
  #define ADCA_ADOFS0_OFFSET0_MASK      8U
  #define ADCA_ADOFS0_OFFSET1_MASK      16U
  #define ADCA_ADOFS0_OFFSET2_MASK      32U
  #define ADCA_ADOFS0_OFFSET3_MASK      64U
  #define ADCA_ADOFS0_OFFSET4_MASK      128U
  #define ADCA_ADOFS0_OFFSET5_MASK      256U
  #define ADCA_ADOFS0_OFFSET6_MASK      512U
  #define ADCA_ADOFS0_OFFSET7_MASK      1024U
  #define ADCA_ADOFS0_OFFSET8_MASK      2048U
  #define ADCA_ADOFS0_OFFSET9_MASK      4096U
  #define ADCA_ADOFS0_OFFSET10_MASK     8192U
  #define ADCA_ADOFS0_OFFSET11_MASK     16384U
  #define ADCA_ADOFS0_OFFSET_MASK       32760U
  #define ADCA_ADOFS0_OFFSET_BITNUM     3U
  #define ADCA_ADOFS0                   *((volatile word *)0x00000EA1)


  /*** ADCA_ADOFS1 - ADCA Offset Register 1; 0x00000EA2 ***/
  union {
    word Word;
  } ADCA_ADOFS1_STR;
  
  #define ADCA_ADOFS1_OFFSET0_MASK      8U
  #define ADCA_ADOFS1_OFFSET1_MASK      16U
  #define ADCA_ADOFS1_OFFSET2_MASK      32U
  #define ADCA_ADOFS1_OFFSET3_MASK      64U
  #define ADCA_ADOFS1_OFFSET4_MASK      128U
  #define ADCA_ADOFS1_OFFSET5_MASK      256U
  #define ADCA_ADOFS1_OFFSET6_MASK      512U
  #define ADCA_ADOFS1_OFFSET7_MASK      1024U
  #define ADCA_ADOFS1_OFFSET8_MASK      2048U
  #define ADCA_ADOFS1_OFFSET9_MASK      4096U
  #define ADCA_ADOFS1_OFFSET10_MASK     8192U
  #define ADCA_ADOFS1_OFFSET11_MASK     16384U
  #define ADCA_ADOFS1_OFFSET_MASK       32760U
  #define ADCA_ADOFS1_OFFSET_BITNUM     3U
  #define ADCA_ADOFS1                   *((volatile word *)0x00000EA2)


  /*** ADCA_ADOFS2 - ADCA Offset Register 2; 0x00000EA3 ***/
  union {
    word Word;
  } ADCA_ADOFS2_STR;
  
  #define ADCA_ADOFS2_OFFSET0_MASK      8U
  #define ADCA_ADOFS2_OFFSET1_MASK      16U
  #define ADCA_ADOFS2_OFFSET2_MASK      32U
  #define ADCA_ADOFS2_OFFSET3_MASK      64U
  #define ADCA_ADOFS2_OFFSET4_MASK      128U
  #define ADCA_ADOFS2_OFFSET5_MASK      256U
  #define ADCA_ADOFS2_OFFSET6_MASK      512U
  #define ADCA_ADOFS2_OFFSET7_MASK      1024U
  #define ADCA_ADOFS2_OFFSET8_MASK      2048U
  #define ADCA_ADOFS2_OFFSET9_MASK      4096U
  #define ADCA_ADOFS2_OFFSET10_MASK     8192U
  #define ADCA_ADOFS2_OFFSET11_MASK     16384U
  #define ADCA_ADOFS2_OFFSET_MASK       32760U
  #define ADCA_ADOFS2_OFFSET_BITNUM     3U
  #define ADCA_ADOFS2                   *((volatile word *)0x00000EA3)


  /*** ADCA_ADOFS3 - ADCA Offset Register 3; 0x00000EA4 ***/
  union {
    word Word;
  } ADCA_ADOFS3_STR;
  
  #define ADCA_ADOFS3_OFFSET0_MASK      8U
  #define ADCA_ADOFS3_OFFSET1_MASK      16U
  #define ADCA_ADOFS3_OFFSET2_MASK      32U
  #define ADCA_ADOFS3_OFFSET3_MASK      64U
  #define ADCA_ADOFS3_OFFSET4_MASK      128U
  #define ADCA_ADOFS3_OFFSET5_MASK      256U
  #define ADCA_ADOFS3_OFFSET6_MASK      512U
  #define ADCA_ADOFS3_OFFSET7_MASK      1024U
  #define ADCA_ADOFS3_OFFSET8_MASK      2048U
  #define ADCA_ADOFS3_OFFSET9_MASK      4096U
  #define ADCA_ADOFS3_OFFSET10_MASK     8192U
  #define ADCA_ADOFS3_OFFSET11_MASK     16384U
  #define ADCA_ADOFS3_OFFSET_MASK       32760U
  #define ADCA_ADOFS3_OFFSET_BITNUM     3U
  #define ADCA_ADOFS3                   *((volatile word *)0x00000EA4)


  /*** ADCA_ADOFS4 - ADCA Offset Register 4; 0x00000EA5 ***/
  union {
    word Word;
  } ADCA_ADOFS4_STR;
  
  #define ADCA_ADOFS4_OFFSET0_MASK      8U
  #define ADCA_ADOFS4_OFFSET1_MASK      16U
  #define ADCA_ADOFS4_OFFSET2_MASK      32U
  #define ADCA_ADOFS4_OFFSET3_MASK      64U
  #define ADCA_ADOFS4_OFFSET4_MASK      128U
  #define ADCA_ADOFS4_OFFSET5_MASK      256U
  #define ADCA_ADOFS4_OFFSET6_MASK      512U
  #define ADCA_ADOFS4_OFFSET7_MASK      1024U
  #define ADCA_ADOFS4_OFFSET8_MASK      2048U
  #define ADCA_ADOFS4_OFFSET9_MASK      4096U
  #define ADCA_ADOFS4_OFFSET10_MASK     8192U
  #define ADCA_ADOFS4_OFFSET11_MASK     16384U
  #define ADCA_ADOFS4_OFFSET_MASK       32760U
  #define ADCA_ADOFS4_OFFSET_BITNUM     3U
  #define ADCA_ADOFS4                   *((volatile word *)0x00000EA5)


  /*** ADCA_ADOFS5 - ADCA Offset Register 5; 0x00000EA6 ***/
  union {
    word Word;
  } ADCA_ADOFS5_STR;
  
  #define ADCA_ADOFS5_OFFSET0_MASK      8U
  #define ADCA_ADOFS5_OFFSET1_MASK      16U
  #define ADCA_ADOFS5_OFFSET2_MASK      32U
  #define ADCA_ADOFS5_OFFSET3_MASK      64U
  #define ADCA_ADOFS5_OFFSET4_MASK      128U
  #define ADCA_ADOFS5_OFFSET5_MASK      256U
  #define ADCA_ADOFS5_OFFSET6_MASK      512U
  #define ADCA_ADOFS5_OFFSET7_MASK      1024U
  #define ADCA_ADOFS5_OFFSET8_MASK      2048U
  #define ADCA_ADOFS5_OFFSET9_MASK      4096U
  #define ADCA_ADOFS5_OFFSET10_MASK     8192U
  #define ADCA_ADOFS5_OFFSET11_MASK     16384U
  #define ADCA_ADOFS5_OFFSET_MASK       32760U
  #define ADCA_ADOFS5_OFFSET_BITNUM     3U
  #define ADCA_ADOFS5                   *((volatile word *)0x00000EA6)


  /*** ADCA_ADOFS6 - ADCA Offset Register 6; 0x00000EA7 ***/
  union {
    word Word;
  } ADCA_ADOFS6_STR;
  
  #define ADCA_ADOFS6_OFFSET0_MASK      8U
  #define ADCA_ADOFS6_OFFSET1_MASK      16U
  #define ADCA_ADOFS6_OFFSET2_MASK      32U
  #define ADCA_ADOFS6_OFFSET3_MASK      64U
  #define ADCA_ADOFS6_OFFSET4_MASK      128U
  #define ADCA_ADOFS6_OFFSET5_MASK      256U
  #define ADCA_ADOFS6_OFFSET6_MASK      512U
  #define ADCA_ADOFS6_OFFSET7_MASK      1024U
  #define ADCA_ADOFS6_OFFSET8_MASK      2048U
  #define ADCA_ADOFS6_OFFSET9_MASK      4096U
  #define ADCA_ADOFS6_OFFSET10_MASK     8192U
  #define ADCA_ADOFS6_OFFSET11_MASK     16384U
  #define ADCA_ADOFS6_OFFSET_MASK       32760U
  #define ADCA_ADOFS6_OFFSET_BITNUM     3U
  #define ADCA_ADOFS6                   *((volatile word *)0x00000EA7)


  /*** ADCA_ADOFS7 - ADCA Offset Register 7; 0x00000EA8 ***/
  union {
    word Word;
  } ADCA_ADOFS7_STR;
  
  #define ADCA_ADOFS7_OFFSET0_MASK      8U
  #define ADCA_ADOFS7_OFFSET1_MASK      16U
  #define ADCA_ADOFS7_OFFSET2_MASK      32U
  #define ADCA_ADOFS7_OFFSET3_MASK      64U
  #define ADCA_ADOFS7_OFFSET4_MASK      128U
  #define ADCA_ADOFS7_OFFSET5_MASK      256U
  #define ADCA_ADOFS7_OFFSET6_MASK      512U
  #define ADCA_ADOFS7_OFFSET7_MASK      1024U
  #define ADCA_ADOFS7_OFFSET8_MASK      2048U
  #define ADCA_ADOFS7_OFFSET9_MASK      4096U
  #define ADCA_ADOFS7_OFFSET10_MASK     8192U
  #define ADCA_ADOFS7_OFFSET11_MASK     16384U
  #define ADCA_ADOFS7_OFFSET_MASK       32760U
  #define ADCA_ADOFS7_OFFSET_BITNUM     3U
  #define ADCA_ADOFS7                   *((volatile word *)0x00000EA8)


  word Reserved0[87];                  /* Reserved (unused) registers */

} ADCA_PRPH;

/******************************************
*** Peripheral SCI0
*******************************************/
typedef volatile struct {
  /*** SCI0_SCIBR - SCI0 Baud Rate Register; 0x00000F00 ***/
  union {
    word Word;
  } SCI0_SCIBR_STR;
  
  #define SCI0_SCIBR_SBR0_MASK          1U
  #define SCI0_SCIBR_SBR1_MASK          2U
  #define SCI0_SCIBR_SBR2_MASK          4U
  #define SCI0_SCIBR_SBR3_MASK          8U
  #define SCI0_SCIBR_SBR4_MASK          16U
  #define SCI0_SCIBR_SBR5_MASK          32U
  #define SCI0_SCIBR_SBR6_MASK          64U
  #define SCI0_SCIBR_SBR7_MASK          128U
  #define SCI0_SCIBR_SBR8_MASK          256U
  #define SCI0_SCIBR_SBR9_MASK          512U
  #define SCI0_SCIBR_SBR10_MASK         1024U
  #define SCI0_SCIBR_SBR11_MASK         2048U
  #define SCI0_SCIBR_SBR12_MASK         4096U
  #define SCI0_SCIBR_SBR_MASK           8191U
  #define SCI0_SCIBR_SBR_BITNUM         0U
  #define SCI0_SCIBR                    *((volatile word *)0x00000F00)


  /*** SCI0_SCICR - SCI0 Control Register; 0x00000F01 ***/
  union {
    word Word;
  } SCI0_SCICR_STR;
  
  #define SCI0_SCICR_SBK_MASK           1U
  #define SCI0_SCICR_RWU_MASK           2U
  #define SCI0_SCICR_RE_MASK            4U
  #define SCI0_SCICR_TE_MASK            8U
  #define SCI0_SCICR_REIE_MASK          16U
  #define SCI0_SCICR_RIE_MASK           32U
  #define SCI0_SCICR_TIIE_MASK          64U
  #define SCI0_SCICR_TEIE_MASK          128U
  #define SCI0_SCICR_PT_MASK            256U
  #define SCI0_SCICR_PE_MASK            512U
  #define SCI0_SCICR_POL_MASK           1024U
  #define SCI0_SCICR_WAKE_MASK          2048U
  #define SCI0_SCICR_M_MASK             4096U
  #define SCI0_SCICR_RSRC_MASK          8192U
  #define SCI0_SCICR_SWAI_MASK          16384U
  #define SCI0_SCICR_LOOP_MASK          32768U
  #define SCI0_SCICR                    *((volatile word *)0x00000F01)


  /*** SCI0_SCISR - SCI0 Status Register; 0x00000F02 ***/
  union {
    word Word;
  } SCI0_SCISR_STR;
  
  #define SCI0_SCISR_RAF_MASK           1U
  #define SCI0_SCISR_PF_MASK            256U
  #define SCI0_SCISR_FE_MASK            512U
  #define SCI0_SCISR_NF_MASK            1024U
  #define SCI0_SCISR_OR_MASK            2048U
  #define SCI0_SCISR_RIDLE_MASK         4096U
  #define SCI0_SCISR_RDRF_MASK          8192U
  #define SCI0_SCISR_TIDLE_MASK         16384U
  #define SCI0_SCISR_TDRE_MASK          32768U
  #define SCI0_SCISR                    *((volatile word *)0x00000F02)


  /*** SCI0_SCIDR - SCI0 Data Register; 0x00000F03 ***/
  union {
    word Word;
  } SCI0_SCIDR_STR;
  
  #define SCI0_SCIDR_RECEIVE_TRANSMIT_DATA0_MASK 1U
  #define SCI0_SCIDR_RECEIVE_TRANSMIT_DATA1_MASK 2U
  #define SCI0_SCIDR_RECEIVE_TRANSMIT_DATA2_MASK 4U
  #define SCI0_SCIDR_RECEIVE_TRANSMIT_DATA3_MASK 8U
  #define SCI0_SCIDR_RECEIVE_TRANSMIT_DATA4_MASK 16U
  #define SCI0_SCIDR_RECEIVE_TRANSMIT_DATA5_MASK 32U
  #define SCI0_SCIDR_RECEIVE_TRANSMIT_DATA6_MASK 64U
  #define SCI0_SCIDR_RECEIVE_TRANSMIT_DATA7_MASK 128U
  #define SCI0_SCIDR_RECEIVE_TRANSMIT_DATA8_MASK 256U
  #define SCI0_SCIDR_RECEIVE_TRANSMIT_DATA_MASK 511U
  #define SCI0_SCIDR_RECEIVE_TRANSMIT_DATA_BITNUM 0U
  #define SCI0_SCIDR                    *((volatile word *)0x00000F03)


  word Reserved0[28];                  /* Reserved (unused) registers */

} SCI0_PRPH;

/******************************************
*** Peripheral SPI
*******************************************/
typedef volatile struct {
  /*** SPSCR - SPI Status and Control Register; 0x00000F20 ***/
  union {
    word Word;
  } SPSCR_STR;
  
  #define SPSCR_SPTIE_MASK              1U
  #define SPSCR_SPE_MASK                2U
  #define SPSCR_CPHA_MASK               4U
  #define SPSCR_CPOL_MASK               8U
  #define SPSCR_SPMSTR_MASK             16U
  #define SPSCR_SPRIE_MASK              32U
  #define SPSCR_SPR0_MASK               64U
  #define SPSCR_SPR1_MASK               128U
  #define SPSCR_MODFEN_MASK             256U
  #define SPSCR_SPTE_MASK               512U
  #define SPSCR_MODF_MASK               1024U
  #define SPSCR_OVRF_MASK               2048U
  #define SPSCR_ERRIE_MASK              4096U
  #define SPSCR_SPRF_MASK               8192U
  #define SPSCR_DSO_MASK                16384U
  #define SPSCR_SPR_MASK                192U
  #define SPSCR_SPR_BITNUM              6U
  #define SPSCR                         *((volatile word *)0x00000F20)


  /*** SPDSR - SPI Data Size and Control Register; 0x00000F21 ***/
  union {
    word Word;
  } SPDSR_STR;
  
  #define SPDSR_DS0_MASK                1U
  #define SPDSR_DS1_MASK                2U
  #define SPDSR_DS2_MASK                4U
  #define SPDSR_DS3_MASK                8U
  #define SPDSR_DS_MASK                 15U
  #define SPDSR_DS_BITNUM               0U
  #define SPDSR                         *((volatile word *)0x00000F21)


  /*** SPDRR - SPI Data Receive Register; 0x00000F22 ***/
  union {
    word Word;
  } SPDRR_STR;
  
  #define SPDRR                         *((volatile word *)0x00000F22)


  /*** SPDTR - SPI Data Transmit Register; 0x00000F23 ***/
  union {
    word Word;
  } SPDTR_STR;
  
  #define SPDTR                         *((volatile word *)0x00000F23)


  word Reserved0[12];                  /* Reserved (unused) registers */

} SPI_PRPH;

/******************************************
*** Peripheral COP
*******************************************/
typedef volatile struct {
  /*** COPCTL - I/O Control Register; 0x00000F30 ***/
  union {
    word Word;
  } COPCTL_STR;
  
  #define COPCTL_CWP_MASK               1U
  #define COPCTL_CEN_MASK               2U
  #define COPCTL_CWEN_MASK              4U
  #define COPCTL_CSEN_MASK              8U
  #define COPCTL                        *((volatile word *)0x00000F30)


  /*** COPTO - COP Time-Out Register; 0x00000F31 ***/
  union {
    word Word;
  } COPTO_STR;
  
  #define COPTO_CT0_MASK                1U
  #define COPTO_CT1_MASK                2U
  #define COPTO_CT2_MASK                4U
  #define COPTO_CT3_MASK                8U
  #define COPTO_CT4_MASK                16U
  #define COPTO_CT5_MASK                32U
  #define COPTO_CT6_MASK                64U
  #define COPTO_CT7_MASK                128U
  #define COPTO_CT8_MASK                256U
  #define COPTO_CT9_MASK                512U
  #define COPTO_CT10_MASK               1024U
  #define COPTO_CT11_MASK               2048U
  #define COPTO_CT_MASK                 4095U
  #define COPTO_CT_BITNUM               0U
  #define COPTO                         *((volatile word *)0x00000F31)


  /*** COPSRV - COP Service Register; 0x00000F32 ***/
  union {
    word Word;
  } COPSRV_STR;
  
  #define COPSRV_COP_Service0_MASK      1U
  #define COPSRV_COP_Service1_MASK      2U
  #define COPSRV_COP_Service2_MASK      4U
  #define COPSRV_COP_Service3_MASK      8U
  #define COPSRV_COP_Service4_MASK      16U
  #define COPSRV_COP_Service5_MASK      32U
  #define COPSRV_COP_Service6_MASK      64U
  #define COPSRV_COP_Service7_MASK      128U
  #define COPSRV_COP_Service8_MASK      256U
  #define COPSRV_COP_Service9_MASK      512U
  #define COPSRV_COP_Service10_MASK     1024U
  #define COPSRV_COP_Service11_MASK     2048U
  #define COPSRV_COP_Service12_MASK     4096U
  #define COPSRV_COP_Service13_MASK     8192U
  #define COPSRV_COP_Service14_MASK     16384U
  #define COPSRV_COP_Service15_MASK     32768U
  #define COPSRV                        *((volatile word *)0x00000F32)


  word Reserved0[13];                  /* Reserved (unused) registers */

} COP_PRPH;

/******************************************
*** Peripheral PFIU
*******************************************/
typedef volatile struct {
  /*** PFIU_CNTL - Program Flash Control Register; 0x00000F40 ***/
  union {
    word Word;
  } PFIU_CNTL_STR;
  
  #define PFIU_CNTL_NVSTR_MASK          1U
  #define PFIU_CNTL_MAS1_MASK           2U
  #define PFIU_CNTL_ERASE_MASK          4U
  #define PFIU_CNTL_PROG_MASK           8U
  #define PFIU_CNTL_YE_MASK             16U
  #define PFIU_CNTL_XE_MASK             32U
  #define PFIU_CNTL_IFREN_MASK          64U
  #define PFIU_CNTL_BUSY_MASK           32768U
  #define PFIU_CNTL                     *((volatile word *)0x00000F40)


  /*** PFIU_PE - Program Flash Program Enable Register; 0x00000F41 ***/
  union {
    word Word;
  } PFIU_PE_STR;
  
  #define PFIU_PE_ROW0_MASK             1U
  #define PFIU_PE_ROW1_MASK             2U
  #define PFIU_PE_ROW2_MASK             4U
  #define PFIU_PE_ROW3_MASK             8U
  #define PFIU_PE_ROW4_MASK             16U
  #define PFIU_PE_ROW5_MASK             32U
  #define PFIU_PE_ROW6_MASK             64U
  #define PFIU_PE_ROW7_MASK             128U
  #define PFIU_PE_ROW8_MASK             256U
  #define PFIU_PE_ROW9_MASK             512U
  #define PFIU_PE_IPE_MASK              16384U
  #define PFIU_PE_DPE_MASK              32768U
  #define PFIU_PE_ROW_MASK              1023U
  #define PFIU_PE_ROW_BITNUM            0U
  #define PFIU_PE                       *((volatile word *)0x00000F41)


  /*** PFIU_EE - Program Flash Erase Enable Register; 0x00000F42 ***/
  union {
    word Word;
  } PFIU_EE_STR;
  
  #define PFIU_EE_PAGE0_MASK            1U
  #define PFIU_EE_PAGE1_MASK            2U
  #define PFIU_EE_PAGE2_MASK            4U
  #define PFIU_EE_PAGE3_MASK            8U
  #define PFIU_EE_PAGE4_MASK            16U
  #define PFIU_EE_PAGE5_MASK            32U
  #define PFIU_EE_PAGE6_MASK            64U
  #define PFIU_EE_IEE_MASK              16384U
  #define PFIU_EE_DEE_MASK              32768U
  #define PFIU_EE_PAGE_MASK             127U
  #define PFIU_EE_PAGE_BITNUM           0U
  #define PFIU_EE                       *((volatile word *)0x00000F42)


  /*** PFIU_ADDR - Program Flash Address Register; 0x00000F43 ***/
  union {
    word Word;
  } PFIU_ADDR_STR;
  
  #define PFIU_ADDR_A0_MASK             1U
  #define PFIU_ADDR_A1_MASK             2U
  #define PFIU_ADDR_A2_MASK             4U
  #define PFIU_ADDR_A3_MASK             8U
  #define PFIU_ADDR_A4_MASK             16U
  #define PFIU_ADDR_A5_MASK             32U
  #define PFIU_ADDR_A6_MASK             64U
  #define PFIU_ADDR_A7_MASK             128U
  #define PFIU_ADDR_A8_MASK             256U
  #define PFIU_ADDR_A9_MASK             512U
  #define PFIU_ADDR_A10_MASK            1024U
  #define PFIU_ADDR_A11_MASK            2048U
  #define PFIU_ADDR_A12_MASK            4096U
  #define PFIU_ADDR_A13_MASK            8192U
  #define PFIU_ADDR_A14_MASK            16384U
  #define PFIU_ADDR_A15_MASK            32768U
  #define PFIU_ADDR                     *((volatile word *)0x00000F43)


  /*** PFIU_DATA - Program Flash Data Register; 0x00000F44 ***/
  union {
    word Word;
  } PFIU_DATA_STR;
  
  #define PFIU_DATA_D0_MASK             1U
  #define PFIU_DATA_D1_MASK             2U
  #define PFIU_DATA_D2_MASK             4U
  #define PFIU_DATA_D3_MASK             8U
  #define PFIU_DATA_D4_MASK             16U
  #define PFIU_DATA_D5_MASK             32U
  #define PFIU_DATA_D6_MASK             64U
  #define PFIU_DATA_D7_MASK             128U
  #define PFIU_DATA_D8_MASK             256U
  #define PFIU_DATA_D9_MASK             512U
  #define PFIU_DATA_D10_MASK            1024U
  #define PFIU_DATA_D11_MASK            2048U
  #define PFIU_DATA_D12_MASK            4096U
  #define PFIU_DATA_D13_MASK            8192U
  #define PFIU_DATA_D14_MASK            16384U
  #define PFIU_DATA_D15_MASK            32768U
  #define PFIU_DATA                     *((volatile word *)0x00000F44)


  /*** PFIU_IE - Program Flash Interrupt Enable Register; 0x00000F45 ***/
  union {
    word Word;
  } PFIU_IE_STR;
  
  #define PFIU_IE_IE0_MASK              1U
  #define PFIU_IE_IE1_MASK              2U
  #define PFIU_IE_IE2_MASK              4U
  #define PFIU_IE_IE3_MASK              8U
  #define PFIU_IE_IE4_MASK              16U
  #define PFIU_IE_IE5_MASK              32U
  #define PFIU_IE_IE6_MASK              64U
  #define PFIU_IE_IE7_MASK              128U
  #define PFIU_IE_IE8_MASK              256U
  #define PFIU_IE_IE9_MASK              512U
  #define PFIU_IE_IE10_MASK             1024U
  #define PFIU_IE_IE11_MASK             2048U
  #define PFIU_IE_IE_MASK               4095U
  #define PFIU_IE_IE_BITNUM             0U
  #define PFIU_IE                       *((volatile word *)0x00000F45)


  /*** PFIU_IS - Program Flash Interrupt Source Register; 0x00000F46 ***/
  union {
    word Word;
  } PFIU_IS_STR;
  
  #define PFIU_IS_IS0_MASK              1U
  #define PFIU_IS_IS1_MASK              2U
  #define PFIU_IS_IS2_MASK              4U
  #define PFIU_IS_IS3_MASK              8U
  #define PFIU_IS_IS4_MASK              16U
  #define PFIU_IS_IS5_MASK              32U
  #define PFIU_IS_IS6_MASK              64U
  #define PFIU_IS_IS7_MASK              128U
  #define PFIU_IS_IS8_MASK              256U
  #define PFIU_IS_IS9_MASK              512U
  #define PFIU_IS_IS10_MASK             1024U
  #define PFIU_IS_IS11_MASK             2048U
  #define PFIU_IS_IS_MASK               4095U
  #define PFIU_IS_IS_BITNUM             0U
  #define PFIU_IS                       *((volatile word *)0x00000F46)


  /*** PFIU_IP - Program Flash Interrupt Pending Register; 0x00000F47 ***/
  union {
    word Word;
  } PFIU_IP_STR;
  
  #define PFIU_IP_IP0_MASK              1U
  #define PFIU_IP_IP1_MASK              2U
  #define PFIU_IP_IP2_MASK              4U
  #define PFIU_IP_IP3_MASK              8U
  #define PFIU_IP_IP4_MASK              16U
  #define PFIU_IP_IP5_MASK              32U
  #define PFIU_IP_IP6_MASK              64U
  #define PFIU_IP_IP7_MASK              128U
  #define PFIU_IP_IP8_MASK              256U
  #define PFIU_IP_IP9_MASK              512U
  #define PFIU_IP_IP10_MASK             1024U
  #define PFIU_IP_IP11_MASK             2048U
  #define PFIU_IP_IP_MASK               4095U
  #define PFIU_IP_IP_BITNUM             0U
  #define PFIU_IP                       *((volatile word *)0x00000F47)


  /*** PFIU_CKDIVISOR - Program Flash Clock Divisor Register; 0x00000F48 ***/
  union {
    word Word;
  } PFIU_CKDIVISOR_STR;
  
  #define PFIU_CKDIVISOR_N0_MASK        1U
  #define PFIU_CKDIVISOR_N1_MASK        2U
  #define PFIU_CKDIVISOR_N2_MASK        4U
  #define PFIU_CKDIVISOR_N3_MASK        8U
  #define PFIU_CKDIVISOR_N_MASK         15U
  #define PFIU_CKDIVISOR_N_BITNUM       0U
  #define PFIU_CKDIVISOR                *((volatile word *)0x00000F48)


  /*** PFIU_TERASEL - Program Flash Erase Time Limit Register; 0x00000F49 ***/
  union {
    word Word;
  } PFIU_TERASEL_STR;
  
  #define PFIU_TERASEL_TERASEL0_MASK    1U
  #define PFIU_TERASEL_TERASEL1_MASK    2U
  #define PFIU_TERASEL_TERASEL2_MASK    4U
  #define PFIU_TERASEL_TERASEL3_MASK    8U
  #define PFIU_TERASEL_TERASEL4_MASK    16U
  #define PFIU_TERASEL_TERASEL5_MASK    32U
  #define PFIU_TERASEL_TERASEL6_MASK    64U
  #define PFIU_TERASEL_TERASEL_MASK     127U
  #define PFIU_TERASEL_TERASEL_BITNUM   0U
  #define PFIU_TERASEL                  *((volatile word *)0x00000F49)


  /*** PFIU_TMEL - Program Flash Mass Erase Time Limit Register; 0x00000F4A ***/
  union {
    word Word;
  } PFIU_TMEL_STR;
  
  #define PFIU_TMEL_TMEL0_MASK          1U
  #define PFIU_TMEL_TMEL1_MASK          2U
  #define PFIU_TMEL_TMEL2_MASK          4U
  #define PFIU_TMEL_TMEL3_MASK          8U
  #define PFIU_TMEL_TMEL4_MASK          16U
  #define PFIU_TMEL_TMEL5_MASK          32U
  #define PFIU_TMEL_TMEL6_MASK          64U
  #define PFIU_TMEL_TMEL7_MASK          128U
  #define PFIU_TMEL_TMEL_MASK           255U
  #define PFIU_TMEL_TMEL_BITNUM         0U
  #define PFIU_TMEL                     *((volatile word *)0x00000F4A)


  /*** PFIU_TNVSL - Program Flash Non-Volatile Storage Limit Register; 0x00000F4B ***/
  union {
    word Word;
  } PFIU_TNVSL_STR;
  
  #define PFIU_TNVSL_TNVSL0_MASK        1U
  #define PFIU_TNVSL_TNVSL1_MASK        2U
  #define PFIU_TNVSL_TNVSL2_MASK        4U
  #define PFIU_TNVSL_TNVSL3_MASK        8U
  #define PFIU_TNVSL_TNVSL4_MASK        16U
  #define PFIU_TNVSL_TNVSL5_MASK        32U
  #define PFIU_TNVSL_TNVSL6_MASK        64U
  #define PFIU_TNVSL_TNVSL7_MASK        128U
  #define PFIU_TNVSL_TNVSL8_MASK        256U
  #define PFIU_TNVSL_TNVSL9_MASK        512U
  #define PFIU_TNVSL_TNVSL10_MASK       1024U
  #define PFIU_TNVSL_TNVSL_MASK         2047U
  #define PFIU_TNVSL_TNVSL_BITNUM       0U
  #define PFIU_TNVSL                    *((volatile word *)0x00000F4B)


  /*** PFIU_TPGSL - Program Flash Program Setup Limit Register; 0x00000F4C ***/
  union {
    word Word;
  } PFIU_TPGSL_STR;
  
  #define PFIU_TPGSL_TPGSL0_MASK        1U
  #define PFIU_TPGSL_TPGSL1_MASK        2U
  #define PFIU_TPGSL_TPGSL2_MASK        4U
  #define PFIU_TPGSL_TPGSL3_MASK        8U
  #define PFIU_TPGSL_TPGSL4_MASK        16U
  #define PFIU_TPGSL_TPGSL5_MASK        32U
  #define PFIU_TPGSL_TPGSL6_MASK        64U
  #define PFIU_TPGSL_TPGSL7_MASK        128U
  #define PFIU_TPGSL_TPGSL8_MASK        256U
  #define PFIU_TPGSL_TPGSL9_MASK        512U
  #define PFIU_TPGSL_TPGSL10_MASK       1024U
  #define PFIU_TPGSL_TPGSL11_MASK       2048U
  #define PFIU_TPGSL_TPGSL_MASK         4095U
  #define PFIU_TPGSL_TPGSL_BITNUM       0U
  #define PFIU_TPGSL                    *((volatile word *)0x00000F4C)


  /*** PFIU_TPROGL - Program Flash Program Limit Register; 0x00000F4D ***/
  union {
    word Word;
  } PFIU_TPROGL_STR;
  
  #define PFIU_TPROGL_TPROGL0_MASK      1U
  #define PFIU_TPROGL_TPROGL1_MASK      2U
  #define PFIU_TPROGL_TPROGL2_MASK      4U
  #define PFIU_TPROGL_TPROGL3_MASK      8U
  #define PFIU_TPROGL_TPROGL4_MASK      16U
  #define PFIU_TPROGL_TPROGL5_MASK      32U
  #define PFIU_TPROGL_TPROGL6_MASK      64U
  #define PFIU_TPROGL_TPROGL7_MASK      128U
  #define PFIU_TPROGL_TPROGL8_MASK      256U
  #define PFIU_TPROGL_TPROGL9_MASK      512U
  #define PFIU_TPROGL_TPROGL10_MASK     1024U
  #define PFIU_TPROGL_TPROGL11_MASK     2048U
  #define PFIU_TPROGL_TPROGL12_MASK     4096U
  #define PFIU_TPROGL_TPROGL13_MASK     8192U
  #define PFIU_TPROGL_TPROGL_MASK       16383U
  #define PFIU_TPROGL_TPROGL_BITNUM     0U
  #define PFIU_TPROGL                   *((volatile word *)0x00000F4D)


  /*** PFIU_TNVHL - Program Flash Non-Volatile Hold Limit Register; 0x00000F4E ***/
  union {
    word Word;
  } PFIU_TNVHL_STR;
  
  #define PFIU_TNVHL_TNVHL0_MASK        1U
  #define PFIU_TNVHL_TNVHL1_MASK        2U
  #define PFIU_TNVHL_TNVHL2_MASK        4U
  #define PFIU_TNVHL_TNVHL3_MASK        8U
  #define PFIU_TNVHL_TNVHL4_MASK        16U
  #define PFIU_TNVHL_TNVHL5_MASK        32U
  #define PFIU_TNVHL_TNVHL6_MASK        64U
  #define PFIU_TNVHL_TNVHL7_MASK        128U
  #define PFIU_TNVHL_TNVHL8_MASK        256U
  #define PFIU_TNVHL_TNVHL9_MASK        512U
  #define PFIU_TNVHL_TNVHL10_MASK       1024U
  #define PFIU_TNVHL_TNVHL_MASK         2047U
  #define PFIU_TNVHL_TNVHL_BITNUM       0U
  #define PFIU_TNVHL                    *((volatile word *)0x00000F4E)


  /*** PFIU_TNVH1L - Program Flash Non-Volatile Hold 1 Limit Register; 0x00000F4F ***/
  union {
    word Word;
  } PFIU_TNVH1L_STR;
  
  #define PFIU_TNVH1L_TNVH1L0_MASK      1U
  #define PFIU_TNVH1L_TNVH1L1_MASK      2U
  #define PFIU_TNVH1L_TNVH1L2_MASK      4U
  #define PFIU_TNVH1L_TNVH1L3_MASK      8U
  #define PFIU_TNVH1L_TNVH1L4_MASK      16U
  #define PFIU_TNVH1L_TNVH1L5_MASK      32U
  #define PFIU_TNVH1L_TNVH1L6_MASK      64U
  #define PFIU_TNVH1L_TNVH1L7_MASK      128U
  #define PFIU_TNVH1L_TNVH1L8_MASK      256U
  #define PFIU_TNVH1L_TNVH1L9_MASK      512U
  #define PFIU_TNVH1L_TNVH1L10_MASK     1024U
  #define PFIU_TNVH1L_TNVH1L11_MASK     2048U
  #define PFIU_TNVH1L_TNVH1L12_MASK     4096U
  #define PFIU_TNVH1L_TNVH1L13_MASK     8192U
  #define PFIU_TNVH1L_TNVH1L14_MASK     16384U
  #define PFIU_TNVH1L_TNVH1L_MASK       32767U
  #define PFIU_TNVH1L_TNVH1L_BITNUM     0U
  #define PFIU_TNVH1L                   *((volatile word *)0x00000F4F)


  /*** PFIU_TRCVL - Program Flash Recovery Limit Register; 0x00000F50 ***/
  union {
    word Word;
  } PFIU_TRCVL_STR;
  
  #define PFIU_TRCVL_TRCVL0_MASK        1U
  #define PFIU_TRCVL_TRCVL1_MASK        2U
  #define PFIU_TRCVL_TRCVL2_MASK        4U
  #define PFIU_TRCVL_TRCVL3_MASK        8U
  #define PFIU_TRCVL_TRCVL4_MASK        16U
  #define PFIU_TRCVL_TRCVL5_MASK        32U
  #define PFIU_TRCVL_TRCVL6_MASK        64U
  #define PFIU_TRCVL_TRCVL7_MASK        128U
  #define PFIU_TRCVL_TRCVL8_MASK        256U
  #define PFIU_TRCVL_TRCVL_MASK         511U
  #define PFIU_TRCVL_TRCVL_BITNUM       0U
  #define PFIU_TRCVL                    *((volatile word *)0x00000F50)


  word Reserved0[15];                  /* Reserved (unused) registers */

} PFIU_PRPH;

/******************************************
*** Peripheral DFIU
*******************************************/
typedef volatile struct {
  /*** DFIU_CNTL - Data Flash Control Register; 0x00000F60 ***/
  union {
    word Word;
  } DFIU_CNTL_STR;
  
  #define DFIU_CNTL_NVSTR_MASK          1U
  #define DFIU_CNTL_MAS1_MASK           2U
  #define DFIU_CNTL_ERASE_MASK          4U
  #define DFIU_CNTL_PROG_MASK           8U
  #define DFIU_CNTL_YE_MASK             16U
  #define DFIU_CNTL_XE_MASK             32U
  #define DFIU_CNTL_IFREN_MASK          64U
  #define DFIU_CNTL_BUSY_MASK           32768U
  #define DFIU_CNTL                     *((volatile word *)0x00000F60)


  /*** DFIU_PE - Data Flash Program Enable Register; 0x00000F61 ***/
  union {
    word Word;
  } DFIU_PE_STR;
  
  #define DFIU_PE_ROW0_MASK             1U
  #define DFIU_PE_ROW1_MASK             2U
  #define DFIU_PE_ROW2_MASK             4U
  #define DFIU_PE_ROW3_MASK             8U
  #define DFIU_PE_ROW4_MASK             16U
  #define DFIU_PE_ROW5_MASK             32U
  #define DFIU_PE_ROW6_MASK             64U
  #define DFIU_PE_ROW7_MASK             128U
  #define DFIU_PE_ROW8_MASK             256U
  #define DFIU_PE_ROW9_MASK             512U
  #define DFIU_PE_IPE_MASK              16384U
  #define DFIU_PE_DPE_MASK              32768U
  #define DFIU_PE_ROW_MASK              1023U
  #define DFIU_PE_ROW_BITNUM            0U
  #define DFIU_PE                       *((volatile word *)0x00000F61)


  /*** DFIU_EE - Data Flash Erase Enable Register; 0x00000F62 ***/
  union {
    word Word;
  } DFIU_EE_STR;
  
  #define DFIU_EE_PAGE0_MASK            1U
  #define DFIU_EE_PAGE1_MASK            2U
  #define DFIU_EE_PAGE2_MASK            4U
  #define DFIU_EE_PAGE3_MASK            8U
  #define DFIU_EE_PAGE4_MASK            16U
  #define DFIU_EE_PAGE5_MASK            32U
  #define DFIU_EE_PAGE6_MASK            64U
  #define DFIU_EE_IEE_MASK              16384U
  #define DFIU_EE_DEE_MASK              32768U
  #define DFIU_EE_PAGE_MASK             127U
  #define DFIU_EE_PAGE_BITNUM           0U
  #define DFIU_EE                       *((volatile word *)0x00000F62)


  /*** DFIU_ADDR - Data Flash Address Register; 0x00000F63 ***/
  union {
    word Word;
  } DFIU_ADDR_STR;
  
  #define DFIU_ADDR_A0_MASK             1U
  #define DFIU_ADDR_A1_MASK             2U
  #define DFIU_ADDR_A2_MASK             4U
  #define DFIU_ADDR_A3_MASK             8U
  #define DFIU_ADDR_A4_MASK             16U
  #define DFIU_ADDR_A5_MASK             32U
  #define DFIU_ADDR_A6_MASK             64U
  #define DFIU_ADDR_A7_MASK             128U
  #define DFIU_ADDR_A8_MASK             256U
  #define DFIU_ADDR_A9_MASK             512U
  #define DFIU_ADDR_A10_MASK            1024U
  #define DFIU_ADDR_A11_MASK            2048U
  #define DFIU_ADDR_A12_MASK            4096U
  #define DFIU_ADDR_A13_MASK            8192U
  #define DFIU_ADDR_A14_MASK            16384U
  #define DFIU_ADDR_A15_MASK            32768U
  #define DFIU_ADDR                     *((volatile word *)0x00000F63)


  /*** DFIU_DATA - Data Flash Data Register; 0x00000F64 ***/
  union {
    word Word;
  } DFIU_DATA_STR;
  
  #define DFIU_DATA_D0_MASK             1U
  #define DFIU_DATA_D1_MASK             2U
  #define DFIU_DATA_D2_MASK             4U
  #define DFIU_DATA_D3_MASK             8U
  #define DFIU_DATA_D4_MASK             16U
  #define DFIU_DATA_D5_MASK             32U
  #define DFIU_DATA_D6_MASK             64U
  #define DFIU_DATA_D7_MASK             128U
  #define DFIU_DATA_D8_MASK             256U
  #define DFIU_DATA_D9_MASK             512U
  #define DFIU_DATA_D10_MASK            1024U
  #define DFIU_DATA_D11_MASK            2048U
  #define DFIU_DATA_D12_MASK            4096U
  #define DFIU_DATA_D13_MASK            8192U
  #define DFIU_DATA_D14_MASK            16384U
  #define DFIU_DATA_D15_MASK            32768U
  #define DFIU_DATA                     *((volatile word *)0x00000F64)


  /*** DFIU_IE - Data Flash Interrupt Enable Register; 0x00000F65 ***/
  union {
    word Word;
  } DFIU_IE_STR;
  
  #define DFIU_IE_IE0_MASK              1U
  #define DFIU_IE_IE1_MASK              2U
  #define DFIU_IE_IE2_MASK              4U
  #define DFIU_IE_IE3_MASK              8U
  #define DFIU_IE_IE4_MASK              16U
  #define DFIU_IE_IE5_MASK              32U
  #define DFIU_IE_IE6_MASK              64U
  #define DFIU_IE_IE7_MASK              128U
  #define DFIU_IE_IE8_MASK              256U
  #define DFIU_IE_IE9_MASK              512U
  #define DFIU_IE_IE10_MASK             1024U
  #define DFIU_IE_IE11_MASK             2048U
  #define DFIU_IE_IE_MASK               4095U
  #define DFIU_IE_IE_BITNUM             0U
  #define DFIU_IE                       *((volatile word *)0x00000F65)


  /*** DFIU_IS - Data Flash Interrupt Source Register; 0x00000F66 ***/
  union {
    word Word;
  } DFIU_IS_STR;
  
  #define DFIU_IS_IS0_MASK              1U
  #define DFIU_IS_IS1_MASK              2U
  #define DFIU_IS_IS2_MASK              4U
  #define DFIU_IS_IS3_MASK              8U
  #define DFIU_IS_IS4_MASK              16U
  #define DFIU_IS_IS5_MASK              32U
  #define DFIU_IS_IS6_MASK              64U
  #define DFIU_IS_IS7_MASK              128U
  #define DFIU_IS_IS8_MASK              256U
  #define DFIU_IS_IS9_MASK              512U
  #define DFIU_IS_IS10_MASK             1024U
  #define DFIU_IS_IS11_MASK             2048U
  #define DFIU_IS_IS_MASK               4095U
  #define DFIU_IS_IS_BITNUM             0U
  #define DFIU_IS                       *((volatile word *)0x00000F66)


  /*** DFIU_IP - Data Flash Interrupt Pending Register; 0x00000F67 ***/
  union {
    word Word;
  } DFIU_IP_STR;
  
  #define DFIU_IP_IP0_MASK              1U
  #define DFIU_IP_IP1_MASK              2U
  #define DFIU_IP_IP2_MASK              4U
  #define DFIU_IP_IP3_MASK              8U
  #define DFIU_IP_IP4_MASK              16U
  #define DFIU_IP_IP5_MASK              32U
  #define DFIU_IP_IP6_MASK              64U
  #define DFIU_IP_IP7_MASK              128U
  #define DFIU_IP_IP8_MASK              256U
  #define DFIU_IP_IP9_MASK              512U
  #define DFIU_IP_IP10_MASK             1024U
  #define DFIU_IP_IP11_MASK             2048U
  #define DFIU_IP_IP_MASK               4095U
  #define DFIU_IP_IP_BITNUM             0U
  #define DFIU_IP                       *((volatile word *)0x00000F67)


  /*** DFIU_CKDIVISOR - Data Flash Clock Divisor Register; 0x00000F68 ***/
  union {
    word Word;
  } DFIU_CKDIVISOR_STR;
  
  #define DFIU_CKDIVISOR_N0_MASK        1U
  #define DFIU_CKDIVISOR_N1_MASK        2U
  #define DFIU_CKDIVISOR_N2_MASK        4U
  #define DFIU_CKDIVISOR_N3_MASK        8U
  #define DFIU_CKDIVISOR_N_MASK         15U
  #define DFIU_CKDIVISOR_N_BITNUM       0U
  #define DFIU_CKDIVISOR                *((volatile word *)0x00000F68)


  /*** DFIU_TERASEL - Data Flash Erase Time Limit Register; 0x00000F69 ***/
  union {
    word Word;
  } DFIU_TERASEL_STR;
  
  #define DFIU_TERASEL_TERASEL0_MASK    1U
  #define DFIU_TERASEL_TERASEL1_MASK    2U
  #define DFIU_TERASEL_TERASEL2_MASK    4U
  #define DFIU_TERASEL_TERASEL3_MASK    8U
  #define DFIU_TERASEL_TERASEL4_MASK    16U
  #define DFIU_TERASEL_TERASEL5_MASK    32U
  #define DFIU_TERASEL_TERASEL6_MASK    64U
  #define DFIU_TERASEL_TERASEL_MASK     127U
  #define DFIU_TERASEL_TERASEL_BITNUM   0U
  #define DFIU_TERASEL                  *((volatile word *)0x00000F69)


  /*** DFIU_TMEL - Data Flash Mass Erase Time Limit Register; 0x00000F6A ***/
  union {
    word Word;
  } DFIU_TMEL_STR;
  
  #define DFIU_TMEL_TMEL0_MASK          1U
  #define DFIU_TMEL_TMEL1_MASK          2U
  #define DFIU_TMEL_TMEL2_MASK          4U
  #define DFIU_TMEL_TMEL3_MASK          8U
  #define DFIU_TMEL_TMEL4_MASK          16U
  #define DFIU_TMEL_TMEL5_MASK          32U
  #define DFIU_TMEL_TMEL6_MASK          64U
  #define DFIU_TMEL_TMEL7_MASK          128U
  #define DFIU_TMEL_TMEL_MASK           255U
  #define DFIU_TMEL_TMEL_BITNUM         0U
  #define DFIU_TMEL                     *((volatile word *)0x00000F6A)


  /*** DFIU_TNVSL - Data Flash Non-Volatile Storage Limit Register; 0x00000F6B ***/
  union {
    word Word;
  } DFIU_TNVSL_STR;
  
  #define DFIU_TNVSL_TNVSL0_MASK        1U
  #define DFIU_TNVSL_TNVSL1_MASK        2U
  #define DFIU_TNVSL_TNVSL2_MASK        4U
  #define DFIU_TNVSL_TNVSL3_MASK        8U
  #define DFIU_TNVSL_TNVSL4_MASK        16U
  #define DFIU_TNVSL_TNVSL5_MASK        32U
  #define DFIU_TNVSL_TNVSL6_MASK        64U
  #define DFIU_TNVSL_TNVSL7_MASK        128U
  #define DFIU_TNVSL_TNVSL8_MASK        256U
  #define DFIU_TNVSL_TNVSL9_MASK        512U
  #define DFIU_TNVSL_TNVSL10_MASK       1024U
  #define DFIU_TNVSL_TNVSL_MASK         2047U
  #define DFIU_TNVSL_TNVSL_BITNUM       0U
  #define DFIU_TNVSL                    *((volatile word *)0x00000F6B)


  /*** DFIU_TPGSL - Data Flash Program Setup Limit Register; 0x00000F6C ***/
  union {
    word Word;
  } DFIU_TPGSL_STR;
  
  #define DFIU_TPGSL_TPGSL0_MASK        1U
  #define DFIU_TPGSL_TPGSL1_MASK        2U
  #define DFIU_TPGSL_TPGSL2_MASK        4U
  #define DFIU_TPGSL_TPGSL3_MASK        8U
  #define DFIU_TPGSL_TPGSL4_MASK        16U
  #define DFIU_TPGSL_TPGSL5_MASK        32U
  #define DFIU_TPGSL_TPGSL6_MASK        64U
  #define DFIU_TPGSL_TPGSL7_MASK        128U
  #define DFIU_TPGSL_TPGSL8_MASK        256U
  #define DFIU_TPGSL_TPGSL9_MASK        512U
  #define DFIU_TPGSL_TPGSL10_MASK       1024U
  #define DFIU_TPGSL_TPGSL11_MASK       2048U
  #define DFIU_TPGSL_TPGSL_MASK         4095U
  #define DFIU_TPGSL_TPGSL_BITNUM       0U
  #define DFIU_TPGSL                    *((volatile word *)0x00000F6C)


  /*** DFIU_TPROGL - Data Flash Program Limit Register; 0x00000F6D ***/
  union {
    word Word;
  } DFIU_TPROGL_STR;
  
  #define DFIU_TPROGL_TPROGL0_MASK      1U
  #define DFIU_TPROGL_TPROGL1_MASK      2U
  #define DFIU_TPROGL_TPROGL2_MASK      4U
  #define DFIU_TPROGL_TPROGL3_MASK      8U
  #define DFIU_TPROGL_TPROGL4_MASK      16U
  #define DFIU_TPROGL_TPROGL5_MASK      32U
  #define DFIU_TPROGL_TPROGL6_MASK      64U
  #define DFIU_TPROGL_TPROGL7_MASK      128U
  #define DFIU_TPROGL_TPROGL8_MASK      256U
  #define DFIU_TPROGL_TPROGL9_MASK      512U
  #define DFIU_TPROGL_TPROGL10_MASK     1024U
  #define DFIU_TPROGL_TPROGL11_MASK     2048U
  #define DFIU_TPROGL_TPROGL12_MASK     4096U
  #define DFIU_TPROGL_TPROGL13_MASK     8192U
  #define DFIU_TPROGL_TPROGL_MASK       16383U
  #define DFIU_TPROGL_TPROGL_BITNUM     0U
  #define DFIU_TPROGL                   *((volatile word *)0x00000F6D)


  /*** DFIU_TNVHL - Data Flash Non-Volatile Hold Limit Register; 0x00000F6E ***/
  union {
    word Word;
  } DFIU_TNVHL_STR;
  
  #define DFIU_TNVHL_TNVHL0_MASK        1U
  #define DFIU_TNVHL_TNVHL1_MASK        2U
  #define DFIU_TNVHL_TNVHL2_MASK        4U
  #define DFIU_TNVHL_TNVHL3_MASK        8U
  #define DFIU_TNVHL_TNVHL4_MASK        16U
  #define DFIU_TNVHL_TNVHL5_MASK        32U
  #define DFIU_TNVHL_TNVHL6_MASK        64U
  #define DFIU_TNVHL_TNVHL7_MASK        128U
  #define DFIU_TNVHL_TNVHL8_MASK        256U
  #define DFIU_TNVHL_TNVHL9_MASK        512U
  #define DFIU_TNVHL_TNVHL10_MASK       1024U
  #define DFIU_TNVHL_TNVHL_MASK         2047U
  #define DFIU_TNVHL_TNVHL_BITNUM       0U
  #define DFIU_TNVHL                    *((volatile word *)0x00000F6E)


  /*** DFIU_TNVH1L - Data Flash Non-Volatile Hold 1 Limit Register; 0x00000F6F ***/
  union {
    word Word;
  } DFIU_TNVH1L_STR;
  
  #define DFIU_TNVH1L_TNVH1L0_MASK      1U
  #define DFIU_TNVH1L_TNVH1L1_MASK      2U
  #define DFIU_TNVH1L_TNVH1L2_MASK      4U
  #define DFIU_TNVH1L_TNVH1L3_MASK      8U
  #define DFIU_TNVH1L_TNVH1L4_MASK      16U
  #define DFIU_TNVH1L_TNVH1L5_MASK      32U
  #define DFIU_TNVH1L_TNVH1L6_MASK      64U
  #define DFIU_TNVH1L_TNVH1L7_MASK      128U
  #define DFIU_TNVH1L_TNVH1L8_MASK      256U
  #define DFIU_TNVH1L_TNVH1L9_MASK      512U
  #define DFIU_TNVH1L_TNVH1L10_MASK     1024U
  #define DFIU_TNVH1L_TNVH1L11_MASK     2048U
  #define DFIU_TNVH1L_TNVH1L12_MASK     4096U
  #define DFIU_TNVH1L_TNVH1L13_MASK     8192U
  #define DFIU_TNVH1L_TNVH1L14_MASK     16384U
  #define DFIU_TNVH1L_TNVH1L_MASK       32767U
  #define DFIU_TNVH1L_TNVH1L_BITNUM     0U
  #define DFIU_TNVH1L                   *((volatile word *)0x00000F6F)


  /*** DFIU_TRCVL - Data Flash Recovery Limit Register; 0x00000F70 ***/
  union {
    word Word;
  } DFIU_TRCVL_STR;
  
  #define DFIU_TRCVL_TRCVL0_MASK        1U
  #define DFIU_TRCVL_TRCVL1_MASK        2U
  #define DFIU_TRCVL_TRCVL2_MASK        4U
  #define DFIU_TRCVL_TRCVL3_MASK        8U
  #define DFIU_TRCVL_TRCVL4_MASK        16U
  #define DFIU_TRCVL_TRCVL5_MASK        32U
  #define DFIU_TRCVL_TRCVL6_MASK        64U
  #define DFIU_TRCVL_TRCVL7_MASK        128U
  #define DFIU_TRCVL_TRCVL8_MASK        256U
  #define DFIU_TRCVL_TRCVL_MASK         511U
  #define DFIU_TRCVL_TRCVL_BITNUM       0U
  #define DFIU_TRCVL                    *((volatile word *)0x00000F70)


  word Reserved0[15];                  /* Reserved (unused) registers */

} DFIU_PRPH;

/******************************************
*** Peripheral BFIU
*******************************************/
typedef volatile struct {
  /*** BFIU_CNTL - Boot Flash Control Register; 0x00000F80 ***/
  union {
    word Word;
  } BFIU_CNTL_STR;
  
  #define BFIU_CNTL_NVSTR_MASK          1U
  #define BFIU_CNTL_MAS1_MASK           2U
  #define BFIU_CNTL_ERASE_MASK          4U
  #define BFIU_CNTL_PROG_MASK           8U
  #define BFIU_CNTL_YE_MASK             16U
  #define BFIU_CNTL_XE_MASK             32U
  #define BFIU_CNTL_IFREN_MASK          64U
  #define BFIU_CNTL_BUSY_MASK           32768U
  #define BFIU_CNTL                     *((volatile word *)0x00000F80)


  /*** BFIU_PE - Boot Flash Program Enable Register; 0x00000F81 ***/
  union {
    word Word;
  } BFIU_PE_STR;
  
  #define BFIU_PE_ROW0_MASK             1U
  #define BFIU_PE_ROW1_MASK             2U
  #define BFIU_PE_ROW2_MASK             4U
  #define BFIU_PE_ROW3_MASK             8U
  #define BFIU_PE_ROW4_MASK             16U
  #define BFIU_PE_ROW5_MASK             32U
  #define BFIU_PE_ROW6_MASK             64U
  #define BFIU_PE_ROW7_MASK             128U
  #define BFIU_PE_ROW8_MASK             256U
  #define BFIU_PE_ROW9_MASK             512U
  #define BFIU_PE_IPE_MASK              16384U
  #define BFIU_PE_DPE_MASK              32768U
  #define BFIU_PE_ROW_MASK              1023U
  #define BFIU_PE_ROW_BITNUM            0U
  #define BFIU_PE                       *((volatile word *)0x00000F81)


  /*** BFIU_EE - Boot Flash Erase Enable Register; 0x00000F82 ***/
  union {
    word Word;
  } BFIU_EE_STR;
  
  #define BFIU_EE_PAGE0_MASK            1U
  #define BFIU_EE_PAGE1_MASK            2U
  #define BFIU_EE_PAGE2_MASK            4U
  #define BFIU_EE_PAGE3_MASK            8U
  #define BFIU_EE_PAGE4_MASK            16U
  #define BFIU_EE_PAGE5_MASK            32U
  #define BFIU_EE_PAGE6_MASK            64U
  #define BFIU_EE_IEE_MASK              16384U
  #define BFIU_EE_DEE_MASK              32768U
  #define BFIU_EE_PAGE_MASK             127U
  #define BFIU_EE_PAGE_BITNUM           0U
  #define BFIU_EE                       *((volatile word *)0x00000F82)


  /*** BFIU_ADDR - Boot Flash Address Register; 0x00000F83 ***/
  union {
    word Word;
  } BFIU_ADDR_STR;
  
  #define BFIU_ADDR_A0_MASK             1U
  #define BFIU_ADDR_A1_MASK             2U
  #define BFIU_ADDR_A2_MASK             4U
  #define BFIU_ADDR_A3_MASK             8U
  #define BFIU_ADDR_A4_MASK             16U
  #define BFIU_ADDR_A5_MASK             32U
  #define BFIU_ADDR_A6_MASK             64U
  #define BFIU_ADDR_A7_MASK             128U
  #define BFIU_ADDR_A8_MASK             256U
  #define BFIU_ADDR_A9_MASK             512U
  #define BFIU_ADDR_A10_MASK            1024U
  #define BFIU_ADDR_A11_MASK            2048U
  #define BFIU_ADDR_A12_MASK            4096U
  #define BFIU_ADDR_A13_MASK            8192U
  #define BFIU_ADDR_A14_MASK            16384U
  #define BFIU_ADDR_A15_MASK            32768U
  #define BFIU_ADDR                     *((volatile word *)0x00000F83)


  /*** BFIU_DATA - Boot Flash Data Register; 0x00000F84 ***/
  union {
    word Word;
  } BFIU_DATA_STR;
  
  #define BFIU_DATA_D0_MASK             1U
  #define BFIU_DATA_D1_MASK             2U
  #define BFIU_DATA_D2_MASK             4U
  #define BFIU_DATA_D3_MASK             8U
  #define BFIU_DATA_D4_MASK             16U
  #define BFIU_DATA_D5_MASK             32U
  #define BFIU_DATA_D6_MASK             64U
  #define BFIU_DATA_D7_MASK             128U
  #define BFIU_DATA_D8_MASK             256U
  #define BFIU_DATA_D9_MASK             512U
  #define BFIU_DATA_D10_MASK            1024U
  #define BFIU_DATA_D11_MASK            2048U
  #define BFIU_DATA_D12_MASK            4096U
  #define BFIU_DATA_D13_MASK            8192U
  #define BFIU_DATA_D14_MASK            16384U
  #define BFIU_DATA_D15_MASK            32768U
  #define BFIU_DATA                     *((volatile word *)0x00000F84)


  /*** BFIU_IE - Boot Flash Interrupt Enable Register; 0x00000F85 ***/
  union {
    word Word;
  } BFIU_IE_STR;
  
  #define BFIU_IE_IE0_MASK              1U
  #define BFIU_IE_IE1_MASK              2U
  #define BFIU_IE_IE2_MASK              4U
  #define BFIU_IE_IE3_MASK              8U
  #define BFIU_IE_IE4_MASK              16U
  #define BFIU_IE_IE5_MASK              32U
  #define BFIU_IE_IE6_MASK              64U
  #define BFIU_IE_IE7_MASK              128U
  #define BFIU_IE_IE8_MASK              256U
  #define BFIU_IE_IE9_MASK              512U
  #define BFIU_IE_IE10_MASK             1024U
  #define BFIU_IE_IE11_MASK             2048U
  #define BFIU_IE_IE_MASK               4095U
  #define BFIU_IE_IE_BITNUM             0U
  #define BFIU_IE                       *((volatile word *)0x00000F85)


  /*** BFIU_IS - Boot Flash Interrupt Source Register; 0x00000F86 ***/
  union {
    word Word;
  } BFIU_IS_STR;
  
  #define BFIU_IS_IS0_MASK              1U
  #define BFIU_IS_IS1_MASK              2U
  #define BFIU_IS_IS2_MASK              4U
  #define BFIU_IS_IS3_MASK              8U
  #define BFIU_IS_IS4_MASK              16U
  #define BFIU_IS_IS5_MASK              32U
  #define BFIU_IS_IS6_MASK              64U
  #define BFIU_IS_IS7_MASK              128U
  #define BFIU_IS_IS8_MASK              256U
  #define BFIU_IS_IS9_MASK              512U
  #define BFIU_IS_IS10_MASK             1024U
  #define BFIU_IS_IS11_MASK             2048U
  #define BFIU_IS_IS_MASK               4095U
  #define BFIU_IS_IS_BITNUM             0U
  #define BFIU_IS                       *((volatile word *)0x00000F86)


  /*** BFIU_IP - Boot Flash Interrupt Pending Register; 0x00000F87 ***/
  union {
    word Word;
  } BFIU_IP_STR;
  
  #define BFIU_IP_IP0_MASK              1U
  #define BFIU_IP_IP1_MASK              2U
  #define BFIU_IP_IP2_MASK              4U
  #define BFIU_IP_IP3_MASK              8U
  #define BFIU_IP_IP4_MASK              16U
  #define BFIU_IP_IP5_MASK              32U
  #define BFIU_IP_IP6_MASK              64U
  #define BFIU_IP_IP7_MASK              128U
  #define BFIU_IP_IP8_MASK              256U
  #define BFIU_IP_IP9_MASK              512U
  #define BFIU_IP_IP10_MASK             1024U
  #define BFIU_IP_IP11_MASK             2048U
  #define BFIU_IP_IP_MASK               4095U
  #define BFIU_IP_IP_BITNUM             0U
  #define BFIU_IP                       *((volatile word *)0x00000F87)


  /*** BFIU_CKDIVISOR - Boot Flash Clock Divisor Register; 0x00000F88 ***/
  union {
    word Word;
  } BFIU_CKDIVISOR_STR;
  
  #define BFIU_CKDIVISOR_N0_MASK        1U
  #define BFIU_CKDIVISOR_N1_MASK        2U
  #define BFIU_CKDIVISOR_N2_MASK        4U
  #define BFIU_CKDIVISOR_N3_MASK        8U
  #define BFIU_CKDIVISOR_N_MASK         15U
  #define BFIU_CKDIVISOR_N_BITNUM       0U
  #define BFIU_CKDIVISOR                *((volatile word *)0x00000F88)


  /*** BFIU_TERASEL - Boot Flash Erase Time Limit Register; 0x00000F89 ***/
  union {
    word Word;
  } BFIU_TERASEL_STR;
  
  #define BFIU_TERASEL_TERASEL0_MASK    1U
  #define BFIU_TERASEL_TERASEL1_MASK    2U
  #define BFIU_TERASEL_TERASEL2_MASK    4U
  #define BFIU_TERASEL_TERASEL3_MASK    8U
  #define BFIU_TERASEL_TERASEL4_MASK    16U
  #define BFIU_TERASEL_TERASEL5_MASK    32U
  #define BFIU_TERASEL_TERASEL6_MASK    64U
  #define BFIU_TERASEL_TERASEL_MASK     127U
  #define BFIU_TERASEL_TERASEL_BITNUM   0U
  #define BFIU_TERASEL                  *((volatile word *)0x00000F89)


  /*** BFIU_TMEL - Boot Flash Mass Erase Time Limit Register; 0x00000F8A ***/
  union {
    word Word;
  } BFIU_TMEL_STR;
  
  #define BFIU_TMEL_TMEL0_MASK          1U
  #define BFIU_TMEL_TMEL1_MASK          2U
  #define BFIU_TMEL_TMEL2_MASK          4U
  #define BFIU_TMEL_TMEL3_MASK          8U
  #define BFIU_TMEL_TMEL4_MASK          16U
  #define BFIU_TMEL_TMEL5_MASK          32U
  #define BFIU_TMEL_TMEL6_MASK          64U
  #define BFIU_TMEL_TMEL7_MASK          128U
  #define BFIU_TMEL_TMEL_MASK           255U
  #define BFIU_TMEL_TMEL_BITNUM         0U
  #define BFIU_TMEL                     *((volatile word *)0x00000F8A)


  /*** BFIU_TNVSL - Boot Flash Non-Volatile Storage Limit Register; 0x00000F8B ***/
  union {
    word Word;
  } BFIU_TNVSL_STR;
  
  #define BFIU_TNVSL_TNVSL0_MASK        1U
  #define BFIU_TNVSL_TNVSL1_MASK        2U
  #define BFIU_TNVSL_TNVSL2_MASK        4U
  #define BFIU_TNVSL_TNVSL3_MASK        8U
  #define BFIU_TNVSL_TNVSL4_MASK        16U
  #define BFIU_TNVSL_TNVSL5_MASK        32U
  #define BFIU_TNVSL_TNVSL6_MASK        64U
  #define BFIU_TNVSL_TNVSL7_MASK        128U
  #define BFIU_TNVSL_TNVSL8_MASK        256U
  #define BFIU_TNVSL_TNVSL9_MASK        512U
  #define BFIU_TNVSL_TNVSL10_MASK       1024U
  #define BFIU_TNVSL_TNVSL_MASK         2047U
  #define BFIU_TNVSL_TNVSL_BITNUM       0U
  #define BFIU_TNVSL                    *((volatile word *)0x00000F8B)


  /*** BFIU_TPGSL - Boot Flash Program Setup Limit Register; 0x00000F8C ***/
  union {
    word Word;
  } BFIU_TPGSL_STR;
  
  #define BFIU_TPGSL_TPGSL0_MASK        1U
  #define BFIU_TPGSL_TPGSL1_MASK        2U
  #define BFIU_TPGSL_TPGSL2_MASK        4U
  #define BFIU_TPGSL_TPGSL3_MASK        8U
  #define BFIU_TPGSL_TPGSL4_MASK        16U
  #define BFIU_TPGSL_TPGSL5_MASK        32U
  #define BFIU_TPGSL_TPGSL6_MASK        64U
  #define BFIU_TPGSL_TPGSL7_MASK        128U
  #define BFIU_TPGSL_TPGSL8_MASK        256U
  #define BFIU_TPGSL_TPGSL9_MASK        512U
  #define BFIU_TPGSL_TPGSL10_MASK       1024U
  #define BFIU_TPGSL_TPGSL11_MASK       2048U
  #define BFIU_TPGSL_TPGSL_MASK         4095U
  #define BFIU_TPGSL_TPGSL_BITNUM       0U
  #define BFIU_TPGSL                    *((volatile word *)0x00000F8C)


  /*** BFIU_TPROGL - Boot Flash Program Limit Register; 0x00000F8D ***/
  union {
    word Word;
  } BFIU_TPROGL_STR;
  
  #define BFIU_TPROGL_TPROGL0_MASK      1U
  #define BFIU_TPROGL_TPROGL1_MASK      2U
  #define BFIU_TPROGL_TPROGL2_MASK      4U
  #define BFIU_TPROGL_TPROGL3_MASK      8U
  #define BFIU_TPROGL_TPROGL4_MASK      16U
  #define BFIU_TPROGL_TPROGL5_MASK      32U
  #define BFIU_TPROGL_TPROGL6_MASK      64U
  #define BFIU_TPROGL_TPROGL7_MASK      128U
  #define BFIU_TPROGL_TPROGL8_MASK      256U
  #define BFIU_TPROGL_TPROGL9_MASK      512U
  #define BFIU_TPROGL_TPROGL10_MASK     1024U
  #define BFIU_TPROGL_TPROGL11_MASK     2048U
  #define BFIU_TPROGL_TPROGL12_MASK     4096U
  #define BFIU_TPROGL_TPROGL13_MASK     8192U
  #define BFIU_TPROGL_TPROGL_MASK       16383U
  #define BFIU_TPROGL_TPROGL_BITNUM     0U
  #define BFIU_TPROGL                   *((volatile word *)0x00000F8D)


  /*** BFIU_TNVHL - Boot Flash Non-Volatile Hold Limit Register; 0x00000F8E ***/
  union {
    word Word;
  } BFIU_TNVHL_STR;
  
  #define BFIU_TNVHL_TNVHL0_MASK        1U
  #define BFIU_TNVHL_TNVHL1_MASK        2U
  #define BFIU_TNVHL_TNVHL2_MASK        4U
  #define BFIU_TNVHL_TNVHL3_MASK        8U
  #define BFIU_TNVHL_TNVHL4_MASK        16U
  #define BFIU_TNVHL_TNVHL5_MASK        32U
  #define BFIU_TNVHL_TNVHL6_MASK        64U
  #define BFIU_TNVHL_TNVHL7_MASK        128U
  #define BFIU_TNVHL_TNVHL8_MASK        256U
  #define BFIU_TNVHL_TNVHL9_MASK        512U
  #define BFIU_TNVHL_TNVHL10_MASK       1024U
  #define BFIU_TNVHL_TNVHL_MASK         2047U
  #define BFIU_TNVHL_TNVHL_BITNUM       0U
  #define BFIU_TNVHL                    *((volatile word *)0x00000F8E)


  /*** BFIU_TNVH1L - Boot Flash Non-Volatile Hold 1 Limit Register; 0x00000F8F ***/
  union {
    word Word;
  } BFIU_TNVH1L_STR;
  
  #define BFIU_TNVH1L_TNVH1L0_MASK      1U
  #define BFIU_TNVH1L_TNVH1L1_MASK      2U
  #define BFIU_TNVH1L_TNVH1L2_MASK      4U
  #define BFIU_TNVH1L_TNVH1L3_MASK      8U
  #define BFIU_TNVH1L_TNVH1L4_MASK      16U
  #define BFIU_TNVH1L_TNVH1L5_MASK      32U
  #define BFIU_TNVH1L_TNVH1L6_MASK      64U
  #define BFIU_TNVH1L_TNVH1L7_MASK      128U
  #define BFIU_TNVH1L_TNVH1L8_MASK      256U
  #define BFIU_TNVH1L_TNVH1L9_MASK      512U
  #define BFIU_TNVH1L_TNVH1L10_MASK     1024U
  #define BFIU_TNVH1L_TNVH1L11_MASK     2048U
  #define BFIU_TNVH1L_TNVH1L12_MASK     4096U
  #define BFIU_TNVH1L_TNVH1L13_MASK     8192U
  #define BFIU_TNVH1L_TNVH1L14_MASK     16384U
  #define BFIU_TNVH1L_TNVH1L_MASK       32767U
  #define BFIU_TNVH1L_TNVH1L_BITNUM     0U
  #define BFIU_TNVH1L                   *((volatile word *)0x00000F8F)


  /*** BFIU_TRCVL - Boot Flash Recovery Limit Register; 0x00000F90 ***/
  union {
    word Word;
  } BFIU_TRCVL_STR;
  
  #define BFIU_TRCVL_TRCVL0_MASK        1U
  #define BFIU_TRCVL_TRCVL1_MASK        2U
  #define BFIU_TRCVL_TRCVL2_MASK        4U
  #define BFIU_TRCVL_TRCVL3_MASK        8U
  #define BFIU_TRCVL_TRCVL4_MASK        16U
  #define BFIU_TRCVL_TRCVL5_MASK        32U
  #define BFIU_TRCVL_TRCVL6_MASK        64U
  #define BFIU_TRCVL_TRCVL7_MASK        128U
  #define BFIU_TRCVL_TRCVL8_MASK        256U
  #define BFIU_TRCVL_TRCVL_MASK         511U
  #define BFIU_TRCVL_TRCVL_BITNUM       0U
  #define BFIU_TRCVL                    *((volatile word *)0x00000F90)


  word Reserved0[15];                  /* Reserved (unused) registers */

} BFIU_PRPH;

/******************************************
*** Peripheral CLKGEN
*******************************************/
typedef volatile struct {
  /*** PLLCR - PLL Control Register; 0x00000FA0 ***/
  union {
    word Word;
  } PLLCR_STR;
  
  #define PLLCR_ZSRC0_MASK              1U
  #define PLLCR_ZSRC1_MASK              2U
  #define PLLCR_PRECS_MASK              4U
  #define PLLCR_PLLPD_MASK              16U
  #define PLLCR_CHPMPTRI_MASK           64U
  #define PLLCR_LCKON_MASK              128U
  #define PLLCR_LOCIE_MASK              2048U
  #define PLLCR_PLLIE00_MASK            4096U
  #define PLLCR_PLLIE01_MASK            8192U
  #define PLLCR_PLLIE10_MASK            16384U
  #define PLLCR_PLLIE11_MASK            32768U
  #define PLLCR_ZSRC_MASK               3U
  #define PLLCR_ZSRC_BITNUM             0U
  #define PLLCR_PLLIE0_MASK             12288U
  #define PLLCR_PLLIE0_BITNUM           12U
  #define PLLCR_PLLIE1_MASK             49152U
  #define PLLCR_PLLIE1_BITNUM           14U
  #define PLLCR                         *((volatile word *)0x00000FA0)


  /*** PLLDB - PLL Divide- by Register; 0x00000FA1 ***/
  union {
    word Word;
  } PLLDB_STR;
  
  #define PLLDB_PLLDB0_MASK             1U
  #define PLLDB_PLLDB1_MASK             2U
  #define PLLDB_PLLDB2_MASK             4U
  #define PLLDB_PLLDB3_MASK             8U
  #define PLLDB_PLLDB4_MASK             16U
  #define PLLDB_PLLDB5_MASK             32U
  #define PLLDB_PLLDB6_MASK             64U
  #define PLLDB_PLLCID0_MASK            256U
  #define PLLDB_PLLCID1_MASK            512U
  #define PLLDB_PLLCOD0_MASK            1024U
  #define PLLDB_PLLCOD1_MASK            2048U
  #define PLLDB_LORTP0_MASK             4096U
  #define PLLDB_LORTP1_MASK             8192U
  #define PLLDB_LORTP2_MASK             16384U
  #define PLLDB_LORTP3_MASK             32768U
  #define PLLDB_PLLDB_MASK              127U
  #define PLLDB_PLLDB_BITNUM            0U
  #define PLLDB_PLLCID_MASK             768U
  #define PLLDB_PLLCID_BITNUM           8U
  #define PLLDB_PLLCOD_MASK             3072U
  #define PLLDB_PLLCOD_BITNUM           10U
  #define PLLDB_LORTP_MASK              61440U
  #define PLLDB_LORTP_BITNUM            12U
  #define PLLDB                         *((volatile word *)0x00000FA1)


  /*** PLLSR - PLL Status Register; 0x00000FA2 ***/
  union {
    word Word;
  } PLLSR_STR;
  
  #define PLLSR_ZSRC0_MASK              1U
  #define PLLSR_ZSRC1_MASK              2U
  #define PLLSR_PRECS_MASK              4U
  #define PLLSR_PLLPDN_MASK             16U
  #define PLLSR_LCK0_MASK               32U
  #define PLLSR_LCK1_MASK               64U
  #define PLLSR_LOCI_MASK               8192U
  #define PLLSR_LOLI0_MASK              16384U
  #define PLLSR_LOLI1_MASK              32768U
  #define PLLSR_ZSRC_MASK               3U
  #define PLLSR_ZSRC_BITNUM             0U
  #define PLLSR_LCK_MASK                96U
  #define PLLSR_LCK_BITNUM              5U
  #define PLLSR_LOLI_MASK               49152U
  #define PLLSR_LOLI_BITNUM             14U
  #define PLLSR                         *((volatile word *)0x00000FA2)


  word Reserved0[1];                   /* Reserved (unused) registers */
  
  /*** CLKOSR - CLKO Select Register; 0x00000FA4 ***/
  union {
    word Word;
  } CLKOSR_STR;
  
  #define CLKOSR_CLKOSEL0_MASK          1U
  #define CLKOSR_CLKOSEL1_MASK          2U
  #define CLKOSR_CLKOSEL2_MASK          4U
  #define CLKOSR_CLKOSEL3_MASK          8U
  #define CLKOSR_CLKOSEL4_MASK          16U
  #define CLKOSR_CLKOSEL_MASK           31U
  #define CLKOSR_CLKOSEL_BITNUM         0U
  #define CLKOSR                        *((volatile word *)0x00000FA4)


  /*** IOSCTL - Internal Oscillator Control Register; 0x00000FA5 ***/
  union {
    word Word;
  } IOSCTL_STR;
  
  #define IOSCTL_TRIM0_MASK             1U
  #define IOSCTL_TRIM1_MASK             2U
  #define IOSCTL_TRIM2_MASK             4U
  #define IOSCTL_TRIM3_MASK             8U
  #define IOSCTL_TRIM4_MASK             16U
  #define IOSCTL_TRIM5_MASK             32U
  #define IOSCTL_TRIM6_MASK             64U
  #define IOSCTL_TRIM7_MASK             128U
  #define IOSCTL_TRIM_MASK              255U
  #define IOSCTL_TRIM_BITNUM            0U
  #define IOSCTL                        *((volatile word *)0x00000FA5)


  word Reserved1[10];                  /* Reserved (unused) registers */

} CLKGEN_PRPH;

/******************************************
*** Peripheral GPIOA
*******************************************/
typedef volatile struct {
  /*** GPIO_A_PUR - GPIO A Pull-up Enable Register; 0x00000FB0 ***/
  union {
    word Word;
  } GPIO_A_PUR_STR;
  
  #define GPIO_A_PUR_PU0_MASK           1U
  #define GPIO_A_PUR_PU1_MASK           2U
  #define GPIO_A_PUR_PU2_MASK           4U
  #define GPIO_A_PUR_PU_MASK            7U
  #define GPIO_A_PUR_PU_BITNUM          0U
  #define GPIO_A_PUR                    *((volatile word *)0x00000FB0)


  /*** GPIO_A_DR - GPIO A Data Register; 0x00000FB1 ***/
  union {
    word Word;
  } GPIO_A_DR_STR;
  
  #define GPIO_A_DR_D0_MASK             1U
  #define GPIO_A_DR_D1_MASK             2U
  #define GPIO_A_DR_D2_MASK             4U
  #define GPIO_A_DR_D_MASK              7U
  #define GPIO_A_DR_D_BITNUM            0U
  #define GPIO_A_DR                     *((volatile word *)0x00000FB1)


  /*** GPIO_A_DDR - GPIO A Data Direction Register; 0x00000FB2 ***/
  union {
    word Word;
  } GPIO_A_DDR_STR;
  
  #define GPIO_A_DDR_DD0_MASK           1U
  #define GPIO_A_DDR_DD1_MASK           2U
  #define GPIO_A_DDR_DD2_MASK           4U
  #define GPIO_A_DDR_DD_MASK            7U
  #define GPIO_A_DDR_DD_BITNUM          0U
  #define GPIO_A_DDR                    *((volatile word *)0x00000FB2)


  /*** GPIO_A_PER - GPIO A Peripheral Enable Registers; 0x00000FB3 ***/
  union {
    word Word;
  } GPIO_A_PER_STR;
  
  #define GPIO_A_PER_PE0_MASK           1U
  #define GPIO_A_PER_PE1_MASK           2U
  #define GPIO_A_PER_PE2_MASK           4U
  #define GPIO_A_PER_PE_MASK            7U
  #define GPIO_A_PER_PE_BITNUM          0U
  #define GPIO_A_PER                    *((volatile word *)0x00000FB3)


  /*** GPIO_A_IAR - GPIO A Interrupt Assert Register; 0x00000FB4 ***/
  union {
    word Word;
  } GPIO_A_IAR_STR;
  
  #define GPIO_A_IAR_IA0_MASK           1U
  #define GPIO_A_IAR_IA1_MASK           2U
  #define GPIO_A_IAR_IA2_MASK           4U
  #define GPIO_A_IAR_IA_MASK            7U
  #define GPIO_A_IAR_IA_BITNUM          0U
  #define GPIO_A_IAR                    *((volatile word *)0x00000FB4)


  /*** GPIO_A_IENR - GPIO A Interrupt Enable Register; 0x00000FB5 ***/
  union {
    word Word;
  } GPIO_A_IENR_STR;
  
  #define GPIO_A_IENR_IEN0_MASK         1U
  #define GPIO_A_IENR_IEN1_MASK         2U
  #define GPIO_A_IENR_IEN2_MASK         4U
  #define GPIO_A_IENR_IEN_MASK          7U
  #define GPIO_A_IENR_IEN_BITNUM        0U
  #define GPIO_A_IENR                   *((volatile word *)0x00000FB5)


  /*** GPIO_A_IPOLR - GPIO A Interrupt Polarity Register; 0x00000FB6 ***/
  union {
    word Word;
  } GPIO_A_IPOLR_STR;
  
  #define GPIO_A_IPOLR_IPOL0_MASK       1U
  #define GPIO_A_IPOLR_IPOL1_MASK       2U
  #define GPIO_A_IPOLR_IPOL2_MASK       4U
  #define GPIO_A_IPOLR_IPOL_MASK        7U
  #define GPIO_A_IPOLR_IPOL_BITNUM      0U
  #define GPIO_A_IPOLR                  *((volatile word *)0x00000FB6)


  /*** GPIO_A_IPR - GPIO A Interrupt Pending Register; 0x00000FB7 ***/
  union {
    word Word;
  } GPIO_A_IPR_STR;
  
  #define GPIO_A_IPR_IP0_MASK           1U
  #define GPIO_A_IPR_IP1_MASK           2U
  #define GPIO_A_IPR_IP2_MASK           4U
  #define GPIO_A_IPR_IP_MASK            7U
  #define GPIO_A_IPR_IP_BITNUM          0U
  #define GPIO_A_IPR                    *((volatile word *)0x00000FB7)


  /*** GPIO_A_IESR - GPIO A Interrupt Edge Sensitive Register; 0x00000FB8 ***/
  union {
    word Word;
  } GPIO_A_IESR_STR;
  
  #define GPIO_A_IESR_IES0_MASK         1U
  #define GPIO_A_IESR_IES1_MASK         2U
  #define GPIO_A_IESR_IES2_MASK         4U
  #define GPIO_A_IESR_IES_MASK          7U
  #define GPIO_A_IESR_IES_BITNUM        0U
  #define GPIO_A_IESR                   *((volatile word *)0x00000FB8)


  word Reserved0[7];                   /* Reserved (unused) registers */

} GPIOA_PRPH;

/******************************************
*** Peripheral GPIOB
*******************************************/
typedef volatile struct {
  /*** GPIO_B_PUR - GPIO B Pull-up Enable Register; 0x00000FC0 ***/
  union {
    word Word;
  } GPIO_B_PUR_STR;
  
  #define GPIO_B_PUR_PU0_MASK           1U
  #define GPIO_B_PUR_PU1_MASK           2U
  #define GPIO_B_PUR_PU2_MASK           4U
  #define GPIO_B_PUR_PU3_MASK           8U
  #define GPIO_B_PUR_PU4_MASK           16U
  #define GPIO_B_PUR_PU5_MASK           32U
  #define GPIO_B_PUR_PU6_MASK           64U
  #define GPIO_B_PUR_PU7_MASK           128U
  #define GPIO_B_PUR_PU_MASK            255U
  #define GPIO_B_PUR_PU_BITNUM          0U
  #define GPIO_B_PUR                    *((volatile word *)0x00000FC0)


  /*** GPIO_B_DR - GPIO B Data Register; 0x00000FC1 ***/
  union {
    word Word;
  } GPIO_B_DR_STR;
  
  #define GPIO_B_DR_D0_MASK             1U
  #define GPIO_B_DR_D1_MASK             2U
  #define GPIO_B_DR_D2_MASK             4U
  #define GPIO_B_DR_D3_MASK             8U
  #define GPIO_B_DR_D4_MASK             16U
  #define GPIO_B_DR_D5_MASK             32U
  #define GPIO_B_DR_D6_MASK             64U
  #define GPIO_B_DR_D7_MASK             128U
  #define GPIO_B_DR_D_MASK              255U
  #define GPIO_B_DR_D_BITNUM            0U
  #define GPIO_B_DR                     *((volatile word *)0x00000FC1)


  /*** GPIO_B_DDR - GPIO B Data Direction Register; 0x00000FC2 ***/
  union {
    word Word;
  } GPIO_B_DDR_STR;
  
  #define GPIO_B_DDR_DD0_MASK           1U
  #define GPIO_B_DDR_DD1_MASK           2U
  #define GPIO_B_DDR_DD2_MASK           4U
  #define GPIO_B_DDR_DD3_MASK           8U
  #define GPIO_B_DDR_DD4_MASK           16U
  #define GPIO_B_DDR_DD5_MASK           32U
  #define GPIO_B_DDR_DD6_MASK           64U
  #define GPIO_B_DDR_DD7_MASK           128U
  #define GPIO_B_DDR_DD_MASK            255U
  #define GPIO_B_DDR_DD_BITNUM          0U
  #define GPIO_B_DDR                    *((volatile word *)0x00000FC2)


  /*** GPIO_B_PER - GPIO B Peripheral Enable Registers; 0x00000FC3 ***/
  union {
    word Word;
  } GPIO_B_PER_STR;
  
  #define GPIO_B_PER_PE0_MASK           1U
  #define GPIO_B_PER_PE1_MASK           2U
  #define GPIO_B_PER_PE2_MASK           4U
  #define GPIO_B_PER_PE3_MASK           8U
  #define GPIO_B_PER_PE4_MASK           16U
  #define GPIO_B_PER_PE5_MASK           32U
  #define GPIO_B_PER_PE6_MASK           64U
  #define GPIO_B_PER_PE7_MASK           128U
  #define GPIO_B_PER_PE_MASK            255U
  #define GPIO_B_PER_PE_BITNUM          0U
  #define GPIO_B_PER                    *((volatile word *)0x00000FC3)


  /*** GPIO_B_IAR - GPIO B Interrupt Assert Register; 0x00000FC4 ***/
  union {
    word Word;
  } GPIO_B_IAR_STR;
  
  #define GPIO_B_IAR_IA0_MASK           1U
  #define GPIO_B_IAR_IA1_MASK           2U
  #define GPIO_B_IAR_IA2_MASK           4U
  #define GPIO_B_IAR_IA3_MASK           8U
  #define GPIO_B_IAR_IA4_MASK           16U
  #define GPIO_B_IAR_IA5_MASK           32U
  #define GPIO_B_IAR_IA6_MASK           64U
  #define GPIO_B_IAR_IA7_MASK           128U
  #define GPIO_B_IAR_IA_MASK            255U
  #define GPIO_B_IAR_IA_BITNUM          0U
  #define GPIO_B_IAR                    *((volatile word *)0x00000FC4)


  /*** GPIO_B_IENR - GPIO B Interrupt Enable Register; 0x00000FC5 ***/
  union {
    word Word;
  } GPIO_B_IENR_STR;
  
  #define GPIO_B_IENR_IEN0_MASK         1U
  #define GPIO_B_IENR_IEN1_MASK         2U
  #define GPIO_B_IENR_IEN2_MASK         4U
  #define GPIO_B_IENR_IEN3_MASK         8U
  #define GPIO_B_IENR_IEN4_MASK         16U
  #define GPIO_B_IENR_IEN5_MASK         32U
  #define GPIO_B_IENR_IEN6_MASK         64U
  #define GPIO_B_IENR_IEN7_MASK         128U
  #define GPIO_B_IENR_IEN_MASK          255U
  #define GPIO_B_IENR_IEN_BITNUM        0U
  #define GPIO_B_IENR                   *((volatile word *)0x00000FC5)


  /*** GPIO_B_IPOLR - GPIO B Interrupt Polarity Register; 0x00000FC6 ***/
  union {
    word Word;
  } GPIO_B_IPOLR_STR;
  
  #define GPIO_B_IPOLR_IPOL0_MASK       1U
  #define GPIO_B_IPOLR_IPOL1_MASK       2U
  #define GPIO_B_IPOLR_IPOL2_MASK       4U
  #define GPIO_B_IPOLR_IPOL3_MASK       8U
  #define GPIO_B_IPOLR_IPOL4_MASK       16U
  #define GPIO_B_IPOLR_IPOL5_MASK       32U
  #define GPIO_B_IPOLR_IPOL6_MASK       64U
  #define GPIO_B_IPOLR_IPOL7_MASK       128U
  #define GPIO_B_IPOLR_IPOL_MASK        255U
  #define GPIO_B_IPOLR_IPOL_BITNUM      0U
  #define GPIO_B_IPOLR                  *((volatile word *)0x00000FC6)


  /*** GPIO_B_IPR - GPIO B Interrupt Pending Register; 0x00000FC7 ***/
  union {
    word Word;
  } GPIO_B_IPR_STR;
  
  #define GPIO_B_IPR_IP0_MASK           1U
  #define GPIO_B_IPR_IP1_MASK           2U
  #define GPIO_B_IPR_IP2_MASK           4U
  #define GPIO_B_IPR_IP3_MASK           8U
  #define GPIO_B_IPR_IP4_MASK           16U
  #define GPIO_B_IPR_IP5_MASK           32U
  #define GPIO_B_IPR_IP6_MASK           64U
  #define GPIO_B_IPR_IP7_MASK           128U
  #define GPIO_B_IPR_IP_MASK            255U
  #define GPIO_B_IPR_IP_BITNUM          0U
  #define GPIO_B_IPR                    *((volatile word *)0x00000FC7)


  /*** GPIO_B_IESR - GPIO B Interrupt Edge Sensitive Register; 0x00000FC8 ***/
  union {
    word Word;
  } GPIO_B_IESR_STR;
  
  #define GPIO_B_IESR_IES0_MASK         1U
  #define GPIO_B_IESR_IES1_MASK         2U
  #define GPIO_B_IESR_IES2_MASK         4U
  #define GPIO_B_IESR_IES3_MASK         8U
  #define GPIO_B_IESR_IES4_MASK         16U
  #define GPIO_B_IESR_IES5_MASK         32U
  #define GPIO_B_IESR_IES6_MASK         64U
  #define GPIO_B_IESR_IES7_MASK         128U
  #define GPIO_B_IESR_IES_MASK          255U
  #define GPIO_B_IESR_IES_BITNUM        0U
  #define GPIO_B_IESR                   *((volatile word *)0x00000FC8)


  word Reserved0[61367];               /* Reserved (unused) registers */

} GPIOB_PRPH;

/******************************************
*** Peripheral Core
*******************************************/
typedef volatile struct {
  /*** CORE0 - Core configuration register 0; 0x0000FF80 ***/
  union {
    word Word;
  } CORE0_STR;
  
  #define CORE0_CORE00_MASK             1U
  #define CORE0_CORE01_MASK             2U
  #define CORE0_CORE02_MASK             4U
  #define CORE0_CORE03_MASK             8U
  #define CORE0_CORE04_MASK             16U
  #define CORE0_CORE05_MASK             32U
  #define CORE0_CORE06_MASK             64U
  #define CORE0_CORE07_MASK             128U
  #define CORE0_CORE08_MASK             256U
  #define CORE0_CORE09_MASK             512U
  #define CORE0_CORE010_MASK            1024U
  #define CORE0_CORE011_MASK            2048U
  #define CORE0_CORE012_MASK            4096U
  #define CORE0_CORE013_MASK            8192U
  #define CORE0_CORE014_MASK            16384U
  #define CORE0_CORE015_MASK            32768U
  #define CORE0                         *((volatile word *)0x0000FF80)


  word Reserved0[120];                 /* Reserved (unused) registers */
  
  /*** BCR - Bus Control Register; 0x0000FFF9 ***/
  union {
    word Word;
  } BCR_STR;
  
  #define BCR_WSP0_MASK                 1U
  #define BCR_WSP1_MASK                 2U
  #define BCR_WSP2_MASK                 4U
  #define BCR_WSP3_MASK                 8U
  #define BCR_WSX0_MASK                 16U
  #define BCR_WSX1_MASK                 32U
  #define BCR_WSX2_MASK                 64U
  #define BCR_WSX3_MASK                 128U
  #define BCR_DRV_MASK                  512U
  #define BCR_WSP_MASK                  15U
  #define BCR_WSP_BITNUM                0U
  #define BCR_WSX_MASK                  240U
  #define BCR_WSX_BITNUM                4U
  #define BCR                           *((volatile word *)0x0000FFF9)


  word Reserved1[1];                   /* Reserved (unused) registers */
  
  /*** IPR - Interrupt Priority Register; 0x0000FFFB ***/
  union {
    word Word;
  } IPR_STR;
  
  #define IPR_IAINV_MASK                1U
  #define IPR_IAL0_MASK                 2U
  #define IPR_IAL1_MASK                 4U
  #define IPR_IBINV_MASK                8U
  #define IPR_IBL0_MASK                 16U
  #define IPR_IBL1_MASK                 32U
  #define IPR_CH6_MASK                  512U
  #define IPR_CH5_MASK                  1024U
  #define IPR_CH4_MASK                  2048U
  #define IPR_CH3_MASK                  4096U
  #define IPR_CH2_MASK                  8192U
  #define IPR_CH1_MASK                  16384U
  #define IPR_CH0_MASK                  32768U
  #define IPR_IAL_MASK                  6U
  #define IPR_IAL_BITNUM                1U
  #define IPR_IBL_MASK                  48U
  #define IPR_IBL_BITNUM                4U
  #define IPR                           *((volatile word *)0x0000FFFB)


} Core_PRPH;




#endif
/* __IO_Map_H */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98.03 [03.79]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
